/**
 * 
 * SOME COPYRIGHT
 * 
 * Domain.hpp
 * 
 * generated Domain.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_DCI_DOMAIN_HPP
#define GI_DCI_DOMAIN_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(dci/DomainToGbpRoutingDomainRSrc)
 */
#include "modelgbp/dci/DomainToGbpRoutingDomainRSrc.hpp"

namespace modelgbp {
namespace dci {

class Domain
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for Domain
     */
    static const opflex::modb::class_id_t CLASS_ID = 87;

    /**
     * Check whether name has been set
     * @return true if name has been set
     */
    bool isNameSet()
    {
        return getObjectInstance().isSet(2850817ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of name if it has been set.
     * @return the value of name or boost::none if not set
     */
    boost::optional<const std::string&> getName()
    {
        if (isNameSet())
            return getObjectInstance().getString(2850817ul);
        return boost::none;
    }

    /**
     * Get the value of name if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of name if set, otherwise the value of default passed in
     */
    const std::string& getName(const std::string& defaultValue)
    {
        return getName().get_value_or(defaultValue);
    }

    /**
     * Set name to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::dci::Domain& setName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(2850817ul, newValue);
        return *this;
    }

    /**
     * Unset name in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::dci::Domain& unsetName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(2850817ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of Domain from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::dci::Domain> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::dci::Domain>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of Domain from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::dci::Domain> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::dci::Domain>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of Domain from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /DciUniverse/DciDomain/[dciDomainName]
     * 
     * @param framework the framework instance to use 
     * @param dciDomainName the value of dciDomainName,
     * a naming property for Domain
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::dci::Domain> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& dciDomainName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("DciUniverse").addElement("DciDomain").addElement(dciDomainName).build());
    }

    /**
     * Retrieve an instance of Domain from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /DciUniverse/DciDomain/[dciDomainName]
     * 
     * @param dciDomainName the value of dciDomainName,
     * a naming property for Domain
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::dci::Domain> > resolve(
        const std::string& dciDomainName)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),dciDomainName);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param dciDomainToGbpRoutingDomainRSrcTargetClass the value of dciDomainToGbpRoutingDomainRSrcTargetClass,
     * a naming property for DomainToGbpRoutingDomainRSrc
     * @param dciDomainToGbpRoutingDomainRSrcTargetName the value of dciDomainToGbpRoutingDomainRSrcTargetName,
     * a naming property for DomainToGbpRoutingDomainRSrc
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::dci::DomainToGbpRoutingDomainRSrc> > resolveDciDomainToGbpRoutingDomainRSrc(
        const std::string& dciDomainToGbpRoutingDomainRSrcTargetName)
    {
        opflex::modb::class_id_t dciDomainToGbpRoutingDomainRSrcTargetClass = 190;
        return modelgbp::dci::DomainToGbpRoutingDomainRSrc::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("DciDomainToGbpRoutingDomainRSrc").addElement(dciDomainToGbpRoutingDomainRSrcTargetClass).addElement(dciDomainToGbpRoutingDomainRSrcTargetName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param dciDomainToGbpRoutingDomainRSrcTargetClass the value of dciDomainToGbpRoutingDomainRSrcTargetClass,
     * a naming property for DomainToGbpRoutingDomainRSrc
     * @param dciDomainToGbpRoutingDomainRSrcTargetName the value of dciDomainToGbpRoutingDomainRSrcTargetName,
     * a naming property for DomainToGbpRoutingDomainRSrc
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::dci::DomainToGbpRoutingDomainRSrc> addDciDomainToGbpRoutingDomainRSrc(
        const std::string& dciDomainToGbpRoutingDomainRSrcTargetName)
    {
        opflex::modb::class_id_t dciDomainToGbpRoutingDomainRSrcTargetClass = 190;
        OF_SHARED_PTR<modelgbp::dci::DomainToGbpRoutingDomainRSrc> result = addChild<modelgbp::dci::DomainToGbpRoutingDomainRSrc>(
            CLASS_ID, getURI(), 2150334552ul, 88,
            opflex::modb::URIBuilder(getURI()).addElement("DciDomainToGbpRoutingDomainRSrc").addElement(dciDomainToGbpRoutingDomainRSrcTargetClass).addElement(dciDomainToGbpRoutingDomainRSrcTargetName).build()
            );
        result->setTargetRoutingDomain(opflex::modb::URI(dciDomainToGbpRoutingDomainRSrcTargetName));
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::dci::DomainToGbpRoutingDomainRSrc
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveDciDomainToGbpRoutingDomainRSrc(/* out */ std::vector<OF_SHARED_PTR<modelgbp::dci::DomainToGbpRoutingDomainRSrc> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::dci::DomainToGbpRoutingDomainRSrc>(
            getFramework(), CLASS_ID, getURI(), 2150334552ul, 88, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the Domain object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the Domain object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the Domain object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /DciUniverse/DciDomain/[dciDomainName]
     * 
     * @param framework the framework instance to use
     * @param dciDomainName the value of dciDomainName,
     * a naming property for Domain
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& dciDomainName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("DciUniverse").addElement("DciDomain").addElement(dciDomainName).build());
    }

    /**
     * Remove the Domain object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /DciUniverse/DciDomain/[dciDomainName]
     * 
     * @param dciDomainName the value of dciDomainName,
     * a naming property for Domain
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& dciDomainName)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),dciDomainName);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of Domain.
     * This should not typically be called from user code.
     */
    Domain(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class Domain

} // namespace dci
} // namespace modelgbp
#endif // GI_DCI_DOMAIN_HPP
