/**
 * 
 * SOME COPYRIGHT
 * 
 * RouteTargetDef.hpp
 * 
 * generated RouteTargetDef.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_DCI_ROUTETARGETDEF_HPP
#define GI_DCI_ROUTETARGETDEF_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"

namespace modelgbp {
namespace dci {

class RouteTargetDef
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for RouteTargetDef
     */
    static const opflex::modb::class_id_t CLASS_ID = 92;

    /**
     * Check whether name has been set
     * @return true if name has been set
     */
    bool isNameSet()
    {
        return getObjectInstance().isSet(3014657ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of name if it has been set.
     * @return the value of name or boost::none if not set
     */
    boost::optional<const std::string&> getName()
    {
        if (isNameSet())
            return getObjectInstance().getString(3014657ul);
        return boost::none;
    }

    /**
     * Get the value of name if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of name if set, otherwise the value of default passed in
     */
    const std::string& getName(const std::string& defaultValue)
    {
        return getName().get_value_or(defaultValue);
    }

    /**
     * Set name to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::dci::RouteTargetDef& setName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(3014657ul, newValue);
        return *this;
    }

    /**
     * Unset name in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::dci::RouteTargetDef& unsetName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3014657ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether rtAS has been set
     * @return true if rtAS has been set
     */
    bool isRtASSet()
    {
        return getObjectInstance().isSet(3014660ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of rtAS if it has been set.
     * @return the value of rtAS or boost::none if not set
     */
    boost::optional<uint32_t> getRtAS()
    {
        if (isRtASSet())
            return (uint32_t)getObjectInstance().getUInt64(3014660ul);
        return boost::none;
    }

    /**
     * Get the value of rtAS if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of rtAS if set, otherwise the value of default passed in
     */
    uint32_t getRtAS(uint32_t defaultValue)
    {
        return getRtAS().get_value_or(defaultValue);
    }

    /**
     * Set rtAS to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::dci::RouteTargetDef& setRtAS(uint32_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(3014660ul, newValue);
        return *this;
    }

    /**
     * Unset rtAS in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::dci::RouteTargetDef& unsetRtAS()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3014660ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether rtIP has been set
     * @return true if rtIP has been set
     */
    bool isRtIPSet()
    {
        return getObjectInstance().isSet(3014661ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of rtIP if it has been set.
     * @return the value of rtIP or boost::none if not set
     */
    boost::optional<const std::string&> getRtIP()
    {
        if (isRtIPSet())
            return getObjectInstance().getString(3014661ul);
        return boost::none;
    }

    /**
     * Get the value of rtIP if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of rtIP if set, otherwise the value of default passed in
     */
    const std::string& getRtIP(const std::string& defaultValue)
    {
        return getRtIP().get_value_or(defaultValue);
    }

    /**
     * Set rtIP to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::dci::RouteTargetDef& setRtIP(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(3014661ul, newValue);
        return *this;
    }

    /**
     * Unset rtIP in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::dci::RouteTargetDef& unsetRtIP()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3014661ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether rtNN has been set
     * @return true if rtNN has been set
     */
    bool isRtNNSet()
    {
        return getObjectInstance().isSet(3014662ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of rtNN if it has been set.
     * @return the value of rtNN or boost::none if not set
     */
    boost::optional<uint32_t> getRtNN()
    {
        if (isRtNNSet())
            return (uint32_t)getObjectInstance().getUInt64(3014662ul);
        return boost::none;
    }

    /**
     * Get the value of rtNN if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of rtNN if set, otherwise the value of default passed in
     */
    uint32_t getRtNN(uint32_t defaultValue)
    {
        return getRtNN().get_value_or(defaultValue);
    }

    /**
     * Set rtNN to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::dci::RouteTargetDef& setRtNN(uint32_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(3014662ul, newValue);
        return *this;
    }

    /**
     * Unset rtNN in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::dci::RouteTargetDef& unsetRtNN()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3014662ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether targetAf has been set
     * @return true if targetAf has been set
     */
    bool isTargetAfSet()
    {
        return getObjectInstance().isSet(3014658ul, opflex::modb::PropertyInfo::ENUM8);
    }

    /**
     * Get the value of targetAf if it has been set.
     * @return the value of targetAf or boost::none if not set
     */
    boost::optional<const uint8_t> getTargetAf()
    {
        if (isTargetAfSet())
            return (const uint8_t)getObjectInstance().getUInt64(3014658ul);
        return boost::none;
    }

    /**
     * Get the value of targetAf if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of targetAf if set, otherwise the value of default passed in
     */
    const uint8_t getTargetAf(const uint8_t defaultValue)
    {
        return getTargetAf().get_value_or(defaultValue);
    }

    /**
     * Set targetAf to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::dci::RouteTargetDef& setTargetAf(const uint8_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(3014658ul, newValue);
        return *this;
    }

    /**
     * Unset targetAf in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::dci::RouteTargetDef& unsetTargetAf()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3014658ul, opflex::modb::PropertyInfo::ENUM8, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether type has been set
     * @return true if type has been set
     */
    bool isTypeSet()
    {
        return getObjectInstance().isSet(3014659ul, opflex::modb::PropertyInfo::ENUM8);
    }

    /**
     * Get the value of type if it has been set.
     * @return the value of type or boost::none if not set
     */
    boost::optional<const uint8_t> getType()
    {
        if (isTypeSet())
            return (const uint8_t)getObjectInstance().getUInt64(3014659ul);
        return boost::none;
    }

    /**
     * Get the value of type if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of type if set, otherwise the value of default passed in
     */
    const uint8_t getType(const uint8_t defaultValue)
    {
        return getType().get_value_or(defaultValue);
    }

    /**
     * Set type to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::dci::RouteTargetDef& setType(const uint8_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(3014659ul, newValue);
        return *this;
    }

    /**
     * Unset type in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::dci::RouteTargetDef& unsetType()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3014659ul, opflex::modb::PropertyInfo::ENUM8, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of RouteTargetDef from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::dci::RouteTargetDef> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::dci::RouteTargetDef>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of RouteTargetDef from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::dci::RouteTargetDef> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::dci::RouteTargetDef>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of RouteTargetDef from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpRoutingDomain/[gbpRoutingDomainName]/DciRouteTargetPdef/[dciRouteTargetPdefName]/DciRouteTargetDef/[dciRouteTargetDefName]
     * 
     * @param framework the framework instance to use 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpRoutingDomainName the value of gbpRoutingDomainName,
     * a naming property for RoutingDomain
     * @param dciRouteTargetPdefName the value of dciRouteTargetPdefName,
     * a naming property for RouteTargetPdef
     * @param dciRouteTargetDefName the value of dciRouteTargetDefName,
     * a naming property for RouteTargetDef
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::dci::RouteTargetDef> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& policySpaceName,
        const std::string& gbpRoutingDomainName,
        const std::string& dciRouteTargetPdefName,
        const std::string& dciRouteTargetDefName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PolicySpace").addElement(policySpaceName).addElement("GbpRoutingDomain").addElement(gbpRoutingDomainName).addElement("DciRouteTargetPdef").addElement(dciRouteTargetPdefName).addElement("DciRouteTargetDef").addElement(dciRouteTargetDefName).build());
    }

    /**
     * Retrieve an instance of RouteTargetDef from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpRoutingDomain/[gbpRoutingDomainName]/DciRouteTargetPdef/[dciRouteTargetPdefName]/DciRouteTargetDef/[dciRouteTargetDefName]
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpRoutingDomainName the value of gbpRoutingDomainName,
     * a naming property for RoutingDomain
     * @param dciRouteTargetPdefName the value of dciRouteTargetPdefName,
     * a naming property for RouteTargetPdef
     * @param dciRouteTargetDefName the value of dciRouteTargetDefName,
     * a naming property for RouteTargetDef
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::dci::RouteTargetDef> > resolve(
        const std::string& policySpaceName,
        const std::string& gbpRoutingDomainName,
        const std::string& dciRouteTargetPdefName,
        const std::string& dciRouteTargetDefName)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),policySpaceName,gbpRoutingDomainName,dciRouteTargetPdefName,dciRouteTargetDefName);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the RouteTargetDef object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the RouteTargetDef object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the RouteTargetDef object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpRoutingDomain/[gbpRoutingDomainName]/DciRouteTargetPdef/[dciRouteTargetPdefName]/DciRouteTargetDef/[dciRouteTargetDefName]
     * 
     * @param framework the framework instance to use
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpRoutingDomainName the value of gbpRoutingDomainName,
     * a naming property for RoutingDomain
     * @param dciRouteTargetPdefName the value of dciRouteTargetPdefName,
     * a naming property for RouteTargetPdef
     * @param dciRouteTargetDefName the value of dciRouteTargetDefName,
     * a naming property for RouteTargetDef
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& policySpaceName,
        const std::string& gbpRoutingDomainName,
        const std::string& dciRouteTargetPdefName,
        const std::string& dciRouteTargetDefName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PolicySpace").addElement(policySpaceName).addElement("GbpRoutingDomain").addElement(gbpRoutingDomainName).addElement("DciRouteTargetPdef").addElement(dciRouteTargetPdefName).addElement("DciRouteTargetDef").addElement(dciRouteTargetDefName).build());
    }

    /**
     * Remove the RouteTargetDef object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpRoutingDomain/[gbpRoutingDomainName]/DciRouteTargetPdef/[dciRouteTargetPdefName]/DciRouteTargetDef/[dciRouteTargetDefName]
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpRoutingDomainName the value of gbpRoutingDomainName,
     * a naming property for RoutingDomain
     * @param dciRouteTargetPdefName the value of dciRouteTargetPdefName,
     * a naming property for RouteTargetPdef
     * @param dciRouteTargetDefName the value of dciRouteTargetDefName,
     * a naming property for RouteTargetDef
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& policySpaceName,
        const std::string& gbpRoutingDomainName,
        const std::string& dciRouteTargetPdefName,
        const std::string& dciRouteTargetDefName)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),policySpaceName,gbpRoutingDomainName,dciRouteTargetPdefName,dciRouteTargetDefName);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of RouteTargetDef.
     * This should not typically be called from user code.
     */
    RouteTargetDef(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class RouteTargetDef

} // namespace dci
} // namespace modelgbp
#endif // GI_DCI_ROUTETARGETDEF_HPP
