/**
 * 
 * SOME COPYRIGHT
 * 
 * EpCounter.hpp
 * 
 * generated EpCounter.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_DFW_EPCOUNTER_HPP
#define GI_DFW_EPCOUNTER_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"

namespace modelgbp {
namespace dfw {

class EpCounter
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for EpCounter
     */
    static const opflex::modb::class_id_t CLASS_ID = 55;

    /**
     * Check whether rxDrop has been set
     * @return true if rxDrop has been set
     */
    bool isRxDropSet()
    {
        return getObjectInstance().isSet(1802242ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of rxDrop if it has been set.
     * @return the value of rxDrop or boost::none if not set
     */
    boost::optional<uint64_t> getRxDrop()
    {
        if (isRxDropSet())
            return getObjectInstance().getUInt64(1802242ul);
        return boost::none;
    }

    /**
     * Get the value of rxDrop if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of rxDrop if set, otherwise the value of default passed in
     */
    uint64_t getRxDrop(uint64_t defaultValue)
    {
        return getRxDrop().get_value_or(defaultValue);
    }

    /**
     * Set rxDrop to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::dfw::EpCounter& setRxDrop(uint64_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1802242ul, newValue);
        return *this;
    }

    /**
     * Unset rxDrop in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::dfw::EpCounter& unsetRxDrop()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1802242ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether txDrop has been set
     * @return true if txDrop has been set
     */
    bool isTxDropSet()
    {
        return getObjectInstance().isSet(1802243ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of txDrop if it has been set.
     * @return the value of txDrop or boost::none if not set
     */
    boost::optional<uint64_t> getTxDrop()
    {
        if (isTxDropSet())
            return getObjectInstance().getUInt64(1802243ul);
        return boost::none;
    }

    /**
     * Get the value of txDrop if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of txDrop if set, otherwise the value of default passed in
     */
    uint64_t getTxDrop(uint64_t defaultValue)
    {
        return getTxDrop().get_value_or(defaultValue);
    }

    /**
     * Set txDrop to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::dfw::EpCounter& setTxDrop(uint64_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1802243ul, newValue);
        return *this;
    }

    /**
     * Unset txDrop in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::dfw::EpCounter& unsetTxDrop()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1802243ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether uuid has been set
     * @return true if uuid has been set
     */
    bool isUuidSet()
    {
        return getObjectInstance().isSet(1802241ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of uuid if it has been set.
     * @return the value of uuid or boost::none if not set
     */
    boost::optional<const std::string&> getUuid()
    {
        if (isUuidSet())
            return getObjectInstance().getString(1802241ul);
        return boost::none;
    }

    /**
     * Get the value of uuid if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of uuid if set, otherwise the value of default passed in
     */
    const std::string& getUuid(const std::string& defaultValue)
    {
        return getUuid().get_value_or(defaultValue);
    }

    /**
     * Set uuid to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::dfw::EpCounter& setUuid(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(1802241ul, newValue);
        return *this;
    }

    /**
     * Unset uuid in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::dfw::EpCounter& unsetUuid()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1802241ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of EpCounter from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::dfw::EpCounter> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::dfw::EpCounter>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of EpCounter from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::dfw::EpCounter> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::dfw::EpCounter>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of EpCounter from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverEpStatUniverse/DfwEpCounter/[dfwEpCounterUuid]
     * 
     * @param framework the framework instance to use 
     * @param dfwEpCounterUuid the value of dfwEpCounterUuid,
     * a naming property for EpCounter
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::dfw::EpCounter> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& dfwEpCounterUuid)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("ObserverEpStatUniverse").addElement("DfwEpCounter").addElement(dfwEpCounterUuid).build());
    }

    /**
     * Retrieve an instance of EpCounter from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverEpStatUniverse/DfwEpCounter/[dfwEpCounterUuid]
     * 
     * @param dfwEpCounterUuid the value of dfwEpCounterUuid,
     * a naming property for EpCounter
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::dfw::EpCounter> > resolve(
        const std::string& dfwEpCounterUuid)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),dfwEpCounterUuid);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the EpCounter object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the EpCounter object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the EpCounter object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverEpStatUniverse/DfwEpCounter/[dfwEpCounterUuid]
     * 
     * @param framework the framework instance to use
     * @param dfwEpCounterUuid the value of dfwEpCounterUuid,
     * a naming property for EpCounter
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& dfwEpCounterUuid)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("ObserverEpStatUniverse").addElement("DfwEpCounter").addElement(dfwEpCounterUuid).build());
    }

    /**
     * Remove the EpCounter object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverEpStatUniverse/DfwEpCounter/[dfwEpCounterUuid]
     * 
     * @param dfwEpCounterUuid the value of dfwEpCounterUuid,
     * a naming property for EpCounter
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& dfwEpCounterUuid)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),dfwEpCounterUuid);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of EpCounter.
     * This should not typically be called from user code.
     */
    EpCounter(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class EpCounter

} // namespace dfw
} // namespace modelgbp
#endif // GI_DFW_EPCOUNTER_HPP
