/**
 * 
 * SOME COPYRIGHT
 * 
 * ConfigToEndpointInventoryRSrc.hpp
 * 
 * generated ConfigToEndpointInventoryRSrc.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_DOMAIN_CONFIGTOENDPOINTINVENTORYRSRC_HPP
#define GI_DOMAIN_CONFIGTOENDPOINTINVENTORYRSRC_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"

namespace modelgbp {
namespace domain {

class ConfigToEndpointInventoryRSrc
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for ConfigToEndpointInventoryRSrc
     */
    static const opflex::modb::class_id_t CLASS_ID = 60;

    /**
     * Check whether role has been set
     * @return true if role has been set
     */
    bool isRoleSet()
    {
        return getObjectInstance().isSet(1966082ul, opflex::modb::PropertyInfo::ENUM8);
    }

    /**
     * Get the value of role if it has been set.
     * @return the value of role or boost::none if not set
     */
    boost::optional<const uint8_t> getRole()
    {
        if (isRoleSet())
            return (const uint8_t)getObjectInstance().getUInt64(1966082ul);
        return boost::none;
    }

    /**
     * Get the value of role if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of role if set, otherwise the value of default passed in
     */
    const uint8_t getRole(const uint8_t defaultValue)
    {
        return getRole().get_value_or(defaultValue);
    }

    /**
     * Set role to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::domain::ConfigToEndpointInventoryRSrc& setRole(const uint8_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1966082ul, newValue);
        return *this;
    }

    /**
     * Unset role in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::domain::ConfigToEndpointInventoryRSrc& unsetRole()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1966082ul, opflex::modb::PropertyInfo::ENUM8, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether target has been set
     * @return true if target has been set
     */
    bool isTargetSet()
    {
        return getObjectInstance().isSet(1966083ul, opflex::modb::PropertyInfo::REFERENCE);
    }

    /**
     * Get the value of targetClass if it has been set.
     * @return the value of targetClass or boost::none if not set
     */
    boost::optional<opflex::modb::class_id_t> getTargetClass()
    {
        if (isTargetSet())
            return getObjectInstance().getReference(1966083ul).first;
        return boost::none;
    }

    /**
     * Get the value of targetURI if it has been set.
     * @return the value of targetURI or boost::none if not set
     */
    boost::optional<opflex::modb::URI> getTargetURI()
    {
        if (isTargetSet())
            return getObjectInstance().getReference(1966083ul).second;
        return boost::none;
    }

    /**
     * Get the value of targetClass if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of targetClass if set, otherwise the value of default passed in
     */
    opflex::modb::class_id_t getTargetClass(opflex::modb::class_id_t defaultValue)
    {
        return getTargetClass().get_value_or(defaultValue);
    }

    /**
     * Get the value of targetURI if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of targetURI if set, otherwise the value of default passed in
     */
    opflex::modb::URI getTargetURI(opflex::modb::URI defaultValue)
    {
        return getTargetURI().get_value_or(defaultValue);
    }

    /**
     * Set the reference to point to an instance of LocalEndpointInventory
     * with the specified URI
     * 
     * @param uri The URI of the reference to add
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::domain::ConfigToEndpointInventoryRSrc& setTargetLocalEndpointInventory(const opflex::modb::URI& uri)
    {
        getTLMutator().modify(getClassId(), getURI())->setReference(1966083ul, 114, uri);
        return *this;
    }

    /**
     * Set the reference to point to an instance of LocalEndpointInventory
     * in the currently-active mutator by constructing its URI from the
     * path elements that lead to it.
     * 
     * The reference URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]
     * 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * 
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::domain::ConfigToEndpointInventoryRSrc& setTargetLocalEndpointInventory(
        const std::string& invLocalEndpointInventoryName)
    {
        getTLMutator().modify(getClassId(), getURI())->setReference(1966083ul, 114, opflex::modb::URIBuilder().addElement("InvUniverse").addElement("InvLocalEndpointInventory").addElement(invLocalEndpointInventoryName).build());
        return *this;
    }

    /**
     * Unset target in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::domain::ConfigToEndpointInventoryRSrc& unsetTarget()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1966083ul, opflex::modb::PropertyInfo::REFERENCE, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether type has been set
     * @return true if type has been set
     */
    bool isTypeSet()
    {
        return getObjectInstance().isSet(1966081ul, opflex::modb::PropertyInfo::ENUM8);
    }

    /**
     * Get the value of type if it has been set.
     * @return the value of type or boost::none if not set
     */
    boost::optional<const uint8_t> getType()
    {
        if (isTypeSet())
            return (const uint8_t)getObjectInstance().getUInt64(1966081ul);
        return boost::none;
    }

    /**
     * Get the value of type if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of type if set, otherwise the value of default passed in
     */
    const uint8_t getType(const uint8_t defaultValue)
    {
        return getType().get_value_or(defaultValue);
    }

    /**
     * Set type to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::domain::ConfigToEndpointInventoryRSrc& setType(const uint8_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1966081ul, newValue);
        return *this;
    }

    /**
     * Unset type in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::domain::ConfigToEndpointInventoryRSrc& unsetType()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1966081ul, opflex::modb::PropertyInfo::ENUM8, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of ConfigToEndpointInventoryRSrc from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::domain::ConfigToEndpointInventoryRSrc> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::domain::ConfigToEndpointInventoryRSrc>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of ConfigToEndpointInventoryRSrc from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::domain::ConfigToEndpointInventoryRSrc> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::domain::ConfigToEndpointInventoryRSrc>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of ConfigToEndpointInventoryRSrc from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /DomainConfig/DomainConfigToEndpointInventoryRSrc/[domainConfigToEndpointInventoryRSrcTargetClass]/[domainConfigToEndpointInventoryRSrcTargetName]
     * 
     * @param framework the framework instance to use 
     * @param domainConfigToEndpointInventoryRSrcTargetClass the value of domainConfigToEndpointInventoryRSrcTargetClass,
     * a naming property for ConfigToEndpointInventoryRSrc
     * @param domainConfigToEndpointInventoryRSrcTargetName the value of domainConfigToEndpointInventoryRSrcTargetName,
     * a naming property for ConfigToEndpointInventoryRSrc
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::domain::ConfigToEndpointInventoryRSrc> > resolve(
        opflex::ofcore::OFFramework& framework,
        uint16_t domainConfigToEndpointInventoryRSrcTargetClass,
        const std::string& domainConfigToEndpointInventoryRSrcTargetName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("DomainConfig").addElement("DomainConfigToEndpointInventoryRSrc").addElement(domainConfigToEndpointInventoryRSrcTargetClass).addElement(domainConfigToEndpointInventoryRSrcTargetName).build());
    }

    /**
     * Retrieve an instance of ConfigToEndpointInventoryRSrc from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /DomainConfig/DomainConfigToEndpointInventoryRSrc/[domainConfigToEndpointInventoryRSrcTargetClass]/[domainConfigToEndpointInventoryRSrcTargetName]
     * 
     * @param domainConfigToEndpointInventoryRSrcTargetClass the value of domainConfigToEndpointInventoryRSrcTargetClass,
     * a naming property for ConfigToEndpointInventoryRSrc
     * @param domainConfigToEndpointInventoryRSrcTargetName the value of domainConfigToEndpointInventoryRSrcTargetName,
     * a naming property for ConfigToEndpointInventoryRSrc
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::domain::ConfigToEndpointInventoryRSrc> > resolve(
        uint16_t domainConfigToEndpointInventoryRSrcTargetClass,
        const std::string& domainConfigToEndpointInventoryRSrcTargetName)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),domainConfigToEndpointInventoryRSrcTargetClass,domainConfigToEndpointInventoryRSrcTargetName);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the ConfigToEndpointInventoryRSrc object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the ConfigToEndpointInventoryRSrc object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the ConfigToEndpointInventoryRSrc object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /DomainConfig/DomainConfigToEndpointInventoryRSrc/[domainConfigToEndpointInventoryRSrcTargetClass]/[domainConfigToEndpointInventoryRSrcTargetName]
     * 
     * @param framework the framework instance to use
     * @param domainConfigToEndpointInventoryRSrcTargetClass the value of domainConfigToEndpointInventoryRSrcTargetClass,
     * a naming property for ConfigToEndpointInventoryRSrc
     * @param domainConfigToEndpointInventoryRSrcTargetName the value of domainConfigToEndpointInventoryRSrcTargetName,
     * a naming property for ConfigToEndpointInventoryRSrc
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        uint16_t domainConfigToEndpointInventoryRSrcTargetClass,
        const std::string& domainConfigToEndpointInventoryRSrcTargetName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("DomainConfig").addElement("DomainConfigToEndpointInventoryRSrc").addElement(domainConfigToEndpointInventoryRSrcTargetClass).addElement(domainConfigToEndpointInventoryRSrcTargetName).build());
    }

    /**
     * Remove the ConfigToEndpointInventoryRSrc object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /DomainConfig/DomainConfigToEndpointInventoryRSrc/[domainConfigToEndpointInventoryRSrcTargetClass]/[domainConfigToEndpointInventoryRSrcTargetName]
     * 
     * @param domainConfigToEndpointInventoryRSrcTargetClass the value of domainConfigToEndpointInventoryRSrcTargetClass,
     * a naming property for ConfigToEndpointInventoryRSrc
     * @param domainConfigToEndpointInventoryRSrcTargetName the value of domainConfigToEndpointInventoryRSrcTargetName,
     * a naming property for ConfigToEndpointInventoryRSrc
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        uint16_t domainConfigToEndpointInventoryRSrcTargetClass,
        const std::string& domainConfigToEndpointInventoryRSrcTargetName)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),domainConfigToEndpointInventoryRSrcTargetClass,domainConfigToEndpointInventoryRSrcTargetName);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of ConfigToEndpointInventoryRSrc.
     * This should not typically be called from user code.
     */
    ConfigToEndpointInventoryRSrc(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class ConfigToEndpointInventoryRSrc

} // namespace domain
} // namespace modelgbp
#endif // GI_DOMAIN_CONFIGTOENDPOINTINVENTORYRSRC_HPP
