/**
 * 
 * SOME COPYRIGHT
 * 
 * L2Ep.hpp
 * 
 * generated L2Ep.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_EPR_L2EP_HPP
#define GI_EPR_L2EP_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(gbpe/ReportedEpAttributeSet)
 */
#include "modelgbp/gbpe/ReportedEpAttributeSet.hpp"
/*
 * contains: item:mclass(gbpe/Attestation)
 */
#include "modelgbp/gbpe/Attestation.hpp"
/*
 * contains: item:mclass(span/LocalEpFromEpRTgt)
 */
#include "modelgbp/span/LocalEpFromEpRTgt.hpp"
/*
 * contains: item:mclass(epr/SecurityGroupContext)
 */
#include "modelgbp/epr/SecurityGroupContext.hpp"
/*
 * contains: item:mclass(epr/L3Net)
 */
#include "modelgbp/epr/L3Net.hpp"

namespace modelgbp {
namespace epr {

class L2Ep
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for L2Ep
     */
    static const opflex::modb::class_id_t CLASS_ID = 99;

    /**
     * Check whether context has been set
     * @return true if context has been set
     */
    bool isContextSet()
    {
        return getObjectInstance().isSet(3244036ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of context if it has been set.
     * @return the value of context or boost::none if not set
     */
    boost::optional<const std::string&> getContext()
    {
        if (isContextSet())
            return getObjectInstance().getString(3244036ul);
        return boost::none;
    }

    /**
     * Get the value of context if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of context if set, otherwise the value of default passed in
     */
    const std::string& getContext(const std::string& defaultValue)
    {
        return getContext().get_value_or(defaultValue);
    }

    /**
     * Set context to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::epr::L2Ep& setContext(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(3244036ul, newValue);
        return *this;
    }

    /**
     * Unset context in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::epr::L2Ep& unsetContext()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3244036ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether group has been set
     * @return true if group has been set
     */
    bool isGroupSet()
    {
        return getObjectInstance().isSet(3244035ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of group if it has been set.
     * @return the value of group or boost::none if not set
     */
    boost::optional<const std::string&> getGroup()
    {
        if (isGroupSet())
            return getObjectInstance().getString(3244035ul);
        return boost::none;
    }

    /**
     * Get the value of group if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of group if set, otherwise the value of default passed in
     */
    const std::string& getGroup(const std::string& defaultValue)
    {
        return getGroup().get_value_or(defaultValue);
    }

    /**
     * Set group to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::epr::L2Ep& setGroup(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(3244035ul, newValue);
        return *this;
    }

    /**
     * Unset group in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::epr::L2Ep& unsetGroup()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3244035ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether interfaceName has been set
     * @return true if interfaceName has been set
     */
    bool isInterfaceNameSet()
    {
        return getObjectInstance().isSet(3244037ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of interfaceName if it has been set.
     * @return the value of interfaceName or boost::none if not set
     */
    boost::optional<const std::string&> getInterfaceName()
    {
        if (isInterfaceNameSet())
            return getObjectInstance().getString(3244037ul);
        return boost::none;
    }

    /**
     * Get the value of interfaceName if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of interfaceName if set, otherwise the value of default passed in
     */
    const std::string& getInterfaceName(const std::string& defaultValue)
    {
        return getInterfaceName().get_value_or(defaultValue);
    }

    /**
     * Set interfaceName to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::epr::L2Ep& setInterfaceName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(3244037ul, newValue);
        return *this;
    }

    /**
     * Unset interfaceName in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::epr::L2Ep& unsetInterfaceName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3244037ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether mac has been set
     * @return true if mac has been set
     */
    bool isMacSet()
    {
        return getObjectInstance().isSet(3244034ul, opflex::modb::PropertyInfo::MAC);
    }

    /**
     * Get the value of mac if it has been set.
     * @return the value of mac or boost::none if not set
     */
    boost::optional<const opflex::modb::MAC&> getMac()
    {
        if (isMacSet())
            return getObjectInstance().getMAC(3244034ul);
        return boost::none;
    }

    /**
     * Get the value of mac if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of mac if set, otherwise the value of default passed in
     */
    const opflex::modb::MAC& getMac(const opflex::modb::MAC& defaultValue)
    {
        return getMac().get_value_or(defaultValue);
    }

    /**
     * Set mac to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::epr::L2Ep& setMac(const opflex::modb::MAC& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setMAC(3244034ul, newValue);
        return *this;
    }

    /**
     * Unset mac in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::epr::L2Ep& unsetMac()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3244034ul, opflex::modb::PropertyInfo::MAC, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether uuid has been set
     * @return true if uuid has been set
     */
    bool isUuidSet()
    {
        return getObjectInstance().isSet(3244033ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of uuid if it has been set.
     * @return the value of uuid or boost::none if not set
     */
    boost::optional<const std::string&> getUuid()
    {
        if (isUuidSet())
            return getObjectInstance().getString(3244033ul);
        return boost::none;
    }

    /**
     * Get the value of uuid if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of uuid if set, otherwise the value of default passed in
     */
    const std::string& getUuid(const std::string& defaultValue)
    {
        return getUuid().get_value_or(defaultValue);
    }

    /**
     * Set uuid to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::epr::L2Ep& setUuid(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(3244033ul, newValue);
        return *this;
    }

    /**
     * Unset uuid in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::epr::L2Ep& unsetUuid()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3244033ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether vmName has been set
     * @return true if vmName has been set
     */
    bool isVmNameSet()
    {
        return getObjectInstance().isSet(3244038ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of vmName if it has been set.
     * @return the value of vmName or boost::none if not set
     */
    boost::optional<const std::string&> getVmName()
    {
        if (isVmNameSet())
            return getObjectInstance().getString(3244038ul);
        return boost::none;
    }

    /**
     * Get the value of vmName if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of vmName if set, otherwise the value of default passed in
     */
    const std::string& getVmName(const std::string& defaultValue)
    {
        return getVmName().get_value_or(defaultValue);
    }

    /**
     * Set vmName to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::epr::L2Ep& setVmName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(3244038ul, newValue);
        return *this;
    }

    /**
     * Unset vmName in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::epr::L2Ep& unsetVmName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3244038ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of L2Ep from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::epr::L2Ep> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::epr::L2Ep>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of L2Ep from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::epr::L2Ep> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::epr::L2Ep>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of L2Ep from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]
     * 
     * @param framework the framework instance to use 
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::epr::L2Ep> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("EprL2Universe").addElement("EprL2Ep").addElement(eprL2EpContext).addElement(eprL2EpMac).build());
    }

    /**
     * Retrieve an instance of L2Ep from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]
     * 
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::epr::L2Ep> > resolve(
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),eprL2EpContext,eprL2EpMac);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::ReportedEpAttributeSet> > resolveGbpeReportedEpAttributeSet(
        )
    {
        return modelgbp::gbpe::ReportedEpAttributeSet::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeReportedEpAttributeSet").build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::ReportedEpAttributeSet> addGbpeReportedEpAttributeSet(
        )
    {
        OF_SHARED_PTR<modelgbp::gbpe::ReportedEpAttributeSet> result = addChild<modelgbp::gbpe::ReportedEpAttributeSet>(
            CLASS_ID, getURI(), 2150727718ul, 38,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeReportedEpAttributeSet").build()
            );
        return result;
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::Attestation> > resolveGbpeAttestation(
        const std::string& gbpeAttestationName)
    {
        return modelgbp::gbpe::Attestation::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeAttestation").addElement(gbpeAttestationName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::Attestation> addGbpeAttestation(
        const std::string& gbpeAttestationName)
    {
        OF_SHARED_PTR<modelgbp::gbpe::Attestation> result = addChild<modelgbp::gbpe::Attestation>(
            CLASS_ID, getURI(), 2150727727ul, 47,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeAttestation").addElement(gbpeAttestationName).build()
            );
        result->setName(gbpeAttestationName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbpe::Attestation
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpeAttestation(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbpe::Attestation> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbpe::Attestation>(
            getFramework(), CLASS_ID, getURI(), 2150727727ul, 47, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param spanLocalEpFromEpRTgtSource the value of spanLocalEpFromEpRTgtSource,
     * a naming property for LocalEpFromEpRTgt
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::span::LocalEpFromEpRTgt> > resolveSpanLocalEpFromEpRTgt(
        const std::string& spanLocalEpFromEpRTgtSource)
    {
        return modelgbp::span::LocalEpFromEpRTgt::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("SpanLocalEpFromEpRTgt").addElement(spanLocalEpFromEpRTgtSource).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param spanLocalEpFromEpRTgtSource the value of spanLocalEpFromEpRTgtSource,
     * a naming property for LocalEpFromEpRTgt
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::span::LocalEpFromEpRTgt> addSpanLocalEpFromEpRTgt(
        const std::string& spanLocalEpFromEpRTgtSource)
    {
        OF_SHARED_PTR<modelgbp::span::LocalEpFromEpRTgt> result = addChild<modelgbp::span::LocalEpFromEpRTgt>(
            CLASS_ID, getURI(), 2150727751ul, 71,
            opflex::modb::URIBuilder(getURI()).addElement("SpanLocalEpFromEpRTgt").addElement(spanLocalEpFromEpRTgtSource).build()
            );
        result->setSource(spanLocalEpFromEpRTgtSource);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::span::LocalEpFromEpRTgt
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveSpanLocalEpFromEpRTgt(/* out */ std::vector<OF_SHARED_PTR<modelgbp::span::LocalEpFromEpRTgt> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::span::LocalEpFromEpRTgt>(
            getFramework(), CLASS_ID, getURI(), 2150727751ul, 71, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param eprSecurityGroupContextSecGroup the value of eprSecurityGroupContextSecGroup,
     * a naming property for SecurityGroupContext
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::epr::SecurityGroupContext> > resolveEprSecurityGroupContext(
        const std::string& eprSecurityGroupContextSecGroup)
    {
        return modelgbp::epr::SecurityGroupContext::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("EprSecurityGroupContext").addElement(eprSecurityGroupContextSecGroup).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param eprSecurityGroupContextSecGroup the value of eprSecurityGroupContextSecGroup,
     * a naming property for SecurityGroupContext
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::epr::SecurityGroupContext> addEprSecurityGroupContext(
        const std::string& eprSecurityGroupContextSecGroup)
    {
        OF_SHARED_PTR<modelgbp::epr::SecurityGroupContext> result = addChild<modelgbp::epr::SecurityGroupContext>(
            CLASS_ID, getURI(), 2150727778ul, 98,
            opflex::modb::URIBuilder(getURI()).addElement("EprSecurityGroupContext").addElement(eprSecurityGroupContextSecGroup).build()
            );
        result->setSecGroup(eprSecurityGroupContextSecGroup);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::epr::SecurityGroupContext
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveEprSecurityGroupContext(/* out */ std::vector<OF_SHARED_PTR<modelgbp::epr::SecurityGroupContext> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::epr::SecurityGroupContext>(
            getFramework(), CLASS_ID, getURI(), 2150727778ul, 98, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param eprL3NetIp the value of eprL3NetIp,
     * a naming property for L3Net
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::epr::L3Net> > resolveEprL3Net(
        const std::string& eprL3NetIp)
    {
        return modelgbp::epr::L3Net::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("EprL3Net").addElement(eprL3NetIp).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param eprL3NetIp the value of eprL3NetIp,
     * a naming property for L3Net
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::epr::L3Net> addEprL3Net(
        const std::string& eprL3NetIp)
    {
        OF_SHARED_PTR<modelgbp::epr::L3Net> result = addChild<modelgbp::epr::L3Net>(
            CLASS_ID, getURI(), 2150727780ul, 100,
            opflex::modb::URIBuilder(getURI()).addElement("EprL3Net").addElement(eprL3NetIp).build()
            );
        result->setIp(eprL3NetIp);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::epr::L3Net
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveEprL3Net(/* out */ std::vector<OF_SHARED_PTR<modelgbp::epr::L3Net> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::epr::L3Net>(
            getFramework(), CLASS_ID, getURI(), 2150727780ul, 100, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the L2Ep object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the L2Ep object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the L2Ep object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]
     * 
     * @param framework the framework instance to use
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("EprL2Universe").addElement("EprL2Ep").addElement(eprL2EpContext).addElement(eprL2EpMac).build());
    }

    /**
     * Remove the L2Ep object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]
     * 
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),eprL2EpContext,eprL2EpMac);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of L2Ep.
     * This should not typically be called from user code.
     */
    L2Ep(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class L2Ep

} // namespace epr
} // namespace modelgbp
#endif // GI_EPR_L2EP_HPP
