/**
 * 
 * SOME COPYRIGHT
 * 
 * SecurityGroupContext.hpp
 * 
 * generated SecurityGroupContext.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_EPR_SECURITYGROUPCONTEXT_HPP
#define GI_EPR_SECURITYGROUPCONTEXT_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"

namespace modelgbp {
namespace epr {

class SecurityGroupContext
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for SecurityGroupContext
     */
    static const opflex::modb::class_id_t CLASS_ID = 98;

    /**
     * Check whether name has been set
     * @return true if name has been set
     */
    bool isNameSet()
    {
        return getObjectInstance().isSet(3211265ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of name if it has been set.
     * @return the value of name or boost::none if not set
     */
    boost::optional<const std::string&> getName()
    {
        if (isNameSet())
            return getObjectInstance().getString(3211265ul);
        return boost::none;
    }

    /**
     * Get the value of name if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of name if set, otherwise the value of default passed in
     */
    const std::string& getName(const std::string& defaultValue)
    {
        return getName().get_value_or(defaultValue);
    }

    /**
     * Set name to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::epr::SecurityGroupContext& setName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(3211265ul, newValue);
        return *this;
    }

    /**
     * Unset name in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::epr::SecurityGroupContext& unsetName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3211265ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether secGroup has been set
     * @return true if secGroup has been set
     */
    bool isSecGroupSet()
    {
        return getObjectInstance().isSet(3211266ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of secGroup if it has been set.
     * @return the value of secGroup or boost::none if not set
     */
    boost::optional<const std::string&> getSecGroup()
    {
        if (isSecGroupSet())
            return getObjectInstance().getString(3211266ul);
        return boost::none;
    }

    /**
     * Get the value of secGroup if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of secGroup if set, otherwise the value of default passed in
     */
    const std::string& getSecGroup(const std::string& defaultValue)
    {
        return getSecGroup().get_value_or(defaultValue);
    }

    /**
     * Set secGroup to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::epr::SecurityGroupContext& setSecGroup(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(3211266ul, newValue);
        return *this;
    }

    /**
     * Unset secGroup in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::epr::SecurityGroupContext& unsetSecGroup()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3211266ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of SecurityGroupContext from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::epr::SecurityGroupContext> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::epr::SecurityGroupContext>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of SecurityGroupContext from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::epr::SecurityGroupContext> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::epr::SecurityGroupContext>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of SecurityGroupContext from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]/EprSecurityGroupContext/[eprSecurityGroupContextSecGroup]
     * 
     * @param framework the framework instance to use 
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @param eprSecurityGroupContextSecGroup the value of eprSecurityGroupContextSecGroup,
     * a naming property for SecurityGroupContext
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::epr::SecurityGroupContext> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac,
        const std::string& eprSecurityGroupContextSecGroup)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("EprL2Universe").addElement("EprL2Ep").addElement(eprL2EpContext).addElement(eprL2EpMac).addElement("EprSecurityGroupContext").addElement(eprSecurityGroupContextSecGroup).build());
    }

    /**
     * Retrieve an instance of SecurityGroupContext from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]/EprSecurityGroupContext/[eprSecurityGroupContextSecGroup]
     * 
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @param eprSecurityGroupContextSecGroup the value of eprSecurityGroupContextSecGroup,
     * a naming property for SecurityGroupContext
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::epr::SecurityGroupContext> > resolve(
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac,
        const std::string& eprSecurityGroupContextSecGroup)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),eprL2EpContext,eprL2EpMac,eprSecurityGroupContextSecGroup);
    }

    /**
     * Retrieve an instance of SecurityGroupContext from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EprL3Universe/EprL3Ep/[eprL3EpContext]/[eprL3EpIp]/EprSecurityGroupContext/[eprSecurityGroupContextSecGroup]
     * 
     * @param framework the framework instance to use 
     * @param eprL3EpContext the value of eprL3EpContext,
     * a naming property for L3Ep
     * @param eprL3EpIp the value of eprL3EpIp,
     * a naming property for L3Ep
     * @param eprSecurityGroupContextSecGroup the value of eprSecurityGroupContextSecGroup,
     * a naming property for SecurityGroupContext
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::epr::SecurityGroupContext> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& eprL3EpContext,
        const std::string& eprL3EpIp,
        const std::string& eprSecurityGroupContextSecGroup)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("EprL3Universe").addElement("EprL3Ep").addElement(eprL3EpContext).addElement(eprL3EpIp).addElement("EprSecurityGroupContext").addElement(eprSecurityGroupContextSecGroup).build());
    }

    /**
     * Retrieve an instance of SecurityGroupContext from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EprL3Universe/EprL3Ep/[eprL3EpContext]/[eprL3EpIp]/EprSecurityGroupContext/[eprSecurityGroupContextSecGroup]
     * 
     * @param eprL3EpContext the value of eprL3EpContext,
     * a naming property for L3Ep
     * @param eprL3EpIp the value of eprL3EpIp,
     * a naming property for L3Ep
     * @param eprSecurityGroupContextSecGroup the value of eprSecurityGroupContextSecGroup,
     * a naming property for SecurityGroupContext
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::epr::SecurityGroupContext> > resolve(
        const std::string& eprL3EpContext,
        const std::string& eprL3EpIp,
        const std::string& eprSecurityGroupContextSecGroup)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),eprL3EpContext,eprL3EpIp,eprSecurityGroupContextSecGroup);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the SecurityGroupContext object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the SecurityGroupContext object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the SecurityGroupContext object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]/EprSecurityGroupContext/[eprSecurityGroupContextSecGroup]
     * 
     * @param framework the framework instance to use
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @param eprSecurityGroupContextSecGroup the value of eprSecurityGroupContextSecGroup,
     * a naming property for SecurityGroupContext
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac,
        const std::string& eprSecurityGroupContextSecGroup)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("EprL2Universe").addElement("EprL2Ep").addElement(eprL2EpContext).addElement(eprL2EpMac).addElement("EprSecurityGroupContext").addElement(eprSecurityGroupContextSecGroup).build());
    }

    /**
     * Remove the SecurityGroupContext object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]/EprSecurityGroupContext/[eprSecurityGroupContextSecGroup]
     * 
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @param eprSecurityGroupContextSecGroup the value of eprSecurityGroupContextSecGroup,
     * a naming property for SecurityGroupContext
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac,
        const std::string& eprSecurityGroupContextSecGroup)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),eprL2EpContext,eprL2EpMac,eprSecurityGroupContextSecGroup);
    }

    /**
     * Remove the SecurityGroupContext object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EprL3Universe/EprL3Ep/[eprL3EpContext]/[eprL3EpIp]/EprSecurityGroupContext/[eprSecurityGroupContextSecGroup]
     * 
     * @param framework the framework instance to use
     * @param eprL3EpContext the value of eprL3EpContext,
     * a naming property for L3Ep
     * @param eprL3EpIp the value of eprL3EpIp,
     * a naming property for L3Ep
     * @param eprSecurityGroupContextSecGroup the value of eprSecurityGroupContextSecGroup,
     * a naming property for SecurityGroupContext
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& eprL3EpContext,
        const std::string& eprL3EpIp,
        const std::string& eprSecurityGroupContextSecGroup)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("EprL3Universe").addElement("EprL3Ep").addElement(eprL3EpContext).addElement(eprL3EpIp).addElement("EprSecurityGroupContext").addElement(eprSecurityGroupContextSecGroup).build());
    }

    /**
     * Remove the SecurityGroupContext object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EprL3Universe/EprL3Ep/[eprL3EpContext]/[eprL3EpIp]/EprSecurityGroupContext/[eprSecurityGroupContextSecGroup]
     * 
     * @param eprL3EpContext the value of eprL3EpContext,
     * a naming property for L3Ep
     * @param eprL3EpIp the value of eprL3EpIp,
     * a naming property for L3Ep
     * @param eprSecurityGroupContextSecGroup the value of eprSecurityGroupContextSecGroup,
     * a naming property for SecurityGroupContext
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& eprL3EpContext,
        const std::string& eprL3EpIp,
        const std::string& eprSecurityGroupContextSecGroup)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),eprL3EpContext,eprL3EpIp,eprSecurityGroupContextSecGroup);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of SecurityGroupContext.
     * This should not typically be called from user code.
     */
    SecurityGroupContext(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class SecurityGroupContext

} // namespace epr
} // namespace modelgbp
#endif // GI_EPR_SECURITYGROUPCONTEXT_HPP
