/**
 * 
 * SOME COPYRIGHT
 * 
 * Contract.hpp
 * 
 * generated Contract.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_GBP_CONTRACT_HPP
#define GI_GBP_CONTRACT_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(gbp/Subject)
 */
#include "modelgbp/gbp/Subject.hpp"
/*
 * contains: item:mclass(gbp/EpGroupFromProvContractRTgt)
 */
#include "modelgbp/gbp/EpGroupFromProvContractRTgt.hpp"
/*
 * contains: item:mclass(gbp/EpGroupFromConsContractRTgt)
 */
#include "modelgbp/gbp/EpGroupFromConsContractRTgt.hpp"
/*
 * contains: item:mclass(gbp/EpGroupFromIntraContractRTgt)
 */
#include "modelgbp/gbp/EpGroupFromIntraContractRTgt.hpp"
/*
 * contains: item:mclass(gbp/L3ExternalNetworkFromProvContractRTgt)
 */
#include "modelgbp/gbp/L3ExternalNetworkFromProvContractRTgt.hpp"
/*
 * contains: item:mclass(gbp/L3ExternalNetworkFromConsContractRTgt)
 */
#include "modelgbp/gbp/L3ExternalNetworkFromConsContractRTgt.hpp"

namespace modelgbp {
namespace gbp {

class Contract
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for Contract
     */
    static const opflex::modb::class_id_t CLASS_ID = 143;

    /**
     * Check whether name has been set
     * @return true if name has been set
     */
    bool isNameSet()
    {
        return getObjectInstance().isSet(4685825ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of name if it has been set.
     * @return the value of name or boost::none if not set
     */
    boost::optional<const std::string&> getName()
    {
        if (isNameSet())
            return getObjectInstance().getString(4685825ul);
        return boost::none;
    }

    /**
     * Get the value of name if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of name if set, otherwise the value of default passed in
     */
    const std::string& getName(const std::string& defaultValue)
    {
        return getName().get_value_or(defaultValue);
    }

    /**
     * Set name to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbp::Contract& setName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(4685825ul, newValue);
        return *this;
    }

    /**
     * Unset name in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbp::Contract& unsetName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4685825ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of Contract from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::Contract> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbp::Contract>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of Contract from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::Contract> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbp::Contract>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of Contract from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpContract/[gbpContractName]
     * 
     * @param framework the framework instance to use 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpContractName the value of gbpContractName,
     * a naming property for Contract
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::Contract> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& policySpaceName,
        const std::string& gbpContractName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PolicySpace").addElement(policySpaceName).addElement("GbpContract").addElement(gbpContractName).build());
    }

    /**
     * Retrieve an instance of Contract from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpContract/[gbpContractName]
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpContractName the value of gbpContractName,
     * a naming property for Contract
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::Contract> > resolve(
        const std::string& policySpaceName,
        const std::string& gbpContractName)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),policySpaceName,gbpContractName);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpSubjectName the value of gbpSubjectName,
     * a naming property for Subject
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::Subject> > resolveGbpSubject(
        const std::string& gbpSubjectName)
    {
        return modelgbp::gbp::Subject::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpSubject").addElement(gbpSubjectName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpSubjectName the value of gbpSubjectName,
     * a naming property for Subject
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::Subject> addGbpSubject(
        const std::string& gbpSubjectName)
    {
        OF_SHARED_PTR<modelgbp::gbp::Subject> result = addChild<modelgbp::gbp::Subject>(
            CLASS_ID, getURI(), 2152169616ul, 144,
            opflex::modb::URIBuilder(getURI()).addElement("GbpSubject").addElement(gbpSubjectName).build()
            );
        result->setName(gbpSubjectName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::Subject
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpSubject(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::Subject> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::Subject>(
            getFramework(), CLASS_ID, getURI(), 2152169616ul, 144, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpEpGroupFromProvContractRTgtSource the value of gbpEpGroupFromProvContractRTgtSource,
     * a naming property for EpGroupFromProvContractRTgt
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::EpGroupFromProvContractRTgt> > resolveGbpEpGroupFromProvContractRTgt(
        const std::string& gbpEpGroupFromProvContractRTgtSource)
    {
        return modelgbp::gbp::EpGroupFromProvContractRTgt::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpEpGroupFromProvContractRTgt").addElement(gbpEpGroupFromProvContractRTgtSource).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpEpGroupFromProvContractRTgtSource the value of gbpEpGroupFromProvContractRTgtSource,
     * a naming property for EpGroupFromProvContractRTgt
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::EpGroupFromProvContractRTgt> addGbpEpGroupFromProvContractRTgt(
        const std::string& gbpEpGroupFromProvContractRTgtSource)
    {
        OF_SHARED_PTR<modelgbp::gbp::EpGroupFromProvContractRTgt> result = addChild<modelgbp::gbp::EpGroupFromProvContractRTgt>(
            CLASS_ID, getURI(), 2152169629ul, 157,
            opflex::modb::URIBuilder(getURI()).addElement("GbpEpGroupFromProvContractRTgt").addElement(gbpEpGroupFromProvContractRTgtSource).build()
            );
        result->setSource(gbpEpGroupFromProvContractRTgtSource);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::EpGroupFromProvContractRTgt
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpEpGroupFromProvContractRTgt(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::EpGroupFromProvContractRTgt> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::EpGroupFromProvContractRTgt>(
            getFramework(), CLASS_ID, getURI(), 2152169629ul, 157, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpEpGroupFromConsContractRTgtSource the value of gbpEpGroupFromConsContractRTgtSource,
     * a naming property for EpGroupFromConsContractRTgt
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::EpGroupFromConsContractRTgt> > resolveGbpEpGroupFromConsContractRTgt(
        const std::string& gbpEpGroupFromConsContractRTgtSource)
    {
        return modelgbp::gbp::EpGroupFromConsContractRTgt::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpEpGroupFromConsContractRTgt").addElement(gbpEpGroupFromConsContractRTgtSource).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpEpGroupFromConsContractRTgtSource the value of gbpEpGroupFromConsContractRTgtSource,
     * a naming property for EpGroupFromConsContractRTgt
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::EpGroupFromConsContractRTgt> addGbpEpGroupFromConsContractRTgt(
        const std::string& gbpEpGroupFromConsContractRTgtSource)
    {
        OF_SHARED_PTR<modelgbp::gbp::EpGroupFromConsContractRTgt> result = addChild<modelgbp::gbp::EpGroupFromConsContractRTgt>(
            CLASS_ID, getURI(), 2152169632ul, 160,
            opflex::modb::URIBuilder(getURI()).addElement("GbpEpGroupFromConsContractRTgt").addElement(gbpEpGroupFromConsContractRTgtSource).build()
            );
        result->setSource(gbpEpGroupFromConsContractRTgtSource);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::EpGroupFromConsContractRTgt
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpEpGroupFromConsContractRTgt(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::EpGroupFromConsContractRTgt> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::EpGroupFromConsContractRTgt>(
            getFramework(), CLASS_ID, getURI(), 2152169632ul, 160, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpEpGroupFromIntraContractRTgtSource the value of gbpEpGroupFromIntraContractRTgtSource,
     * a naming property for EpGroupFromIntraContractRTgt
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::EpGroupFromIntraContractRTgt> > resolveGbpEpGroupFromIntraContractRTgt(
        const std::string& gbpEpGroupFromIntraContractRTgtSource)
    {
        return modelgbp::gbp::EpGroupFromIntraContractRTgt::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpEpGroupFromIntraContractRTgt").addElement(gbpEpGroupFromIntraContractRTgtSource).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpEpGroupFromIntraContractRTgtSource the value of gbpEpGroupFromIntraContractRTgtSource,
     * a naming property for EpGroupFromIntraContractRTgt
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::EpGroupFromIntraContractRTgt> addGbpEpGroupFromIntraContractRTgt(
        const std::string& gbpEpGroupFromIntraContractRTgtSource)
    {
        OF_SHARED_PTR<modelgbp::gbp::EpGroupFromIntraContractRTgt> result = addChild<modelgbp::gbp::EpGroupFromIntraContractRTgt>(
            CLASS_ID, getURI(), 2152169635ul, 163,
            opflex::modb::URIBuilder(getURI()).addElement("GbpEpGroupFromIntraContractRTgt").addElement(gbpEpGroupFromIntraContractRTgtSource).build()
            );
        result->setSource(gbpEpGroupFromIntraContractRTgtSource);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::EpGroupFromIntraContractRTgt
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpEpGroupFromIntraContractRTgt(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::EpGroupFromIntraContractRTgt> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::EpGroupFromIntraContractRTgt>(
            getFramework(), CLASS_ID, getURI(), 2152169635ul, 163, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpL3ExternalNetworkFromProvContractRTgtSource the value of gbpL3ExternalNetworkFromProvContractRTgtSource,
     * a naming property for L3ExternalNetworkFromProvContractRTgt
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkFromProvContractRTgt> > resolveGbpL3ExternalNetworkFromProvContractRTgt(
        const std::string& gbpL3ExternalNetworkFromProvContractRTgtSource)
    {
        return modelgbp::gbp::L3ExternalNetworkFromProvContractRTgt::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpL3ExternalNetworkFromProvContractRTgt").addElement(gbpL3ExternalNetworkFromProvContractRTgtSource).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpL3ExternalNetworkFromProvContractRTgtSource the value of gbpL3ExternalNetworkFromProvContractRTgtSource,
     * a naming property for L3ExternalNetworkFromProvContractRTgt
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkFromProvContractRTgt> addGbpL3ExternalNetworkFromProvContractRTgt(
        const std::string& gbpL3ExternalNetworkFromProvContractRTgtSource)
    {
        OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkFromProvContractRTgt> result = addChild<modelgbp::gbp::L3ExternalNetworkFromProvContractRTgt>(
            CLASS_ID, getURI(), 2152169643ul, 171,
            opflex::modb::URIBuilder(getURI()).addElement("GbpL3ExternalNetworkFromProvContractRTgt").addElement(gbpL3ExternalNetworkFromProvContractRTgtSource).build()
            );
        result->setSource(gbpL3ExternalNetworkFromProvContractRTgtSource);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::L3ExternalNetworkFromProvContractRTgt
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpL3ExternalNetworkFromProvContractRTgt(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkFromProvContractRTgt> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::L3ExternalNetworkFromProvContractRTgt>(
            getFramework(), CLASS_ID, getURI(), 2152169643ul, 171, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpL3ExternalNetworkFromConsContractRTgtSource the value of gbpL3ExternalNetworkFromConsContractRTgtSource,
     * a naming property for L3ExternalNetworkFromConsContractRTgt
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkFromConsContractRTgt> > resolveGbpL3ExternalNetworkFromConsContractRTgt(
        const std::string& gbpL3ExternalNetworkFromConsContractRTgtSource)
    {
        return modelgbp::gbp::L3ExternalNetworkFromConsContractRTgt::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpL3ExternalNetworkFromConsContractRTgt").addElement(gbpL3ExternalNetworkFromConsContractRTgtSource).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpL3ExternalNetworkFromConsContractRTgtSource the value of gbpL3ExternalNetworkFromConsContractRTgtSource,
     * a naming property for L3ExternalNetworkFromConsContractRTgt
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkFromConsContractRTgt> addGbpL3ExternalNetworkFromConsContractRTgt(
        const std::string& gbpL3ExternalNetworkFromConsContractRTgtSource)
    {
        OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkFromConsContractRTgt> result = addChild<modelgbp::gbp::L3ExternalNetworkFromConsContractRTgt>(
            CLASS_ID, getURI(), 2152169646ul, 174,
            opflex::modb::URIBuilder(getURI()).addElement("GbpL3ExternalNetworkFromConsContractRTgt").addElement(gbpL3ExternalNetworkFromConsContractRTgtSource).build()
            );
        result->setSource(gbpL3ExternalNetworkFromConsContractRTgtSource);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::L3ExternalNetworkFromConsContractRTgt
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpL3ExternalNetworkFromConsContractRTgt(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkFromConsContractRTgt> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::L3ExternalNetworkFromConsContractRTgt>(
            getFramework(), CLASS_ID, getURI(), 2152169646ul, 174, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the Contract object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the Contract object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the Contract object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpContract/[gbpContractName]
     * 
     * @param framework the framework instance to use
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpContractName the value of gbpContractName,
     * a naming property for Contract
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& policySpaceName,
        const std::string& gbpContractName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PolicySpace").addElement(policySpaceName).addElement("GbpContract").addElement(gbpContractName).build());
    }

    /**
     * Remove the Contract object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpContract/[gbpContractName]
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpContractName the value of gbpContractName,
     * a naming property for Contract
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& policySpaceName,
        const std::string& gbpContractName)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),policySpaceName,gbpContractName);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of Contract.
     * This should not typically be called from user code.
     */
    Contract(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class Contract

} // namespace gbp
} // namespace modelgbp
#endif // GI_GBP_CONTRACT_HPP
