/**
 * 
 * SOME COPYRIGHT
 * 
 * L3ExternalNetwork.hpp
 * 
 * generated L3ExternalNetwork.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_GBP_L3EXTERNALNETWORK_HPP
#define GI_GBP_L3EXTERNALNETWORK_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(gbp/L3ExternalNetworkToProvContractRSrc)
 */
#include "modelgbp/gbp/L3ExternalNetworkToProvContractRSrc.hpp"
/*
 * contains: item:mclass(gbp/L3ExternalNetworkToConsContractRSrc)
 */
#include "modelgbp/gbp/L3ExternalNetworkToConsContractRSrc.hpp"
/*
 * contains: item:mclass(gbp/L3ExternalNetworkToNatEPGroupRSrc)
 */
#include "modelgbp/gbp/L3ExternalNetworkToNatEPGroupRSrc.hpp"
/*
 * contains: item:mclass(gbp/ExternalSubnet)
 */
#include "modelgbp/gbp/ExternalSubnet.hpp"

namespace modelgbp {
namespace gbp {

class L3ExternalNetwork
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for L3ExternalNetwork
     */
    static const opflex::modb::class_id_t CLASS_ID = 169;

    /**
     * Check whether name has been set
     * @return true if name has been set
     */
    bool isNameSet()
    {
        return getObjectInstance().isSet(5537793ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of name if it has been set.
     * @return the value of name or boost::none if not set
     */
    boost::optional<const std::string&> getName()
    {
        if (isNameSet())
            return getObjectInstance().getString(5537793ul);
        return boost::none;
    }

    /**
     * Get the value of name if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of name if set, otherwise the value of default passed in
     */
    const std::string& getName(const std::string& defaultValue)
    {
        return getName().get_value_or(defaultValue);
    }

    /**
     * Set name to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbp::L3ExternalNetwork& setName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(5537793ul, newValue);
        return *this;
    }

    /**
     * Unset name in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbp::L3ExternalNetwork& unsetName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(5537793ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of L3ExternalNetwork from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetwork> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbp::L3ExternalNetwork>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of L3ExternalNetwork from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetwork> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbp::L3ExternalNetwork>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of L3ExternalNetwork from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpRoutingDomain/[gbpRoutingDomainName]/GbpL3ExternalDomain/[gbpL3ExternalDomainName]/GbpL3ExternalNetwork/[gbpL3ExternalNetworkName]
     * 
     * @param framework the framework instance to use 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpRoutingDomainName the value of gbpRoutingDomainName,
     * a naming property for RoutingDomain
     * @param gbpL3ExternalDomainName the value of gbpL3ExternalDomainName,
     * a naming property for L3ExternalDomain
     * @param gbpL3ExternalNetworkName the value of gbpL3ExternalNetworkName,
     * a naming property for L3ExternalNetwork
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetwork> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& policySpaceName,
        const std::string& gbpRoutingDomainName,
        const std::string& gbpL3ExternalDomainName,
        const std::string& gbpL3ExternalNetworkName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PolicySpace").addElement(policySpaceName).addElement("GbpRoutingDomain").addElement(gbpRoutingDomainName).addElement("GbpL3ExternalDomain").addElement(gbpL3ExternalDomainName).addElement("GbpL3ExternalNetwork").addElement(gbpL3ExternalNetworkName).build());
    }

    /**
     * Retrieve an instance of L3ExternalNetwork from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpRoutingDomain/[gbpRoutingDomainName]/GbpL3ExternalDomain/[gbpL3ExternalDomainName]/GbpL3ExternalNetwork/[gbpL3ExternalNetworkName]
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpRoutingDomainName the value of gbpRoutingDomainName,
     * a naming property for RoutingDomain
     * @param gbpL3ExternalDomainName the value of gbpL3ExternalDomainName,
     * a naming property for L3ExternalDomain
     * @param gbpL3ExternalNetworkName the value of gbpL3ExternalNetworkName,
     * a naming property for L3ExternalNetwork
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetwork> > resolve(
        const std::string& policySpaceName,
        const std::string& gbpRoutingDomainName,
        const std::string& gbpL3ExternalDomainName,
        const std::string& gbpL3ExternalNetworkName)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),policySpaceName,gbpRoutingDomainName,gbpL3ExternalDomainName,gbpL3ExternalNetworkName);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpL3ExternalNetworkToProvContractRSrcTargetClass the value of gbpL3ExternalNetworkToProvContractRSrcTargetClass,
     * a naming property for L3ExternalNetworkToProvContractRSrc
     * @param gbpL3ExternalNetworkToProvContractRSrcTargetName the value of gbpL3ExternalNetworkToProvContractRSrcTargetName,
     * a naming property for L3ExternalNetworkToProvContractRSrc
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkToProvContractRSrc> > resolveGbpL3ExternalNetworkToProvContractRSrc(
        const std::string& gbpL3ExternalNetworkToProvContractRSrcTargetName)
    {
        opflex::modb::class_id_t gbpL3ExternalNetworkToProvContractRSrcTargetClass = 143;
        return modelgbp::gbp::L3ExternalNetworkToProvContractRSrc::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpL3ExternalNetworkToProvContractRSrc").addElement(gbpL3ExternalNetworkToProvContractRSrcTargetClass).addElement(gbpL3ExternalNetworkToProvContractRSrcTargetName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpL3ExternalNetworkToProvContractRSrcTargetClass the value of gbpL3ExternalNetworkToProvContractRSrcTargetClass,
     * a naming property for L3ExternalNetworkToProvContractRSrc
     * @param gbpL3ExternalNetworkToProvContractRSrcTargetName the value of gbpL3ExternalNetworkToProvContractRSrcTargetName,
     * a naming property for L3ExternalNetworkToProvContractRSrc
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkToProvContractRSrc> addGbpL3ExternalNetworkToProvContractRSrc(
        const std::string& gbpL3ExternalNetworkToProvContractRSrcTargetName)
    {
        opflex::modb::class_id_t gbpL3ExternalNetworkToProvContractRSrcTargetClass = 143;
        OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkToProvContractRSrc> result = addChild<modelgbp::gbp::L3ExternalNetworkToProvContractRSrc>(
            CLASS_ID, getURI(), 2153021610ul, 170,
            opflex::modb::URIBuilder(getURI()).addElement("GbpL3ExternalNetworkToProvContractRSrc").addElement(gbpL3ExternalNetworkToProvContractRSrcTargetClass).addElement(gbpL3ExternalNetworkToProvContractRSrcTargetName).build()
            );
        result->setTargetContract(opflex::modb::URI(gbpL3ExternalNetworkToProvContractRSrcTargetName));
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::L3ExternalNetworkToProvContractRSrc
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpL3ExternalNetworkToProvContractRSrc(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkToProvContractRSrc> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::L3ExternalNetworkToProvContractRSrc>(
            getFramework(), CLASS_ID, getURI(), 2153021610ul, 170, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpL3ExternalNetworkToConsContractRSrcTargetClass the value of gbpL3ExternalNetworkToConsContractRSrcTargetClass,
     * a naming property for L3ExternalNetworkToConsContractRSrc
     * @param gbpL3ExternalNetworkToConsContractRSrcTargetName the value of gbpL3ExternalNetworkToConsContractRSrcTargetName,
     * a naming property for L3ExternalNetworkToConsContractRSrc
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkToConsContractRSrc> > resolveGbpL3ExternalNetworkToConsContractRSrc(
        const std::string& gbpL3ExternalNetworkToConsContractRSrcTargetName)
    {
        opflex::modb::class_id_t gbpL3ExternalNetworkToConsContractRSrcTargetClass = 143;
        return modelgbp::gbp::L3ExternalNetworkToConsContractRSrc::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpL3ExternalNetworkToConsContractRSrc").addElement(gbpL3ExternalNetworkToConsContractRSrcTargetClass).addElement(gbpL3ExternalNetworkToConsContractRSrcTargetName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpL3ExternalNetworkToConsContractRSrcTargetClass the value of gbpL3ExternalNetworkToConsContractRSrcTargetClass,
     * a naming property for L3ExternalNetworkToConsContractRSrc
     * @param gbpL3ExternalNetworkToConsContractRSrcTargetName the value of gbpL3ExternalNetworkToConsContractRSrcTargetName,
     * a naming property for L3ExternalNetworkToConsContractRSrc
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkToConsContractRSrc> addGbpL3ExternalNetworkToConsContractRSrc(
        const std::string& gbpL3ExternalNetworkToConsContractRSrcTargetName)
    {
        opflex::modb::class_id_t gbpL3ExternalNetworkToConsContractRSrcTargetClass = 143;
        OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkToConsContractRSrc> result = addChild<modelgbp::gbp::L3ExternalNetworkToConsContractRSrc>(
            CLASS_ID, getURI(), 2153021613ul, 173,
            opflex::modb::URIBuilder(getURI()).addElement("GbpL3ExternalNetworkToConsContractRSrc").addElement(gbpL3ExternalNetworkToConsContractRSrcTargetClass).addElement(gbpL3ExternalNetworkToConsContractRSrcTargetName).build()
            );
        result->setTargetContract(opflex::modb::URI(gbpL3ExternalNetworkToConsContractRSrcTargetName));
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::L3ExternalNetworkToConsContractRSrc
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpL3ExternalNetworkToConsContractRSrc(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkToConsContractRSrc> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::L3ExternalNetworkToConsContractRSrc>(
            getFramework(), CLASS_ID, getURI(), 2153021613ul, 173, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkToNatEPGroupRSrc> > resolveGbpL3ExternalNetworkToNatEPGroupRSrc(
        )
    {
        return modelgbp::gbp::L3ExternalNetworkToNatEPGroupRSrc::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpL3ExternalNetworkToNatEPGroupRSrc").build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkToNatEPGroupRSrc> addGbpL3ExternalNetworkToNatEPGroupRSrc(
        )
    {
        OF_SHARED_PTR<modelgbp::gbp::L3ExternalNetworkToNatEPGroupRSrc> result = addChild<modelgbp::gbp::L3ExternalNetworkToNatEPGroupRSrc>(
            CLASS_ID, getURI(), 2153021616ul, 176,
            opflex::modb::URIBuilder(getURI()).addElement("GbpL3ExternalNetworkToNatEPGroupRSrc").build()
            );
        return result;
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpExternalSubnetName the value of gbpExternalSubnetName,
     * a naming property for ExternalSubnet
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::ExternalSubnet> > resolveGbpExternalSubnet(
        const std::string& gbpExternalSubnetName)
    {
        return modelgbp::gbp::ExternalSubnet::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpExternalSubnet").addElement(gbpExternalSubnetName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpExternalSubnetName the value of gbpExternalSubnetName,
     * a naming property for ExternalSubnet
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::ExternalSubnet> addGbpExternalSubnet(
        const std::string& gbpExternalSubnetName)
    {
        OF_SHARED_PTR<modelgbp::gbp::ExternalSubnet> result = addChild<modelgbp::gbp::ExternalSubnet>(
            CLASS_ID, getURI(), 2153021619ul, 179,
            opflex::modb::URIBuilder(getURI()).addElement("GbpExternalSubnet").addElement(gbpExternalSubnetName).build()
            );
        result->setName(gbpExternalSubnetName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::ExternalSubnet
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpExternalSubnet(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::ExternalSubnet> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::ExternalSubnet>(
            getFramework(), CLASS_ID, getURI(), 2153021619ul, 179, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the L3ExternalNetwork object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the L3ExternalNetwork object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the L3ExternalNetwork object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpRoutingDomain/[gbpRoutingDomainName]/GbpL3ExternalDomain/[gbpL3ExternalDomainName]/GbpL3ExternalNetwork/[gbpL3ExternalNetworkName]
     * 
     * @param framework the framework instance to use
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpRoutingDomainName the value of gbpRoutingDomainName,
     * a naming property for RoutingDomain
     * @param gbpL3ExternalDomainName the value of gbpL3ExternalDomainName,
     * a naming property for L3ExternalDomain
     * @param gbpL3ExternalNetworkName the value of gbpL3ExternalNetworkName,
     * a naming property for L3ExternalNetwork
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& policySpaceName,
        const std::string& gbpRoutingDomainName,
        const std::string& gbpL3ExternalDomainName,
        const std::string& gbpL3ExternalNetworkName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PolicySpace").addElement(policySpaceName).addElement("GbpRoutingDomain").addElement(gbpRoutingDomainName).addElement("GbpL3ExternalDomain").addElement(gbpL3ExternalDomainName).addElement("GbpL3ExternalNetwork").addElement(gbpL3ExternalNetworkName).build());
    }

    /**
     * Remove the L3ExternalNetwork object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpRoutingDomain/[gbpRoutingDomainName]/GbpL3ExternalDomain/[gbpL3ExternalDomainName]/GbpL3ExternalNetwork/[gbpL3ExternalNetworkName]
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpRoutingDomainName the value of gbpRoutingDomainName,
     * a naming property for RoutingDomain
     * @param gbpL3ExternalDomainName the value of gbpL3ExternalDomainName,
     * a naming property for L3ExternalDomain
     * @param gbpL3ExternalNetworkName the value of gbpL3ExternalNetworkName,
     * a naming property for L3ExternalNetwork
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& policySpaceName,
        const std::string& gbpRoutingDomainName,
        const std::string& gbpL3ExternalDomainName,
        const std::string& gbpL3ExternalNetworkName)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),policySpaceName,gbpRoutingDomainName,gbpL3ExternalDomainName,gbpL3ExternalNetworkName);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of L3ExternalNetwork.
     * This should not typically be called from user code.
     */
    L3ExternalNetwork(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class L3ExternalNetwork

} // namespace gbp
} // namespace modelgbp
#endif // GI_GBP_L3EXTERNALNETWORK_HPP
