/**
 * 
 * SOME COPYRIGHT
 * 
 * SecGroup.hpp
 * 
 * generated SecGroup.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_GBP_SECGROUP_HPP
#define GI_GBP_SECGROUP_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(epdr/EndPointFromSecGroupRTgt)
 */
#include "modelgbp/epdr/EndPointFromSecGroupRTgt.hpp"
/*
 * contains: item:mclass(inv/LocalInventoryEpFromSecGroupRTgt)
 */
#include "modelgbp/inv/LocalInventoryEpFromSecGroupRTgt.hpp"
/*
 * contains: item:mclass(gbp/SecGroupSubject)
 */
#include "modelgbp/gbp/SecGroupSubject.hpp"

namespace modelgbp {
namespace gbp {

class SecGroup
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for SecGroup
     */
    static const opflex::modb::class_id_t CLASS_ID = 203;

    /**
     * Check whether name has been set
     * @return true if name has been set
     */
    bool isNameSet()
    {
        return getObjectInstance().isSet(6651905ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of name if it has been set.
     * @return the value of name or boost::none if not set
     */
    boost::optional<const std::string&> getName()
    {
        if (isNameSet())
            return getObjectInstance().getString(6651905ul);
        return boost::none;
    }

    /**
     * Get the value of name if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of name if set, otherwise the value of default passed in
     */
    const std::string& getName(const std::string& defaultValue)
    {
        return getName().get_value_or(defaultValue);
    }

    /**
     * Set name to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbp::SecGroup& setName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(6651905ul, newValue);
        return *this;
    }

    /**
     * Unset name in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbp::SecGroup& unsetName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(6651905ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of SecGroup from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::SecGroup> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbp::SecGroup>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of SecGroup from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::SecGroup> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbp::SecGroup>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of SecGroup from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpSecGroup/[gbpSecGroupName]
     * 
     * @param framework the framework instance to use 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpSecGroupName the value of gbpSecGroupName,
     * a naming property for SecGroup
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::SecGroup> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& policySpaceName,
        const std::string& gbpSecGroupName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PolicySpace").addElement(policySpaceName).addElement("GbpSecGroup").addElement(gbpSecGroupName).build());
    }

    /**
     * Retrieve an instance of SecGroup from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpSecGroup/[gbpSecGroupName]
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpSecGroupName the value of gbpSecGroupName,
     * a naming property for SecGroup
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::SecGroup> > resolve(
        const std::string& policySpaceName,
        const std::string& gbpSecGroupName)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),policySpaceName,gbpSecGroupName);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param epdrEndPointFromSecGroupRTgtSource the value of epdrEndPointFromSecGroupRTgtSource,
     * a naming property for EndPointFromSecGroupRTgt
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::epdr::EndPointFromSecGroupRTgt> > resolveEpdrEndPointFromSecGroupRTgt(
        const std::string& epdrEndPointFromSecGroupRTgtSource)
    {
        return modelgbp::epdr::EndPointFromSecGroupRTgt::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("EpdrEndPointFromSecGroupRTgt").addElement(epdrEndPointFromSecGroupRTgtSource).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param epdrEndPointFromSecGroupRTgtSource the value of epdrEndPointFromSecGroupRTgtSource,
     * a naming property for EndPointFromSecGroupRTgt
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::epdr::EndPointFromSecGroupRTgt> addEpdrEndPointFromSecGroupRTgt(
        const std::string& epdrEndPointFromSecGroupRTgtSource)
    {
        OF_SHARED_PTR<modelgbp::epdr::EndPointFromSecGroupRTgt> result = addChild<modelgbp::epdr::EndPointFromSecGroupRTgt>(
            CLASS_ID, getURI(), 2154135659ul, 107,
            opflex::modb::URIBuilder(getURI()).addElement("EpdrEndPointFromSecGroupRTgt").addElement(epdrEndPointFromSecGroupRTgtSource).build()
            );
        result->setSource(epdrEndPointFromSecGroupRTgtSource);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::epdr::EndPointFromSecGroupRTgt
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveEpdrEndPointFromSecGroupRTgt(/* out */ std::vector<OF_SHARED_PTR<modelgbp::epdr::EndPointFromSecGroupRTgt> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::epdr::EndPointFromSecGroupRTgt>(
            getFramework(), CLASS_ID, getURI(), 2154135659ul, 107, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param invLocalInventoryEpFromSecGroupRTgtSource the value of invLocalInventoryEpFromSecGroupRTgtSource,
     * a naming property for LocalInventoryEpFromSecGroupRTgt
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::inv::LocalInventoryEpFromSecGroupRTgt> > resolveInvLocalInventoryEpFromSecGroupRTgt(
        const std::string& invLocalInventoryEpFromSecGroupRTgtSource)
    {
        return modelgbp::inv::LocalInventoryEpFromSecGroupRTgt::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("InvLocalInventoryEpFromSecGroupRTgt").addElement(invLocalInventoryEpFromSecGroupRTgtSource).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param invLocalInventoryEpFromSecGroupRTgtSource the value of invLocalInventoryEpFromSecGroupRTgtSource,
     * a naming property for LocalInventoryEpFromSecGroupRTgt
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::inv::LocalInventoryEpFromSecGroupRTgt> addInvLocalInventoryEpFromSecGroupRTgt(
        const std::string& invLocalInventoryEpFromSecGroupRTgtSource)
    {
        OF_SHARED_PTR<modelgbp::inv::LocalInventoryEpFromSecGroupRTgt> result = addChild<modelgbp::inv::LocalInventoryEpFromSecGroupRTgt>(
            CLASS_ID, getURI(), 2154135673ul, 121,
            opflex::modb::URIBuilder(getURI()).addElement("InvLocalInventoryEpFromSecGroupRTgt").addElement(invLocalInventoryEpFromSecGroupRTgtSource).build()
            );
        result->setSource(invLocalInventoryEpFromSecGroupRTgtSource);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::inv::LocalInventoryEpFromSecGroupRTgt
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveInvLocalInventoryEpFromSecGroupRTgt(/* out */ std::vector<OF_SHARED_PTR<modelgbp::inv::LocalInventoryEpFromSecGroupRTgt> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::inv::LocalInventoryEpFromSecGroupRTgt>(
            getFramework(), CLASS_ID, getURI(), 2154135673ul, 121, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpSecGroupSubjectName the value of gbpSecGroupSubjectName,
     * a naming property for SecGroupSubject
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::SecGroupSubject> > resolveGbpSecGroupSubject(
        const std::string& gbpSecGroupSubjectName)
    {
        return modelgbp::gbp::SecGroupSubject::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpSecGroupSubject").addElement(gbpSecGroupSubjectName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpSecGroupSubjectName the value of gbpSecGroupSubjectName,
     * a naming property for SecGroupSubject
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::SecGroupSubject> addGbpSecGroupSubject(
        const std::string& gbpSecGroupSubjectName)
    {
        OF_SHARED_PTR<modelgbp::gbp::SecGroupSubject> result = addChild<modelgbp::gbp::SecGroupSubject>(
            CLASS_ID, getURI(), 2154135756ul, 204,
            opflex::modb::URIBuilder(getURI()).addElement("GbpSecGroupSubject").addElement(gbpSecGroupSubjectName).build()
            );
        result->setName(gbpSecGroupSubjectName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::SecGroupSubject
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpSecGroupSubject(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::SecGroupSubject> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::SecGroupSubject>(
            getFramework(), CLASS_ID, getURI(), 2154135756ul, 204, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the SecGroup object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the SecGroup object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the SecGroup object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpSecGroup/[gbpSecGroupName]
     * 
     * @param framework the framework instance to use
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpSecGroupName the value of gbpSecGroupName,
     * a naming property for SecGroup
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& policySpaceName,
        const std::string& gbpSecGroupName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PolicySpace").addElement(policySpaceName).addElement("GbpSecGroup").addElement(gbpSecGroupName).build());
    }

    /**
     * Remove the SecGroup object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpSecGroup/[gbpSecGroupName]
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpSecGroupName the value of gbpSecGroupName,
     * a naming property for SecGroup
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& policySpaceName,
        const std::string& gbpSecGroupName)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),policySpaceName,gbpSecGroupName);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of SecGroup.
     * This should not typically be called from user code.
     */
    SecGroup(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class SecGroup

} // namespace gbp
} // namespace modelgbp
#endif // GI_GBP_SECGROUP_HPP
