/**
 * 
 * SOME COPYRIGHT
 * 
 * SecGroupRule.hpp
 * 
 * generated SecGroupRule.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_GBP_SECGROUPRULE_HPP
#define GI_GBP_SECGROUPRULE_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(gbp/RuleToClassifierRSrc)
 */
#include "modelgbp/gbp/RuleToClassifierRSrc.hpp"
/*
 * contains: item:mclass(gbp/RuleToActionRSrc)
 */
#include "modelgbp/gbp/RuleToActionRSrc.hpp"
/*
 * contains: item:mclass(gbp/SecGroupRuleToRemoteAddressRSrc)
 */
#include "modelgbp/gbp/SecGroupRuleToRemoteAddressRSrc.hpp"

namespace modelgbp {
namespace gbp {

class SecGroupRule
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for SecGroupRule
     */
    static const opflex::modb::class_id_t CLASS_ID = 205;

    /**
     * Check whether direction has been set
     * @return true if direction has been set
     */
    bool isDirectionSet()
    {
        return getObjectInstance().isSet(6717443ul, opflex::modb::PropertyInfo::ENUM8);
    }

    /**
     * Get the value of direction if it has been set.
     * @return the value of direction or boost::none if not set
     */
    boost::optional<const uint8_t> getDirection()
    {
        if (isDirectionSet())
            return (const uint8_t)getObjectInstance().getUInt64(6717443ul);
        return boost::none;
    }

    /**
     * Get the value of direction if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of direction if set, otherwise the value of default passed in
     */
    const uint8_t getDirection(const uint8_t defaultValue)
    {
        return getDirection().get_value_or(defaultValue);
    }

    /**
     * Set direction to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbp::SecGroupRule& setDirection(const uint8_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(6717443ul, newValue);
        return *this;
    }

    /**
     * Unset direction in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbp::SecGroupRule& unsetDirection()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(6717443ul, opflex::modb::PropertyInfo::ENUM8, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether name has been set
     * @return true if name has been set
     */
    bool isNameSet()
    {
        return getObjectInstance().isSet(6717441ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of name if it has been set.
     * @return the value of name or boost::none if not set
     */
    boost::optional<const std::string&> getName()
    {
        if (isNameSet())
            return getObjectInstance().getString(6717441ul);
        return boost::none;
    }

    /**
     * Get the value of name if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of name if set, otherwise the value of default passed in
     */
    const std::string& getName(const std::string& defaultValue)
    {
        return getName().get_value_or(defaultValue);
    }

    /**
     * Set name to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbp::SecGroupRule& setName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(6717441ul, newValue);
        return *this;
    }

    /**
     * Unset name in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbp::SecGroupRule& unsetName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(6717441ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether order has been set
     * @return true if order has been set
     */
    bool isOrderSet()
    {
        return getObjectInstance().isSet(6717442ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of order if it has been set.
     * @return the value of order or boost::none if not set
     */
    boost::optional<uint32_t> getOrder()
    {
        if (isOrderSet())
            return (uint32_t)getObjectInstance().getUInt64(6717442ul);
        return boost::none;
    }

    /**
     * Get the value of order if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of order if set, otherwise the value of default passed in
     */
    uint32_t getOrder(uint32_t defaultValue)
    {
        return getOrder().get_value_or(defaultValue);
    }

    /**
     * Set order to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbp::SecGroupRule& setOrder(uint32_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(6717442ul, newValue);
        return *this;
    }

    /**
     * Unset order in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbp::SecGroupRule& unsetOrder()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(6717442ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of SecGroupRule from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::SecGroupRule> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbp::SecGroupRule>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of SecGroupRule from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::SecGroupRule> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbp::SecGroupRule>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of SecGroupRule from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpContract/[gbpContractName]/GbpSubject/[gbpSubjectName]/GbpSecGroupRule/[gbpSecGroupRuleName]
     * 
     * @param framework the framework instance to use 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpContractName the value of gbpContractName,
     * a naming property for Contract
     * @param gbpSubjectName the value of gbpSubjectName,
     * a naming property for Subject
     * @param gbpSecGroupRuleName the value of gbpSecGroupRuleName,
     * a naming property for SecGroupRule
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::SecGroupRule> > resolveUnderPolicyUniversePolicySpaceGbpContractGbpSubject(
        opflex::ofcore::OFFramework& framework,
        const std::string& policySpaceName,
        const std::string& gbpContractName,
        const std::string& gbpSubjectName,
        const std::string& gbpSecGroupRuleName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PolicySpace").addElement(policySpaceName).addElement("GbpContract").addElement(gbpContractName).addElement("GbpSubject").addElement(gbpSubjectName).addElement("GbpSecGroupRule").addElement(gbpSecGroupRuleName).build());
    }

    /**
     * Retrieve an instance of SecGroupRule from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpContract/[gbpContractName]/GbpSubject/[gbpSubjectName]/GbpSecGroupRule/[gbpSecGroupRuleName]
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpContractName the value of gbpContractName,
     * a naming property for Contract
     * @param gbpSubjectName the value of gbpSubjectName,
     * a naming property for Subject
     * @param gbpSecGroupRuleName the value of gbpSecGroupRuleName,
     * a naming property for SecGroupRule
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::SecGroupRule> > resolveUnderPolicyUniversePolicySpaceGbpContractGbpSubject(
        const std::string& policySpaceName,
        const std::string& gbpContractName,
        const std::string& gbpSubjectName,
        const std::string& gbpSecGroupRuleName)
    {
        return resolveUnderPolicyUniversePolicySpaceGbpContractGbpSubject(opflex::ofcore::OFFramework::defaultInstance(),policySpaceName,gbpContractName,gbpSubjectName,gbpSecGroupRuleName);
    }

    /**
     * Retrieve an instance of SecGroupRule from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpSecGroup/[gbpSecGroupName]/GbpSecGroupSubject/[gbpSecGroupSubjectName]/GbpSecGroupRule/[gbpSecGroupRuleName]
     * 
     * @param framework the framework instance to use 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpSecGroupName the value of gbpSecGroupName,
     * a naming property for SecGroup
     * @param gbpSecGroupSubjectName the value of gbpSecGroupSubjectName,
     * a naming property for SecGroupSubject
     * @param gbpSecGroupRuleName the value of gbpSecGroupRuleName,
     * a naming property for SecGroupRule
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::SecGroupRule> > resolveUnderPolicyUniversePolicySpaceGbpSecGroupGbpSecGroupSubject(
        opflex::ofcore::OFFramework& framework,
        const std::string& policySpaceName,
        const std::string& gbpSecGroupName,
        const std::string& gbpSecGroupSubjectName,
        const std::string& gbpSecGroupRuleName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PolicySpace").addElement(policySpaceName).addElement("GbpSecGroup").addElement(gbpSecGroupName).addElement("GbpSecGroupSubject").addElement(gbpSecGroupSubjectName).addElement("GbpSecGroupRule").addElement(gbpSecGroupRuleName).build());
    }

    /**
     * Retrieve an instance of SecGroupRule from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpSecGroup/[gbpSecGroupName]/GbpSecGroupSubject/[gbpSecGroupSubjectName]/GbpSecGroupRule/[gbpSecGroupRuleName]
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpSecGroupName the value of gbpSecGroupName,
     * a naming property for SecGroup
     * @param gbpSecGroupSubjectName the value of gbpSecGroupSubjectName,
     * a naming property for SecGroupSubject
     * @param gbpSecGroupRuleName the value of gbpSecGroupRuleName,
     * a naming property for SecGroupRule
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::SecGroupRule> > resolveUnderPolicyUniversePolicySpaceGbpSecGroupGbpSecGroupSubject(
        const std::string& policySpaceName,
        const std::string& gbpSecGroupName,
        const std::string& gbpSecGroupSubjectName,
        const std::string& gbpSecGroupRuleName)
    {
        return resolveUnderPolicyUniversePolicySpaceGbpSecGroupGbpSecGroupSubject(opflex::ofcore::OFFramework::defaultInstance(),policySpaceName,gbpSecGroupName,gbpSecGroupSubjectName,gbpSecGroupRuleName);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpRuleToClassifierRSrcTargetClass the value of gbpRuleToClassifierRSrcTargetClass,
     * a naming property for RuleToClassifierRSrc
     * @param gbpRuleToClassifierRSrcTargetName the value of gbpRuleToClassifierRSrcTargetName,
     * a naming property for RuleToClassifierRSrc
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::RuleToClassifierRSrc> > resolveGbpRuleToClassifierRSrc(
        const std::string& gbpRuleToClassifierRSrcTargetName)
    {
        opflex::modb::class_id_t gbpRuleToClassifierRSrcTargetClass = 42;
        return modelgbp::gbp::RuleToClassifierRSrc::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpRuleToClassifierRSrc").addElement(gbpRuleToClassifierRSrcTargetClass).addElement(gbpRuleToClassifierRSrcTargetName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpRuleToClassifierRSrcTargetClass the value of gbpRuleToClassifierRSrcTargetClass,
     * a naming property for RuleToClassifierRSrc
     * @param gbpRuleToClassifierRSrcTargetName the value of gbpRuleToClassifierRSrcTargetName,
     * a naming property for RuleToClassifierRSrc
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::RuleToClassifierRSrc> addGbpRuleToClassifierRSrc(
        const std::string& gbpRuleToClassifierRSrcTargetName)
    {
        opflex::modb::class_id_t gbpRuleToClassifierRSrcTargetClass = 42;
        OF_SHARED_PTR<modelgbp::gbp::RuleToClassifierRSrc> result = addChild<modelgbp::gbp::RuleToClassifierRSrc>(
            CLASS_ID, getURI(), 2154201234ul, 146,
            opflex::modb::URIBuilder(getURI()).addElement("GbpRuleToClassifierRSrc").addElement(gbpRuleToClassifierRSrcTargetClass).addElement(gbpRuleToClassifierRSrcTargetName).build()
            );
        result->setTargetL24Classifier(opflex::modb::URI(gbpRuleToClassifierRSrcTargetName));
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::RuleToClassifierRSrc
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpRuleToClassifierRSrc(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::RuleToClassifierRSrc> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::RuleToClassifierRSrc>(
            getFramework(), CLASS_ID, getURI(), 2154201234ul, 146, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpRuleToActionRSrcTargetClass the value of gbpRuleToActionRSrcTargetClass,
     * a naming property for RuleToActionRSrc
     * @param gbpRuleToActionRSrcTargetName the value of gbpRuleToActionRSrcTargetName,
     * a naming property for RuleToActionRSrc
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::RuleToActionRSrc> > resolveGbpRuleToActionRSrc(
        const std::string& gbpRuleToActionRSrcTargetName)
    {
        opflex::modb::class_id_t gbpRuleToActionRSrcTargetClass = 141;
        return modelgbp::gbp::RuleToActionRSrc::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpRuleToActionRSrc").addElement(gbpRuleToActionRSrcTargetClass).addElement(gbpRuleToActionRSrcTargetName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpRuleToActionRSrcTargetClass the value of gbpRuleToActionRSrcTargetClass,
     * a naming property for RuleToActionRSrc
     * @param gbpRuleToActionRSrcTargetName the value of gbpRuleToActionRSrcTargetName,
     * a naming property for RuleToActionRSrc
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::RuleToActionRSrc> addGbpRuleToActionRSrc(
        const std::string& gbpRuleToActionRSrcTargetName)
    {
        opflex::modb::class_id_t gbpRuleToActionRSrcTargetClass = 141;
        OF_SHARED_PTR<modelgbp::gbp::RuleToActionRSrc> result = addChild<modelgbp::gbp::RuleToActionRSrc>(
            CLASS_ID, getURI(), 2154201237ul, 149,
            opflex::modb::URIBuilder(getURI()).addElement("GbpRuleToActionRSrc").addElement(gbpRuleToActionRSrcTargetClass).addElement(gbpRuleToActionRSrcTargetName).build()
            );
        result->setTargetAllowDenyAction(opflex::modb::URI(gbpRuleToActionRSrcTargetName));
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::RuleToActionRSrc
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpRuleToActionRSrc(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::RuleToActionRSrc> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::RuleToActionRSrc>(
            getFramework(), CLASS_ID, getURI(), 2154201237ul, 149, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpSecGroupRuleToRemoteAddressRSrcTargetClass the value of gbpSecGroupRuleToRemoteAddressRSrcTargetClass,
     * a naming property for SecGroupRuleToRemoteAddressRSrc
     * @param gbpSecGroupRuleToRemoteAddressRSrcTargetName the value of gbpSecGroupRuleToRemoteAddressRSrcTargetName,
     * a naming property for SecGroupRuleToRemoteAddressRSrc
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::SecGroupRuleToRemoteAddressRSrc> > resolveGbpSecGroupRuleToRemoteAddressRSrc(
        const std::string& gbpSecGroupRuleToRemoteAddressRSrcTargetName)
    {
        opflex::modb::class_id_t gbpSecGroupRuleToRemoteAddressRSrcTargetClass = 196;
        return modelgbp::gbp::SecGroupRuleToRemoteAddressRSrc::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpSecGroupRuleToRemoteAddressRSrc").addElement(gbpSecGroupRuleToRemoteAddressRSrcTargetClass).addElement(gbpSecGroupRuleToRemoteAddressRSrcTargetName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpSecGroupRuleToRemoteAddressRSrcTargetClass the value of gbpSecGroupRuleToRemoteAddressRSrcTargetClass,
     * a naming property for SecGroupRuleToRemoteAddressRSrc
     * @param gbpSecGroupRuleToRemoteAddressRSrcTargetName the value of gbpSecGroupRuleToRemoteAddressRSrcTargetName,
     * a naming property for SecGroupRuleToRemoteAddressRSrc
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::SecGroupRuleToRemoteAddressRSrc> addGbpSecGroupRuleToRemoteAddressRSrc(
        const std::string& gbpSecGroupRuleToRemoteAddressRSrcTargetName)
    {
        opflex::modb::class_id_t gbpSecGroupRuleToRemoteAddressRSrcTargetClass = 196;
        OF_SHARED_PTR<modelgbp::gbp::SecGroupRuleToRemoteAddressRSrc> result = addChild<modelgbp::gbp::SecGroupRuleToRemoteAddressRSrc>(
            CLASS_ID, getURI(), 2154201294ul, 206,
            opflex::modb::URIBuilder(getURI()).addElement("GbpSecGroupRuleToRemoteAddressRSrc").addElement(gbpSecGroupRuleToRemoteAddressRSrcTargetClass).addElement(gbpSecGroupRuleToRemoteAddressRSrcTargetName).build()
            );
        result->setTargetSubnets(opflex::modb::URI(gbpSecGroupRuleToRemoteAddressRSrcTargetName));
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::SecGroupRuleToRemoteAddressRSrc
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpSecGroupRuleToRemoteAddressRSrc(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::SecGroupRuleToRemoteAddressRSrc> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::SecGroupRuleToRemoteAddressRSrc>(
            getFramework(), CLASS_ID, getURI(), 2154201294ul, 206, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the SecGroupRule object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the SecGroupRule object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the SecGroupRule object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpContract/[gbpContractName]/GbpSubject/[gbpSubjectName]/GbpSecGroupRule/[gbpSecGroupRuleName]
     * 
     * @param framework the framework instance to use
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpContractName the value of gbpContractName,
     * a naming property for Contract
     * @param gbpSubjectName the value of gbpSubjectName,
     * a naming property for Subject
     * @param gbpSecGroupRuleName the value of gbpSecGroupRuleName,
     * a naming property for SecGroupRule
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderPolicyUniversePolicySpaceGbpContractGbpSubject(
        opflex::ofcore::OFFramework& framework,
        const std::string& policySpaceName,
        const std::string& gbpContractName,
        const std::string& gbpSubjectName,
        const std::string& gbpSecGroupRuleName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PolicySpace").addElement(policySpaceName).addElement("GbpContract").addElement(gbpContractName).addElement("GbpSubject").addElement(gbpSubjectName).addElement("GbpSecGroupRule").addElement(gbpSecGroupRuleName).build());
    }

    /**
     * Remove the SecGroupRule object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpContract/[gbpContractName]/GbpSubject/[gbpSubjectName]/GbpSecGroupRule/[gbpSecGroupRuleName]
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpContractName the value of gbpContractName,
     * a naming property for Contract
     * @param gbpSubjectName the value of gbpSubjectName,
     * a naming property for Subject
     * @param gbpSecGroupRuleName the value of gbpSecGroupRuleName,
     * a naming property for SecGroupRule
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderPolicyUniversePolicySpaceGbpContractGbpSubject(
        const std::string& policySpaceName,
        const std::string& gbpContractName,
        const std::string& gbpSubjectName,
        const std::string& gbpSecGroupRuleName)
    {
        removeUnderPolicyUniversePolicySpaceGbpContractGbpSubject(opflex::ofcore::OFFramework::defaultInstance(),policySpaceName,gbpContractName,gbpSubjectName,gbpSecGroupRuleName);
    }

    /**
     * Remove the SecGroupRule object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpSecGroup/[gbpSecGroupName]/GbpSecGroupSubject/[gbpSecGroupSubjectName]/GbpSecGroupRule/[gbpSecGroupRuleName]
     * 
     * @param framework the framework instance to use
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpSecGroupName the value of gbpSecGroupName,
     * a naming property for SecGroup
     * @param gbpSecGroupSubjectName the value of gbpSecGroupSubjectName,
     * a naming property for SecGroupSubject
     * @param gbpSecGroupRuleName the value of gbpSecGroupRuleName,
     * a naming property for SecGroupRule
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderPolicyUniversePolicySpaceGbpSecGroupGbpSecGroupSubject(
        opflex::ofcore::OFFramework& framework,
        const std::string& policySpaceName,
        const std::string& gbpSecGroupName,
        const std::string& gbpSecGroupSubjectName,
        const std::string& gbpSecGroupRuleName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PolicySpace").addElement(policySpaceName).addElement("GbpSecGroup").addElement(gbpSecGroupName).addElement("GbpSecGroupSubject").addElement(gbpSecGroupSubjectName).addElement("GbpSecGroupRule").addElement(gbpSecGroupRuleName).build());
    }

    /**
     * Remove the SecGroupRule object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpSecGroup/[gbpSecGroupName]/GbpSecGroupSubject/[gbpSecGroupSubjectName]/GbpSecGroupRule/[gbpSecGroupRuleName]
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpSecGroupName the value of gbpSecGroupName,
     * a naming property for SecGroup
     * @param gbpSecGroupSubjectName the value of gbpSecGroupSubjectName,
     * a naming property for SecGroupSubject
     * @param gbpSecGroupRuleName the value of gbpSecGroupRuleName,
     * a naming property for SecGroupRule
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderPolicyUniversePolicySpaceGbpSecGroupGbpSecGroupSubject(
        const std::string& policySpaceName,
        const std::string& gbpSecGroupName,
        const std::string& gbpSecGroupSubjectName,
        const std::string& gbpSecGroupRuleName)
    {
        removeUnderPolicyUniversePolicySpaceGbpSecGroupGbpSecGroupSubject(opflex::ofcore::OFFramework::defaultInstance(),policySpaceName,gbpSecGroupName,gbpSecGroupSubjectName,gbpSecGroupRuleName);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of SecGroupRule.
     * This should not typically be called from user code.
     */
    SecGroupRule(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class SecGroupRule

} // namespace gbp
} // namespace modelgbp
#endif // GI_GBP_SECGROUPRULE_HPP
