/**
 * 
 * SOME COPYRIGHT
 * 
 * Subnets.hpp
 * 
 * generated Subnets.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_GBP_SUBNETS_HPP
#define GI_GBP_SUBNETS_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(gbp/EpGroupFromSubnetsRTgt)
 */
#include "modelgbp/gbp/EpGroupFromSubnetsRTgt.hpp"
/*
 * contains: item:mclass(gbp/RoutingDomainFromIntSubnetsRTgt)
 */
#include "modelgbp/gbp/RoutingDomainFromIntSubnetsRTgt.hpp"
/*
 * contains: item:mclass(gbp/Subnet)
 */
#include "modelgbp/gbp/Subnet.hpp"
/*
 * contains: item:mclass(gbp/ForwardingBehavioralGroupFromSubnetsRTgt)
 */
#include "modelgbp/gbp/ForwardingBehavioralGroupFromSubnetsRTgt.hpp"
/*
 * contains: item:mclass(gbp/SecGroupRuleFromRemoteAddressRTgt)
 */
#include "modelgbp/gbp/SecGroupRuleFromRemoteAddressRTgt.hpp"

namespace modelgbp {
namespace gbp {

class Subnets
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for Subnets
     */
    static const opflex::modb::class_id_t CLASS_ID = 196;

    /**
     * Check whether name has been set
     * @return true if name has been set
     */
    bool isNameSet()
    {
        return getObjectInstance().isSet(6422529ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of name if it has been set.
     * @return the value of name or boost::none if not set
     */
    boost::optional<const std::string&> getName()
    {
        if (isNameSet())
            return getObjectInstance().getString(6422529ul);
        return boost::none;
    }

    /**
     * Get the value of name if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of name if set, otherwise the value of default passed in
     */
    const std::string& getName(const std::string& defaultValue)
    {
        return getName().get_value_or(defaultValue);
    }

    /**
     * Set name to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbp::Subnets& setName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(6422529ul, newValue);
        return *this;
    }

    /**
     * Unset name in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbp::Subnets& unsetName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(6422529ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of Subnets from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::Subnets> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbp::Subnets>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of Subnets from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::Subnets> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbp::Subnets>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of Subnets from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpSubnets/[gbpSubnetsName]
     * 
     * @param framework the framework instance to use 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpSubnetsName the value of gbpSubnetsName,
     * a naming property for Subnets
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::Subnets> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& policySpaceName,
        const std::string& gbpSubnetsName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PolicySpace").addElement(policySpaceName).addElement("GbpSubnets").addElement(gbpSubnetsName).build());
    }

    /**
     * Retrieve an instance of Subnets from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpSubnets/[gbpSubnetsName]
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpSubnetsName the value of gbpSubnetsName,
     * a naming property for Subnets
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbp::Subnets> > resolve(
        const std::string& policySpaceName,
        const std::string& gbpSubnetsName)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),policySpaceName,gbpSubnetsName);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpEpGroupFromSubnetsRTgtSource the value of gbpEpGroupFromSubnetsRTgtSource,
     * a naming property for EpGroupFromSubnetsRTgt
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::EpGroupFromSubnetsRTgt> > resolveGbpEpGroupFromSubnetsRTgt(
        const std::string& gbpEpGroupFromSubnetsRTgtSource)
    {
        return modelgbp::gbp::EpGroupFromSubnetsRTgt::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpEpGroupFromSubnetsRTgt").addElement(gbpEpGroupFromSubnetsRTgtSource).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpEpGroupFromSubnetsRTgtSource the value of gbpEpGroupFromSubnetsRTgtSource,
     * a naming property for EpGroupFromSubnetsRTgt
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::EpGroupFromSubnetsRTgt> addGbpEpGroupFromSubnetsRTgt(
        const std::string& gbpEpGroupFromSubnetsRTgtSource)
    {
        OF_SHARED_PTR<modelgbp::gbp::EpGroupFromSubnetsRTgt> result = addChild<modelgbp::gbp::EpGroupFromSubnetsRTgt>(
            CLASS_ID, getURI(), 2153906342ul, 166,
            opflex::modb::URIBuilder(getURI()).addElement("GbpEpGroupFromSubnetsRTgt").addElement(gbpEpGroupFromSubnetsRTgtSource).build()
            );
        result->setSource(gbpEpGroupFromSubnetsRTgtSource);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::EpGroupFromSubnetsRTgt
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpEpGroupFromSubnetsRTgt(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::EpGroupFromSubnetsRTgt> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::EpGroupFromSubnetsRTgt>(
            getFramework(), CLASS_ID, getURI(), 2153906342ul, 166, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpRoutingDomainFromIntSubnetsRTgtSource the value of gbpRoutingDomainFromIntSubnetsRTgtSource,
     * a naming property for RoutingDomainFromIntSubnetsRTgt
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::RoutingDomainFromIntSubnetsRTgt> > resolveGbpRoutingDomainFromIntSubnetsRTgt(
        const std::string& gbpRoutingDomainFromIntSubnetsRTgtSource)
    {
        return modelgbp::gbp::RoutingDomainFromIntSubnetsRTgt::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpRoutingDomainFromIntSubnetsRTgt").addElement(gbpRoutingDomainFromIntSubnetsRTgtSource).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpRoutingDomainFromIntSubnetsRTgtSource the value of gbpRoutingDomainFromIntSubnetsRTgtSource,
     * a naming property for RoutingDomainFromIntSubnetsRTgt
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::RoutingDomainFromIntSubnetsRTgt> addGbpRoutingDomainFromIntSubnetsRTgt(
        const std::string& gbpRoutingDomainFromIntSubnetsRTgtSource)
    {
        OF_SHARED_PTR<modelgbp::gbp::RoutingDomainFromIntSubnetsRTgt> result = addChild<modelgbp::gbp::RoutingDomainFromIntSubnetsRTgt>(
            CLASS_ID, getURI(), 2153906368ul, 192,
            opflex::modb::URIBuilder(getURI()).addElement("GbpRoutingDomainFromIntSubnetsRTgt").addElement(gbpRoutingDomainFromIntSubnetsRTgtSource).build()
            );
        result->setSource(gbpRoutingDomainFromIntSubnetsRTgtSource);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::RoutingDomainFromIntSubnetsRTgt
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpRoutingDomainFromIntSubnetsRTgt(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::RoutingDomainFromIntSubnetsRTgt> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::RoutingDomainFromIntSubnetsRTgt>(
            getFramework(), CLASS_ID, getURI(), 2153906368ul, 192, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpSubnetName the value of gbpSubnetName,
     * a naming property for Subnet
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::Subnet> > resolveGbpSubnet(
        const std::string& gbpSubnetName)
    {
        return modelgbp::gbp::Subnet::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpSubnet").addElement(gbpSubnetName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpSubnetName the value of gbpSubnetName,
     * a naming property for Subnet
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::Subnet> addGbpSubnet(
        const std::string& gbpSubnetName)
    {
        OF_SHARED_PTR<modelgbp::gbp::Subnet> result = addChild<modelgbp::gbp::Subnet>(
            CLASS_ID, getURI(), 2153906371ul, 195,
            opflex::modb::URIBuilder(getURI()).addElement("GbpSubnet").addElement(gbpSubnetName).build()
            );
        result->setName(gbpSubnetName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::Subnet
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpSubnet(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::Subnet> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::Subnet>(
            getFramework(), CLASS_ID, getURI(), 2153906371ul, 195, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpForwardingBehavioralGroupFromSubnetsRTgtSource the value of gbpForwardingBehavioralGroupFromSubnetsRTgtSource,
     * a naming property for ForwardingBehavioralGroupFromSubnetsRTgt
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::ForwardingBehavioralGroupFromSubnetsRTgt> > resolveGbpForwardingBehavioralGroupFromSubnetsRTgt(
        const std::string& gbpForwardingBehavioralGroupFromSubnetsRTgtSource)
    {
        return modelgbp::gbp::ForwardingBehavioralGroupFromSubnetsRTgt::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpForwardingBehavioralGroupFromSubnetsRTgt").addElement(gbpForwardingBehavioralGroupFromSubnetsRTgtSource).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpForwardingBehavioralGroupFromSubnetsRTgtSource the value of gbpForwardingBehavioralGroupFromSubnetsRTgtSource,
     * a naming property for ForwardingBehavioralGroupFromSubnetsRTgt
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::ForwardingBehavioralGroupFromSubnetsRTgt> addGbpForwardingBehavioralGroupFromSubnetsRTgt(
        const std::string& gbpForwardingBehavioralGroupFromSubnetsRTgtSource)
    {
        OF_SHARED_PTR<modelgbp::gbp::ForwardingBehavioralGroupFromSubnetsRTgt> result = addChild<modelgbp::gbp::ForwardingBehavioralGroupFromSubnetsRTgt>(
            CLASS_ID, getURI(), 2153906376ul, 200,
            opflex::modb::URIBuilder(getURI()).addElement("GbpForwardingBehavioralGroupFromSubnetsRTgt").addElement(gbpForwardingBehavioralGroupFromSubnetsRTgtSource).build()
            );
        result->setSource(gbpForwardingBehavioralGroupFromSubnetsRTgtSource);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::ForwardingBehavioralGroupFromSubnetsRTgt
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpForwardingBehavioralGroupFromSubnetsRTgt(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::ForwardingBehavioralGroupFromSubnetsRTgt> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::ForwardingBehavioralGroupFromSubnetsRTgt>(
            getFramework(), CLASS_ID, getURI(), 2153906376ul, 200, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpSecGroupRuleFromRemoteAddressRTgtSource the value of gbpSecGroupRuleFromRemoteAddressRTgtSource,
     * a naming property for SecGroupRuleFromRemoteAddressRTgt
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::SecGroupRuleFromRemoteAddressRTgt> > resolveGbpSecGroupRuleFromRemoteAddressRTgt(
        const std::string& gbpSecGroupRuleFromRemoteAddressRTgtSource)
    {
        return modelgbp::gbp::SecGroupRuleFromRemoteAddressRTgt::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpSecGroupRuleFromRemoteAddressRTgt").addElement(gbpSecGroupRuleFromRemoteAddressRTgtSource).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpSecGroupRuleFromRemoteAddressRTgtSource the value of gbpSecGroupRuleFromRemoteAddressRTgtSource,
     * a naming property for SecGroupRuleFromRemoteAddressRTgt
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::SecGroupRuleFromRemoteAddressRTgt> addGbpSecGroupRuleFromRemoteAddressRTgt(
        const std::string& gbpSecGroupRuleFromRemoteAddressRTgtSource)
    {
        OF_SHARED_PTR<modelgbp::gbp::SecGroupRuleFromRemoteAddressRTgt> result = addChild<modelgbp::gbp::SecGroupRuleFromRemoteAddressRTgt>(
            CLASS_ID, getURI(), 2153906383ul, 207,
            opflex::modb::URIBuilder(getURI()).addElement("GbpSecGroupRuleFromRemoteAddressRTgt").addElement(gbpSecGroupRuleFromRemoteAddressRTgtSource).build()
            );
        result->setSource(gbpSecGroupRuleFromRemoteAddressRTgtSource);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::SecGroupRuleFromRemoteAddressRTgt
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpSecGroupRuleFromRemoteAddressRTgt(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::SecGroupRuleFromRemoteAddressRTgt> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::SecGroupRuleFromRemoteAddressRTgt>(
            getFramework(), CLASS_ID, getURI(), 2153906383ul, 207, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the Subnets object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the Subnets object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the Subnets object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpSubnets/[gbpSubnetsName]
     * 
     * @param framework the framework instance to use
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpSubnetsName the value of gbpSubnetsName,
     * a naming property for Subnets
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& policySpaceName,
        const std::string& gbpSubnetsName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PolicySpace").addElement(policySpaceName).addElement("GbpSubnets").addElement(gbpSubnetsName).build());
    }

    /**
     * Remove the Subnets object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpSubnets/[gbpSubnetsName]
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpSubnetsName the value of gbpSubnetsName,
     * a naming property for Subnets
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& policySpaceName,
        const std::string& gbpSubnetsName)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),policySpaceName,gbpSubnetsName);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of Subnets.
     * This should not typically be called from user code.
     */
    Subnets(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class Subnets

} // namespace gbp
} // namespace modelgbp
#endif // GI_GBP_SUBNETS_HPP
