/**
 * 
 * SOME COPYRIGHT
 * 
 * Attestation.hpp
 * 
 * generated Attestation.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_GBPE_ATTESTATION_HPP
#define GI_GBPE_ATTESTATION_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"

namespace modelgbp {
namespace gbpe {

class Attestation
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for Attestation
     */
    static const opflex::modb::class_id_t CLASS_ID = 47;

    /**
     * Check whether name has been set
     * @return true if name has been set
     */
    bool isNameSet()
    {
        return getObjectInstance().isSet(1540097ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of name if it has been set.
     * @return the value of name or boost::none if not set
     */
    boost::optional<const std::string&> getName()
    {
        if (isNameSet())
            return getObjectInstance().getString(1540097ul);
        return boost::none;
    }

    /**
     * Get the value of name if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of name if set, otherwise the value of default passed in
     */
    const std::string& getName(const std::string& defaultValue)
    {
        return getName().get_value_or(defaultValue);
    }

    /**
     * Set name to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::Attestation& setName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(1540097ul, newValue);
        return *this;
    }

    /**
     * Unset name in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::Attestation& unsetName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1540097ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether validator has been set
     * @return true if validator has been set
     */
    bool isValidatorSet()
    {
        return getObjectInstance().isSet(1540098ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of validator if it has been set.
     * @return the value of validator or boost::none if not set
     */
    boost::optional<const std::string&> getValidator()
    {
        if (isValidatorSet())
            return getObjectInstance().getString(1540098ul);
        return boost::none;
    }

    /**
     * Get the value of validator if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of validator if set, otherwise the value of default passed in
     */
    const std::string& getValidator(const std::string& defaultValue)
    {
        return getValidator().get_value_or(defaultValue);
    }

    /**
     * Set validator to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::Attestation& setValidator(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(1540098ul, newValue);
        return *this;
    }

    /**
     * Unset validator in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::Attestation& unsetValidator()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1540098ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether validatorMac has been set
     * @return true if validatorMac has been set
     */
    bool isValidatorMacSet()
    {
        return getObjectInstance().isSet(1540099ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of validatorMac if it has been set.
     * @return the value of validatorMac or boost::none if not set
     */
    boost::optional<const std::string&> getValidatorMac()
    {
        if (isValidatorMacSet())
            return getObjectInstance().getString(1540099ul);
        return boost::none;
    }

    /**
     * Get the value of validatorMac if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of validatorMac if set, otherwise the value of default passed in
     */
    const std::string& getValidatorMac(const std::string& defaultValue)
    {
        return getValidatorMac().get_value_or(defaultValue);
    }

    /**
     * Set validatorMac to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::Attestation& setValidatorMac(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(1540099ul, newValue);
        return *this;
    }

    /**
     * Unset validatorMac in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::Attestation& unsetValidatorMac()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1540099ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of Attestation from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::Attestation> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::Attestation>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of Attestation from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::Attestation> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::Attestation>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of Attestation from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeVMUniverse/GbpeVMEp/[gbpeVMEpUuid]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param framework the framework instance to use 
     * @param gbpeVMEpUuid the value of gbpeVMEpUuid,
     * a naming property for VMEp
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::Attestation> > resolveUnderGbpeVMUniverseGbpeVMEp(
        opflex::ofcore::OFFramework& framework,
        const std::string& gbpeVMEpUuid,
        const std::string& gbpeAttestationName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("GbpeVMUniverse").addElement("GbpeVMEp").addElement(gbpeVMEpUuid).addElement("GbpeAttestation").addElement(gbpeAttestationName).build());
    }

    /**
     * Retrieve an instance of Attestation from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeVMUniverse/GbpeVMEp/[gbpeVMEpUuid]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param gbpeVMEpUuid the value of gbpeVMEpUuid,
     * a naming property for VMEp
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::Attestation> > resolveUnderGbpeVMUniverseGbpeVMEp(
        const std::string& gbpeVMEpUuid,
        const std::string& gbpeAttestationName)
    {
        return resolveUnderGbpeVMUniverseGbpeVMEp(opflex::ofcore::OFFramework::defaultInstance(),gbpeVMEpUuid,gbpeAttestationName);
    }

    /**
     * Retrieve an instance of Attestation from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeTunnelEpUniverse/GbpeTunnelEp/[gbpeTunnelEpUuid]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param framework the framework instance to use 
     * @param gbpeTunnelEpUuid the value of gbpeTunnelEpUuid,
     * a naming property for TunnelEp
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::Attestation> > resolveUnderGbpeTunnelEpUniverseGbpeTunnelEp(
        opflex::ofcore::OFFramework& framework,
        const std::string& gbpeTunnelEpUuid,
        const std::string& gbpeAttestationName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("GbpeTunnelEpUniverse").addElement("GbpeTunnelEp").addElement(gbpeTunnelEpUuid).addElement("GbpeAttestation").addElement(gbpeAttestationName).build());
    }

    /**
     * Retrieve an instance of Attestation from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeTunnelEpUniverse/GbpeTunnelEp/[gbpeTunnelEpUuid]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param gbpeTunnelEpUuid the value of gbpeTunnelEpUuid,
     * a naming property for TunnelEp
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::Attestation> > resolveUnderGbpeTunnelEpUniverseGbpeTunnelEp(
        const std::string& gbpeTunnelEpUuid,
        const std::string& gbpeAttestationName)
    {
        return resolveUnderGbpeTunnelEpUniverseGbpeTunnelEp(opflex::ofcore::OFFramework::defaultInstance(),gbpeTunnelEpUuid,gbpeAttestationName);
    }

    /**
     * Retrieve an instance of Attestation from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param framework the framework instance to use 
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::Attestation> > resolveUnderEprL2UniverseEprL2Ep(
        opflex::ofcore::OFFramework& framework,
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac,
        const std::string& gbpeAttestationName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("EprL2Universe").addElement("EprL2Ep").addElement(eprL2EpContext).addElement(eprL2EpMac).addElement("GbpeAttestation").addElement(gbpeAttestationName).build());
    }

    /**
     * Retrieve an instance of Attestation from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::Attestation> > resolveUnderEprL2UniverseEprL2Ep(
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac,
        const std::string& gbpeAttestationName)
    {
        return resolveUnderEprL2UniverseEprL2Ep(opflex::ofcore::OFFramework::defaultInstance(),eprL2EpContext,eprL2EpMac,gbpeAttestationName);
    }

    /**
     * Retrieve an instance of Attestation from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]/EprL3Net/[eprL3NetIp]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param framework the framework instance to use 
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @param eprL3NetIp the value of eprL3NetIp,
     * a naming property for L3Net
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::Attestation> > resolveUnderEprL2UniverseEprL2EpEprL3Net(
        opflex::ofcore::OFFramework& framework,
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac,
        const std::string& eprL3NetIp,
        const std::string& gbpeAttestationName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("EprL2Universe").addElement("EprL2Ep").addElement(eprL2EpContext).addElement(eprL2EpMac).addElement("EprL3Net").addElement(eprL3NetIp).addElement("GbpeAttestation").addElement(gbpeAttestationName).build());
    }

    /**
     * Retrieve an instance of Attestation from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]/EprL3Net/[eprL3NetIp]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @param eprL3NetIp the value of eprL3NetIp,
     * a naming property for L3Net
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::Attestation> > resolveUnderEprL2UniverseEprL2EpEprL3Net(
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac,
        const std::string& eprL3NetIp,
        const std::string& gbpeAttestationName)
    {
        return resolveUnderEprL2UniverseEprL2EpEprL3Net(opflex::ofcore::OFFramework::defaultInstance(),eprL2EpContext,eprL2EpMac,eprL3NetIp,gbpeAttestationName);
    }

    /**
     * Retrieve an instance of Attestation from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EprL3Universe/EprL3Ep/[eprL3EpContext]/[eprL3EpIp]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param framework the framework instance to use 
     * @param eprL3EpContext the value of eprL3EpContext,
     * a naming property for L3Ep
     * @param eprL3EpIp the value of eprL3EpIp,
     * a naming property for L3Ep
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::Attestation> > resolveUnderEprL3UniverseEprL3Ep(
        opflex::ofcore::OFFramework& framework,
        const std::string& eprL3EpContext,
        const std::string& eprL3EpIp,
        const std::string& gbpeAttestationName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("EprL3Universe").addElement("EprL3Ep").addElement(eprL3EpContext).addElement(eprL3EpIp).addElement("GbpeAttestation").addElement(gbpeAttestationName).build());
    }

    /**
     * Retrieve an instance of Attestation from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EprL3Universe/EprL3Ep/[eprL3EpContext]/[eprL3EpIp]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param eprL3EpContext the value of eprL3EpContext,
     * a naming property for L3Ep
     * @param eprL3EpIp the value of eprL3EpIp,
     * a naming property for L3Ep
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::Attestation> > resolveUnderEprL3UniverseEprL3Ep(
        const std::string& eprL3EpContext,
        const std::string& eprL3EpIp,
        const std::string& gbpeAttestationName)
    {
        return resolveUnderEprL3UniverseEprL3Ep(opflex::ofcore::OFFramework::defaultInstance(),eprL3EpContext,eprL3EpIp,gbpeAttestationName);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the Attestation object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the Attestation object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the Attestation object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeVMUniverse/GbpeVMEp/[gbpeVMEpUuid]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param framework the framework instance to use
     * @param gbpeVMEpUuid the value of gbpeVMEpUuid,
     * a naming property for VMEp
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderGbpeVMUniverseGbpeVMEp(
        opflex::ofcore::OFFramework& framework,
        const std::string& gbpeVMEpUuid,
        const std::string& gbpeAttestationName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("GbpeVMUniverse").addElement("GbpeVMEp").addElement(gbpeVMEpUuid).addElement("GbpeAttestation").addElement(gbpeAttestationName).build());
    }

    /**
     * Remove the Attestation object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeVMUniverse/GbpeVMEp/[gbpeVMEpUuid]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param gbpeVMEpUuid the value of gbpeVMEpUuid,
     * a naming property for VMEp
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderGbpeVMUniverseGbpeVMEp(
        const std::string& gbpeVMEpUuid,
        const std::string& gbpeAttestationName)
    {
        removeUnderGbpeVMUniverseGbpeVMEp(opflex::ofcore::OFFramework::defaultInstance(),gbpeVMEpUuid,gbpeAttestationName);
    }

    /**
     * Remove the Attestation object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeTunnelEpUniverse/GbpeTunnelEp/[gbpeTunnelEpUuid]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param framework the framework instance to use
     * @param gbpeTunnelEpUuid the value of gbpeTunnelEpUuid,
     * a naming property for TunnelEp
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderGbpeTunnelEpUniverseGbpeTunnelEp(
        opflex::ofcore::OFFramework& framework,
        const std::string& gbpeTunnelEpUuid,
        const std::string& gbpeAttestationName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("GbpeTunnelEpUniverse").addElement("GbpeTunnelEp").addElement(gbpeTunnelEpUuid).addElement("GbpeAttestation").addElement(gbpeAttestationName).build());
    }

    /**
     * Remove the Attestation object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeTunnelEpUniverse/GbpeTunnelEp/[gbpeTunnelEpUuid]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param gbpeTunnelEpUuid the value of gbpeTunnelEpUuid,
     * a naming property for TunnelEp
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderGbpeTunnelEpUniverseGbpeTunnelEp(
        const std::string& gbpeTunnelEpUuid,
        const std::string& gbpeAttestationName)
    {
        removeUnderGbpeTunnelEpUniverseGbpeTunnelEp(opflex::ofcore::OFFramework::defaultInstance(),gbpeTunnelEpUuid,gbpeAttestationName);
    }

    /**
     * Remove the Attestation object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param framework the framework instance to use
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderEprL2UniverseEprL2Ep(
        opflex::ofcore::OFFramework& framework,
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac,
        const std::string& gbpeAttestationName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("EprL2Universe").addElement("EprL2Ep").addElement(eprL2EpContext).addElement(eprL2EpMac).addElement("GbpeAttestation").addElement(gbpeAttestationName).build());
    }

    /**
     * Remove the Attestation object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderEprL2UniverseEprL2Ep(
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac,
        const std::string& gbpeAttestationName)
    {
        removeUnderEprL2UniverseEprL2Ep(opflex::ofcore::OFFramework::defaultInstance(),eprL2EpContext,eprL2EpMac,gbpeAttestationName);
    }

    /**
     * Remove the Attestation object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]/EprL3Net/[eprL3NetIp]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param framework the framework instance to use
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @param eprL3NetIp the value of eprL3NetIp,
     * a naming property for L3Net
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderEprL2UniverseEprL2EpEprL3Net(
        opflex::ofcore::OFFramework& framework,
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac,
        const std::string& eprL3NetIp,
        const std::string& gbpeAttestationName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("EprL2Universe").addElement("EprL2Ep").addElement(eprL2EpContext).addElement(eprL2EpMac).addElement("EprL3Net").addElement(eprL3NetIp).addElement("GbpeAttestation").addElement(gbpeAttestationName).build());
    }

    /**
     * Remove the Attestation object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]/EprL3Net/[eprL3NetIp]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @param eprL3NetIp the value of eprL3NetIp,
     * a naming property for L3Net
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderEprL2UniverseEprL2EpEprL3Net(
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac,
        const std::string& eprL3NetIp,
        const std::string& gbpeAttestationName)
    {
        removeUnderEprL2UniverseEprL2EpEprL3Net(opflex::ofcore::OFFramework::defaultInstance(),eprL2EpContext,eprL2EpMac,eprL3NetIp,gbpeAttestationName);
    }

    /**
     * Remove the Attestation object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EprL3Universe/EprL3Ep/[eprL3EpContext]/[eprL3EpIp]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param framework the framework instance to use
     * @param eprL3EpContext the value of eprL3EpContext,
     * a naming property for L3Ep
     * @param eprL3EpIp the value of eprL3EpIp,
     * a naming property for L3Ep
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderEprL3UniverseEprL3Ep(
        opflex::ofcore::OFFramework& framework,
        const std::string& eprL3EpContext,
        const std::string& eprL3EpIp,
        const std::string& gbpeAttestationName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("EprL3Universe").addElement("EprL3Ep").addElement(eprL3EpContext).addElement(eprL3EpIp).addElement("GbpeAttestation").addElement(gbpeAttestationName).build());
    }

    /**
     * Remove the Attestation object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EprL3Universe/EprL3Ep/[eprL3EpContext]/[eprL3EpIp]/GbpeAttestation/[gbpeAttestationName]
     * 
     * @param eprL3EpContext the value of eprL3EpContext,
     * a naming property for L3Ep
     * @param eprL3EpIp the value of eprL3EpIp,
     * a naming property for L3Ep
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderEprL3UniverseEprL3Ep(
        const std::string& eprL3EpContext,
        const std::string& eprL3EpIp,
        const std::string& gbpeAttestationName)
    {
        removeUnderEprL3UniverseEprL3Ep(opflex::ofcore::OFFramework::defaultInstance(),eprL3EpContext,eprL3EpIp,gbpeAttestationName);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of Attestation.
     * This should not typically be called from user code.
     */
    Attestation(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class Attestation

} // namespace gbpe
} // namespace modelgbp
#endif // GI_GBPE_ATTESTATION_HPP
