/**
 * 
 * SOME COPYRIGHT
 * 
 * EpAttribute.hpp
 * 
 * generated EpAttribute.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_GBPE_EPATTRIBUTE_HPP
#define GI_GBPE_EPATTRIBUTE_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"

namespace modelgbp {
namespace gbpe {

class EpAttribute
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for EpAttribute
     */
    static const opflex::modb::class_id_t CLASS_ID = 37;

    /**
     * Check whether name has been set
     * @return true if name has been set
     */
    bool isNameSet()
    {
        return getObjectInstance().isSet(1212417ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of name if it has been set.
     * @return the value of name or boost::none if not set
     */
    boost::optional<const std::string&> getName()
    {
        if (isNameSet())
            return getObjectInstance().getString(1212417ul);
        return boost::none;
    }

    /**
     * Get the value of name if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of name if set, otherwise the value of default passed in
     */
    const std::string& getName(const std::string& defaultValue)
    {
        return getName().get_value_or(defaultValue);
    }

    /**
     * Set name to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::EpAttribute& setName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(1212417ul, newValue);
        return *this;
    }

    /**
     * Unset name in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::EpAttribute& unsetName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1212417ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether value has been set
     * @return true if value has been set
     */
    bool isValueSet()
    {
        return getObjectInstance().isSet(1212418ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of value if it has been set.
     * @return the value of value or boost::none if not set
     */
    boost::optional<const std::string&> getValue()
    {
        if (isValueSet())
            return getObjectInstance().getString(1212418ul);
        return boost::none;
    }

    /**
     * Get the value of value if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of value if set, otherwise the value of default passed in
     */
    const std::string& getValue(const std::string& defaultValue)
    {
        return getValue().get_value_or(defaultValue);
    }

    /**
     * Set value to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::EpAttribute& setValue(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(1212418ul, newValue);
        return *this;
    }

    /**
     * Unset value in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::EpAttribute& unsetValue()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1212418ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of EpAttribute from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpAttribute> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::EpAttribute>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of EpAttribute from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpAttribute> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::EpAttribute>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of EpAttribute from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeVMUniverse/GbpeEpAttributeSet/[gbpeEpAttributeSetUuid]/GbpeEpAttribute/[gbpeEpAttributeName]
     * 
     * @param framework the framework instance to use 
     * @param gbpeEpAttributeSetUuid the value of gbpeEpAttributeSetUuid,
     * a naming property for EpAttributeSet
     * @param gbpeEpAttributeName the value of gbpeEpAttributeName,
     * a naming property for EpAttribute
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpAttribute> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& gbpeEpAttributeSetUuid,
        const std::string& gbpeEpAttributeName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("GbpeVMUniverse").addElement("GbpeEpAttributeSet").addElement(gbpeEpAttributeSetUuid).addElement("GbpeEpAttribute").addElement(gbpeEpAttributeName).build());
    }

    /**
     * Retrieve an instance of EpAttribute from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeVMUniverse/GbpeEpAttributeSet/[gbpeEpAttributeSetUuid]/GbpeEpAttribute/[gbpeEpAttributeName]
     * 
     * @param gbpeEpAttributeSetUuid the value of gbpeEpAttributeSetUuid,
     * a naming property for EpAttributeSet
     * @param gbpeEpAttributeName the value of gbpeEpAttributeName,
     * a naming property for EpAttribute
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpAttribute> > resolve(
        const std::string& gbpeEpAttributeSetUuid,
        const std::string& gbpeEpAttributeName)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),gbpeEpAttributeSetUuid,gbpeEpAttributeName);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the EpAttribute object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the EpAttribute object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the EpAttribute object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeVMUniverse/GbpeEpAttributeSet/[gbpeEpAttributeSetUuid]/GbpeEpAttribute/[gbpeEpAttributeName]
     * 
     * @param framework the framework instance to use
     * @param gbpeEpAttributeSetUuid the value of gbpeEpAttributeSetUuid,
     * a naming property for EpAttributeSet
     * @param gbpeEpAttributeName the value of gbpeEpAttributeName,
     * a naming property for EpAttribute
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& gbpeEpAttributeSetUuid,
        const std::string& gbpeEpAttributeName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("GbpeVMUniverse").addElement("GbpeEpAttributeSet").addElement(gbpeEpAttributeSetUuid).addElement("GbpeEpAttribute").addElement(gbpeEpAttributeName).build());
    }

    /**
     * Remove the EpAttribute object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeVMUniverse/GbpeEpAttributeSet/[gbpeEpAttributeSetUuid]/GbpeEpAttribute/[gbpeEpAttributeName]
     * 
     * @param gbpeEpAttributeSetUuid the value of gbpeEpAttributeSetUuid,
     * a naming property for EpAttributeSet
     * @param gbpeEpAttributeName the value of gbpeEpAttributeName,
     * a naming property for EpAttribute
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& gbpeEpAttributeSetUuid,
        const std::string& gbpeEpAttributeName)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),gbpeEpAttributeSetUuid,gbpeEpAttributeName);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of EpAttribute.
     * This should not typically be called from user code.
     */
    EpAttribute(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class EpAttribute

} // namespace gbpe
} // namespace modelgbp
#endif // GI_GBPE_EPATTRIBUTE_HPP
