/**
 * 
 * SOME COPYRIGHT
 * 
 * EpAttributeSet.hpp
 * 
 * generated EpAttributeSet.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_GBPE_EPATTRIBUTESET_HPP
#define GI_GBPE_EPATTRIBUTESET_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(gbpe/EpgMappingCtxFromAttrSetRTgt)
 */
#include "modelgbp/gbpe/EpgMappingCtxFromAttrSetRTgt.hpp"
/*
 * contains: item:mclass(gbpe/EpAttribute)
 */
#include "modelgbp/gbpe/EpAttribute.hpp"

namespace modelgbp {
namespace gbpe {

class EpAttributeSet
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for EpAttributeSet
     */
    static const opflex::modb::class_id_t CLASS_ID = 36;

    /**
     * Check whether uuid has been set
     * @return true if uuid has been set
     */
    bool isUuidSet()
    {
        return getObjectInstance().isSet(1179649ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of uuid if it has been set.
     * @return the value of uuid or boost::none if not set
     */
    boost::optional<const std::string&> getUuid()
    {
        if (isUuidSet())
            return getObjectInstance().getString(1179649ul);
        return boost::none;
    }

    /**
     * Get the value of uuid if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of uuid if set, otherwise the value of default passed in
     */
    const std::string& getUuid(const std::string& defaultValue)
    {
        return getUuid().get_value_or(defaultValue);
    }

    /**
     * Set uuid to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::EpAttributeSet& setUuid(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(1179649ul, newValue);
        return *this;
    }

    /**
     * Unset uuid in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::EpAttributeSet& unsetUuid()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1179649ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of EpAttributeSet from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpAttributeSet> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::EpAttributeSet>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of EpAttributeSet from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpAttributeSet> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::EpAttributeSet>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of EpAttributeSet from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeVMUniverse/GbpeEpAttributeSet/[gbpeEpAttributeSetUuid]
     * 
     * @param framework the framework instance to use 
     * @param gbpeEpAttributeSetUuid the value of gbpeEpAttributeSetUuid,
     * a naming property for EpAttributeSet
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpAttributeSet> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& gbpeEpAttributeSetUuid)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("GbpeVMUniverse").addElement("GbpeEpAttributeSet").addElement(gbpeEpAttributeSetUuid).build());
    }

    /**
     * Retrieve an instance of EpAttributeSet from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeVMUniverse/GbpeEpAttributeSet/[gbpeEpAttributeSetUuid]
     * 
     * @param gbpeEpAttributeSetUuid the value of gbpeEpAttributeSetUuid,
     * a naming property for EpAttributeSet
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpAttributeSet> > resolve(
        const std::string& gbpeEpAttributeSetUuid)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),gbpeEpAttributeSetUuid);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpeEpgMappingCtxFromAttrSetRTgtSource the value of gbpeEpgMappingCtxFromAttrSetRTgtSource,
     * a naming property for EpgMappingCtxFromAttrSetRTgt
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtxFromAttrSetRTgt> > resolveGbpeEpgMappingCtxFromAttrSetRTgt(
        const std::string& gbpeEpgMappingCtxFromAttrSetRTgtSource)
    {
        return modelgbp::gbpe::EpgMappingCtxFromAttrSetRTgt::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeEpgMappingCtxFromAttrSetRTgt").addElement(gbpeEpgMappingCtxFromAttrSetRTgtSource).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpeEpgMappingCtxFromAttrSetRTgtSource the value of gbpeEpgMappingCtxFromAttrSetRTgtSource,
     * a naming property for EpgMappingCtxFromAttrSetRTgt
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtxFromAttrSetRTgt> addGbpeEpgMappingCtxFromAttrSetRTgt(
        const std::string& gbpeEpgMappingCtxFromAttrSetRTgtSource)
    {
        OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtxFromAttrSetRTgt> result = addChild<modelgbp::gbpe::EpgMappingCtxFromAttrSetRTgt>(
            CLASS_ID, getURI(), 2148663322ul, 26,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeEpgMappingCtxFromAttrSetRTgt").addElement(gbpeEpgMappingCtxFromAttrSetRTgtSource).build()
            );
        result->setSource(gbpeEpgMappingCtxFromAttrSetRTgtSource);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbpe::EpgMappingCtxFromAttrSetRTgt
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpeEpgMappingCtxFromAttrSetRTgt(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtxFromAttrSetRTgt> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbpe::EpgMappingCtxFromAttrSetRTgt>(
            getFramework(), CLASS_ID, getURI(), 2148663322ul, 26, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpeEpAttributeName the value of gbpeEpAttributeName,
     * a naming property for EpAttribute
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpAttribute> > resolveGbpeEpAttribute(
        const std::string& gbpeEpAttributeName)
    {
        return modelgbp::gbpe::EpAttribute::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeEpAttribute").addElement(gbpeEpAttributeName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpeEpAttributeName the value of gbpeEpAttributeName,
     * a naming property for EpAttribute
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::EpAttribute> addGbpeEpAttribute(
        const std::string& gbpeEpAttributeName)
    {
        OF_SHARED_PTR<modelgbp::gbpe::EpAttribute> result = addChild<modelgbp::gbpe::EpAttribute>(
            CLASS_ID, getURI(), 2148663333ul, 37,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeEpAttribute").addElement(gbpeEpAttributeName).build()
            );
        result->setName(gbpeEpAttributeName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbpe::EpAttribute
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpeEpAttribute(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbpe::EpAttribute> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbpe::EpAttribute>(
            getFramework(), CLASS_ID, getURI(), 2148663333ul, 37, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the EpAttributeSet object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the EpAttributeSet object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the EpAttributeSet object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeVMUniverse/GbpeEpAttributeSet/[gbpeEpAttributeSetUuid]
     * 
     * @param framework the framework instance to use
     * @param gbpeEpAttributeSetUuid the value of gbpeEpAttributeSetUuid,
     * a naming property for EpAttributeSet
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& gbpeEpAttributeSetUuid)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("GbpeVMUniverse").addElement("GbpeEpAttributeSet").addElement(gbpeEpAttributeSetUuid).build());
    }

    /**
     * Remove the EpAttributeSet object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeVMUniverse/GbpeEpAttributeSet/[gbpeEpAttributeSetUuid]
     * 
     * @param gbpeEpAttributeSetUuid the value of gbpeEpAttributeSetUuid,
     * a naming property for EpAttributeSet
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& gbpeEpAttributeSetUuid)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),gbpeEpAttributeSetUuid);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of EpAttributeSet.
     * This should not typically be called from user code.
     */
    EpAttributeSet(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class EpAttributeSet

} // namespace gbpe
} // namespace modelgbp
#endif // GI_GBPE_EPATTRIBUTESET_HPP
