/**
 * 
 * SOME COPYRIGHT
 * 
 * EpgMappingCtx.hpp
 * 
 * generated EpgMappingCtx.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_GBPE_EPGMAPPINGCTX_HPP
#define GI_GBPE_EPGMAPPINGCTX_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(gbpe/EpgMappingCtxToEpgMappingRSrc)
 */
#include "modelgbp/gbpe/EpgMappingCtxToEpgMappingRSrc.hpp"
/*
 * contains: item:mclass(gbpe/EpgMappingCtxToAttrSetRSrc)
 */
#include "modelgbp/gbpe/EpgMappingCtxToAttrSetRSrc.hpp"

namespace modelgbp {
namespace gbpe {

class EpgMappingCtx
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for EpgMappingCtx
     */
    static const opflex::modb::class_id_t CLASS_ID = 21;

    /**
     * Retrieve an instance of EpgMappingCtx from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtx> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::EpgMappingCtx>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of EpgMappingCtx from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtx> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::EpgMappingCtx>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of EpgMappingCtx from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EpdrL2Discovered/EpdrLocalL2Ep/[epdrLocalL2EpUuid]/GbpeEpgMappingCtx
     * 
     * @param framework the framework instance to use 
     * @param epdrLocalL2EpUuid the value of epdrLocalL2EpUuid,
     * a naming property for LocalL2Ep
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtx> > resolveUnderEpdrL2DiscoveredEpdrLocalL2Ep(
        opflex::ofcore::OFFramework& framework,
        const std::string& epdrLocalL2EpUuid)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("EpdrL2Discovered").addElement("EpdrLocalL2Ep").addElement(epdrLocalL2EpUuid).addElement("GbpeEpgMappingCtx").build());
    }

    /**
     * Retrieve an instance of EpgMappingCtx from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EpdrL2Discovered/EpdrLocalL2Ep/[epdrLocalL2EpUuid]/GbpeEpgMappingCtx
     * 
     * @param epdrLocalL2EpUuid the value of epdrLocalL2EpUuid,
     * a naming property for LocalL2Ep
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtx> > resolveUnderEpdrL2DiscoveredEpdrLocalL2Ep(
        const std::string& epdrLocalL2EpUuid)
    {
        return resolveUnderEpdrL2DiscoveredEpdrLocalL2Ep(opflex::ofcore::OFFramework::defaultInstance(),epdrLocalL2EpUuid);
    }

    /**
     * Retrieve an instance of EpgMappingCtx from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EpdrL3Discovered/EpdrLocalL3Ep/[epdrLocalL3EpUuid]/GbpeEpgMappingCtx
     * 
     * @param framework the framework instance to use 
     * @param epdrLocalL3EpUuid the value of epdrLocalL3EpUuid,
     * a naming property for LocalL3Ep
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtx> > resolveUnderEpdrL3DiscoveredEpdrLocalL3Ep(
        opflex::ofcore::OFFramework& framework,
        const std::string& epdrLocalL3EpUuid)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("EpdrL3Discovered").addElement("EpdrLocalL3Ep").addElement(epdrLocalL3EpUuid).addElement("GbpeEpgMappingCtx").build());
    }

    /**
     * Retrieve an instance of EpgMappingCtx from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EpdrL3Discovered/EpdrLocalL3Ep/[epdrLocalL3EpUuid]/GbpeEpgMappingCtx
     * 
     * @param epdrLocalL3EpUuid the value of epdrLocalL3EpUuid,
     * a naming property for LocalL3Ep
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtx> > resolveUnderEpdrL3DiscoveredEpdrLocalL3Ep(
        const std::string& epdrLocalL3EpUuid)
    {
        return resolveUnderEpdrL3DiscoveredEpdrLocalL3Ep(opflex::ofcore::OFFramework::defaultInstance(),epdrLocalL3EpUuid);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtxToEpgMappingRSrc> > resolveGbpeEpgMappingCtxToEpgMappingRSrc(
        )
    {
        return modelgbp::gbpe::EpgMappingCtxToEpgMappingRSrc::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeEpgMappingCtxToEpgMappingRSrc").build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtxToEpgMappingRSrc> addGbpeEpgMappingCtxToEpgMappingRSrc(
        )
    {
        OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtxToEpgMappingRSrc> result = addChild<modelgbp::gbpe::EpgMappingCtxToEpgMappingRSrc>(
            CLASS_ID, getURI(), 2148171798ul, 22,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeEpgMappingCtxToEpgMappingRSrc").build()
            );
        return result;
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtxToAttrSetRSrc> > resolveGbpeEpgMappingCtxToAttrSetRSrc(
        )
    {
        return modelgbp::gbpe::EpgMappingCtxToAttrSetRSrc::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeEpgMappingCtxToAttrSetRSrc").build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtxToAttrSetRSrc> addGbpeEpgMappingCtxToAttrSetRSrc(
        )
    {
        OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtxToAttrSetRSrc> result = addChild<modelgbp::gbpe::EpgMappingCtxToAttrSetRSrc>(
            CLASS_ID, getURI(), 2148171801ul, 25,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeEpgMappingCtxToAttrSetRSrc").build()
            );
        return result;
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the EpgMappingCtx object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the EpgMappingCtx object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the EpgMappingCtx object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EpdrL2Discovered/EpdrLocalL2Ep/[epdrLocalL2EpUuid]/GbpeEpgMappingCtx
     * 
     * @param framework the framework instance to use
     * @param epdrLocalL2EpUuid the value of epdrLocalL2EpUuid,
     * a naming property for LocalL2Ep
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderEpdrL2DiscoveredEpdrLocalL2Ep(
        opflex::ofcore::OFFramework& framework,
        const std::string& epdrLocalL2EpUuid)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("EpdrL2Discovered").addElement("EpdrLocalL2Ep").addElement(epdrLocalL2EpUuid).addElement("GbpeEpgMappingCtx").build());
    }

    /**
     * Remove the EpgMappingCtx object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EpdrL2Discovered/EpdrLocalL2Ep/[epdrLocalL2EpUuid]/GbpeEpgMappingCtx
     * 
     * @param epdrLocalL2EpUuid the value of epdrLocalL2EpUuid,
     * a naming property for LocalL2Ep
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderEpdrL2DiscoveredEpdrLocalL2Ep(
        const std::string& epdrLocalL2EpUuid)
    {
        removeUnderEpdrL2DiscoveredEpdrLocalL2Ep(opflex::ofcore::OFFramework::defaultInstance(),epdrLocalL2EpUuid);
    }

    /**
     * Remove the EpgMappingCtx object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EpdrL3Discovered/EpdrLocalL3Ep/[epdrLocalL3EpUuid]/GbpeEpgMappingCtx
     * 
     * @param framework the framework instance to use
     * @param epdrLocalL3EpUuid the value of epdrLocalL3EpUuid,
     * a naming property for LocalL3Ep
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderEpdrL3DiscoveredEpdrLocalL3Ep(
        opflex::ofcore::OFFramework& framework,
        const std::string& epdrLocalL3EpUuid)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("EpdrL3Discovered").addElement("EpdrLocalL3Ep").addElement(epdrLocalL3EpUuid).addElement("GbpeEpgMappingCtx").build());
    }

    /**
     * Remove the EpgMappingCtx object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EpdrL3Discovered/EpdrLocalL3Ep/[epdrLocalL3EpUuid]/GbpeEpgMappingCtx
     * 
     * @param epdrLocalL3EpUuid the value of epdrLocalL3EpUuid,
     * a naming property for LocalL3Ep
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderEpdrL3DiscoveredEpdrLocalL3Ep(
        const std::string& epdrLocalL3EpUuid)
    {
        removeUnderEpdrL3DiscoveredEpdrLocalL3Ep(opflex::ofcore::OFFramework::defaultInstance(),epdrLocalL3EpUuid);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of EpgMappingCtx.
     * This should not typically be called from user code.
     */
    EpgMappingCtx(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class EpgMappingCtx

} // namespace gbpe
} // namespace modelgbp
#endif // GI_GBPE_EPGMAPPINGCTX_HPP
