/**
 * 
 * SOME COPYRIGHT
 * 
 * IndirectEpgMapping.hpp
 * 
 * generated IndirectEpgMapping.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_GBPE_INDIRECTEPGMAPPING_HPP
#define GI_GBPE_INDIRECTEPGMAPPING_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(gbpe/IndirectEpgMappingToDefaultGroupRSrc)
 */
#include "modelgbp/gbpe/IndirectEpgMappingToDefaultGroupRSrc.hpp"
/*
 * contains: item:mclass(gbpe/IndirectEpgMappingToMappingRuleSetRSrc)
 */
#include "modelgbp/gbpe/IndirectEpgMappingToMappingRuleSetRSrc.hpp"
/*
 * contains: item:mclass(gbpe/EpgMappingCtxFromEpgMappingRTgt)
 */
#include "modelgbp/gbpe/EpgMappingCtxFromEpgMappingRTgt.hpp"

namespace modelgbp {
namespace gbpe {

class IndirectEpgMapping
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for IndirectEpgMapping
     */
    static const opflex::modb::class_id_t CLASS_ID = 14;

    /**
     * Check whether name has been set
     * @return true if name has been set
     */
    bool isNameSet()
    {
        return getObjectInstance().isSet(458753ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of name if it has been set.
     * @return the value of name or boost::none if not set
     */
    boost::optional<const std::string&> getName()
    {
        if (isNameSet())
            return getObjectInstance().getString(458753ul);
        return boost::none;
    }

    /**
     * Get the value of name if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of name if set, otherwise the value of default passed in
     */
    const std::string& getName(const std::string& defaultValue)
    {
        return getName().get_value_or(defaultValue);
    }

    /**
     * Set name to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::IndirectEpgMapping& setName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(458753ul, newValue);
        return *this;
    }

    /**
     * Unset name in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::IndirectEpgMapping& unsetName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(458753ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of IndirectEpgMapping from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::IndirectEpgMapping> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::IndirectEpgMapping>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of IndirectEpgMapping from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::IndirectEpgMapping> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::IndirectEpgMapping>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of IndirectEpgMapping from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/GbpeIndirectEpgMapping/[gbpeIndirectEpgMappingName]
     * 
     * @param framework the framework instance to use 
     * @param gbpeIndirectEpgMappingName the value of gbpeIndirectEpgMappingName,
     * a naming property for IndirectEpgMapping
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::IndirectEpgMapping> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& gbpeIndirectEpgMappingName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("GbpeIndirectEpgMapping").addElement(gbpeIndirectEpgMappingName).build());
    }

    /**
     * Retrieve an instance of IndirectEpgMapping from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/GbpeIndirectEpgMapping/[gbpeIndirectEpgMappingName]
     * 
     * @param gbpeIndirectEpgMappingName the value of gbpeIndirectEpgMappingName,
     * a naming property for IndirectEpgMapping
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::IndirectEpgMapping> > resolve(
        const std::string& gbpeIndirectEpgMappingName)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),gbpeIndirectEpgMappingName);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::IndirectEpgMappingToDefaultGroupRSrc> > resolveGbpeIndirectEpgMappingToDefaultGroupRSrc(
        )
    {
        return modelgbp::gbpe::IndirectEpgMappingToDefaultGroupRSrc::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeIndirectEpgMappingToDefaultGroupRSrc").build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::IndirectEpgMappingToDefaultGroupRSrc> addGbpeIndirectEpgMappingToDefaultGroupRSrc(
        )
    {
        OF_SHARED_PTR<modelgbp::gbpe::IndirectEpgMappingToDefaultGroupRSrc> result = addChild<modelgbp::gbpe::IndirectEpgMappingToDefaultGroupRSrc>(
            CLASS_ID, getURI(), 2147942415ul, 15,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeIndirectEpgMappingToDefaultGroupRSrc").build()
            );
        return result;
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::IndirectEpgMappingToMappingRuleSetRSrc> > resolveGbpeIndirectEpgMappingToMappingRuleSetRSrc(
        )
    {
        return modelgbp::gbpe::IndirectEpgMappingToMappingRuleSetRSrc::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeIndirectEpgMappingToMappingRuleSetRSrc").build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::IndirectEpgMappingToMappingRuleSetRSrc> addGbpeIndirectEpgMappingToMappingRuleSetRSrc(
        )
    {
        OF_SHARED_PTR<modelgbp::gbpe::IndirectEpgMappingToMappingRuleSetRSrc> result = addChild<modelgbp::gbpe::IndirectEpgMappingToMappingRuleSetRSrc>(
            CLASS_ID, getURI(), 2147942418ul, 18,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeIndirectEpgMappingToMappingRuleSetRSrc").build()
            );
        return result;
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpeEpgMappingCtxFromEpgMappingRTgtSource the value of gbpeEpgMappingCtxFromEpgMappingRTgtSource,
     * a naming property for EpgMappingCtxFromEpgMappingRTgt
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtxFromEpgMappingRTgt> > resolveGbpeEpgMappingCtxFromEpgMappingRTgt(
        const std::string& gbpeEpgMappingCtxFromEpgMappingRTgtSource)
    {
        return modelgbp::gbpe::EpgMappingCtxFromEpgMappingRTgt::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeEpgMappingCtxFromEpgMappingRTgt").addElement(gbpeEpgMappingCtxFromEpgMappingRTgtSource).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpeEpgMappingCtxFromEpgMappingRTgtSource the value of gbpeEpgMappingCtxFromEpgMappingRTgtSource,
     * a naming property for EpgMappingCtxFromEpgMappingRTgt
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtxFromEpgMappingRTgt> addGbpeEpgMappingCtxFromEpgMappingRTgt(
        const std::string& gbpeEpgMappingCtxFromEpgMappingRTgtSource)
    {
        OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtxFromEpgMappingRTgt> result = addChild<modelgbp::gbpe::EpgMappingCtxFromEpgMappingRTgt>(
            CLASS_ID, getURI(), 2147942423ul, 23,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeEpgMappingCtxFromEpgMappingRTgt").addElement(gbpeEpgMappingCtxFromEpgMappingRTgtSource).build()
            );
        result->setSource(gbpeEpgMappingCtxFromEpgMappingRTgtSource);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbpe::EpgMappingCtxFromEpgMappingRTgt
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpeEpgMappingCtxFromEpgMappingRTgt(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbpe::EpgMappingCtxFromEpgMappingRTgt> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbpe::EpgMappingCtxFromEpgMappingRTgt>(
            getFramework(), CLASS_ID, getURI(), 2147942423ul, 23, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the IndirectEpgMapping object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the IndirectEpgMapping object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the IndirectEpgMapping object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/GbpeIndirectEpgMapping/[gbpeIndirectEpgMappingName]
     * 
     * @param framework the framework instance to use
     * @param gbpeIndirectEpgMappingName the value of gbpeIndirectEpgMappingName,
     * a naming property for IndirectEpgMapping
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& gbpeIndirectEpgMappingName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("GbpeIndirectEpgMapping").addElement(gbpeIndirectEpgMappingName).build());
    }

    /**
     * Remove the IndirectEpgMapping object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/GbpeIndirectEpgMapping/[gbpeIndirectEpgMappingName]
     * 
     * @param gbpeIndirectEpgMappingName the value of gbpeIndirectEpgMappingName,
     * a naming property for IndirectEpgMapping
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& gbpeIndirectEpgMappingName)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),gbpeIndirectEpgMappingName);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of IndirectEpgMapping.
     * This should not typically be called from user code.
     */
    IndirectEpgMapping(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class IndirectEpgMapping

} // namespace gbpe
} // namespace modelgbp
#endif // GI_GBPE_INDIRECTEPGMAPPING_HPP
