/**
 * 
 * SOME COPYRIGHT
 * 
 * L24Classifier.hpp
 * 
 * generated L24Classifier.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_GBPE_L24CLASSIFIER_HPP
#define GI_GBPE_L24CLASSIFIER_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(gbp/RuleFromClassifierRTgt)
 */
#include "modelgbp/gbp/RuleFromClassifierRTgt.hpp"

namespace modelgbp {
namespace gbpe {

class L24Classifier
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for L24Classifier
     */
    static const opflex::modb::class_id_t CLASS_ID = 42;

    /**
     * Check whether arpOpc has been set
     * @return true if arpOpc has been set
     */
    bool isArpOpcSet()
    {
        return getObjectInstance().isSet(1376260ul, opflex::modb::PropertyInfo::ENUM8);
    }

    /**
     * Get the value of arpOpc if it has been set.
     * @return the value of arpOpc or boost::none if not set
     */
    boost::optional<const uint8_t> getArpOpc()
    {
        if (isArpOpcSet())
            return (const uint8_t)getObjectInstance().getUInt64(1376260ul);
        return boost::none;
    }

    /**
     * Get the value of arpOpc if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of arpOpc if set, otherwise the value of default passed in
     */
    const uint8_t getArpOpc(const uint8_t defaultValue)
    {
        return getArpOpc().get_value_or(defaultValue);
    }

    /**
     * Set arpOpc to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& setArpOpc(const uint8_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1376260ul, newValue);
        return *this;
    }

    /**
     * Unset arpOpc in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& unsetArpOpc()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1376260ul, opflex::modb::PropertyInfo::ENUM8, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether connectionTracking has been set
     * @return true if connectionTracking has been set
     */
    bool isConnectionTrackingSet()
    {
        return getObjectInstance().isSet(1376259ul, opflex::modb::PropertyInfo::ENUM8);
    }

    /**
     * Get the value of connectionTracking if it has been set.
     * @return the value of connectionTracking or boost::none if not set
     */
    boost::optional<const uint8_t> getConnectionTracking()
    {
        if (isConnectionTrackingSet())
            return (const uint8_t)getObjectInstance().getUInt64(1376259ul);
        return boost::none;
    }

    /**
     * Get the value of connectionTracking if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of connectionTracking if set, otherwise the value of default passed in
     */
    const uint8_t getConnectionTracking(const uint8_t defaultValue)
    {
        return getConnectionTracking().get_value_or(defaultValue);
    }

    /**
     * Set connectionTracking to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& setConnectionTracking(const uint8_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1376259ul, newValue);
        return *this;
    }

    /**
     * Unset connectionTracking in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& unsetConnectionTracking()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1376259ul, opflex::modb::PropertyInfo::ENUM8, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether dFromPort has been set
     * @return true if dFromPort has been set
     */
    bool isDFromPortSet()
    {
        return getObjectInstance().isSet(1376265ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of dFromPort if it has been set.
     * @return the value of dFromPort or boost::none if not set
     */
    boost::optional<uint16_t> getDFromPort()
    {
        if (isDFromPortSet())
            return (uint16_t)getObjectInstance().getUInt64(1376265ul);
        return boost::none;
    }

    /**
     * Get the value of dFromPort if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of dFromPort if set, otherwise the value of default passed in
     */
    uint16_t getDFromPort(uint16_t defaultValue)
    {
        return getDFromPort().get_value_or(defaultValue);
    }

    /**
     * Set dFromPort to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& setDFromPort(uint16_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1376265ul, newValue);
        return *this;
    }

    /**
     * Unset dFromPort in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& unsetDFromPort()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1376265ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether dToPort has been set
     * @return true if dToPort has been set
     */
    bool isDToPortSet()
    {
        return getObjectInstance().isSet(1376266ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of dToPort if it has been set.
     * @return the value of dToPort or boost::none if not set
     */
    boost::optional<uint16_t> getDToPort()
    {
        if (isDToPortSet())
            return (uint16_t)getObjectInstance().getUInt64(1376266ul);
        return boost::none;
    }

    /**
     * Get the value of dToPort if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of dToPort if set, otherwise the value of default passed in
     */
    uint16_t getDToPort(uint16_t defaultValue)
    {
        return getDToPort().get_value_or(defaultValue);
    }

    /**
     * Set dToPort to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& setDToPort(uint16_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1376266ul, newValue);
        return *this;
    }

    /**
     * Unset dToPort in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& unsetDToPort()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1376266ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether etherT has been set
     * @return true if etherT has been set
     */
    bool isEtherTSet()
    {
        return getObjectInstance().isSet(1376261ul, opflex::modb::PropertyInfo::ENUM16);
    }

    /**
     * Get the value of etherT if it has been set.
     * @return the value of etherT or boost::none if not set
     */
    boost::optional<uint16_t> getEtherT()
    {
        if (isEtherTSet())
            return (uint16_t)getObjectInstance().getUInt64(1376261ul);
        return boost::none;
    }

    /**
     * Get the value of etherT if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of etherT if set, otherwise the value of default passed in
     */
    uint16_t getEtherT(uint16_t defaultValue)
    {
        return getEtherT().get_value_or(defaultValue);
    }

    /**
     * Set etherT to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& setEtherT(uint16_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1376261ul, newValue);
        return *this;
    }

    /**
     * Unset etherT in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& unsetEtherT()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1376261ul, opflex::modb::PropertyInfo::ENUM16, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether icmpCode has been set
     * @return true if icmpCode has been set
     */
    bool isIcmpCodeSet()
    {
        return getObjectInstance().isSet(1376269ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of icmpCode if it has been set.
     * @return the value of icmpCode or boost::none if not set
     */
    boost::optional<const uint8_t> getIcmpCode()
    {
        if (isIcmpCodeSet())
            return (const uint8_t)getObjectInstance().getUInt64(1376269ul);
        return boost::none;
    }

    /**
     * Get the value of icmpCode if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of icmpCode if set, otherwise the value of default passed in
     */
    const uint8_t getIcmpCode(const uint8_t defaultValue)
    {
        return getIcmpCode().get_value_or(defaultValue);
    }

    /**
     * Set icmpCode to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& setIcmpCode(const uint8_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1376269ul, newValue);
        return *this;
    }

    /**
     * Unset icmpCode in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& unsetIcmpCode()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1376269ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether icmpType has been set
     * @return true if icmpType has been set
     */
    bool isIcmpTypeSet()
    {
        return getObjectInstance().isSet(1376268ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of icmpType if it has been set.
     * @return the value of icmpType or boost::none if not set
     */
    boost::optional<const uint8_t> getIcmpType()
    {
        if (isIcmpTypeSet())
            return (const uint8_t)getObjectInstance().getUInt64(1376268ul);
        return boost::none;
    }

    /**
     * Get the value of icmpType if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of icmpType if set, otherwise the value of default passed in
     */
    const uint8_t getIcmpType(const uint8_t defaultValue)
    {
        return getIcmpType().get_value_or(defaultValue);
    }

    /**
     * Set icmpType to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& setIcmpType(const uint8_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1376268ul, newValue);
        return *this;
    }

    /**
     * Unset icmpType in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& unsetIcmpType()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1376268ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether name has been set
     * @return true if name has been set
     */
    bool isNameSet()
    {
        return getObjectInstance().isSet(1376257ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of name if it has been set.
     * @return the value of name or boost::none if not set
     */
    boost::optional<const std::string&> getName()
    {
        if (isNameSet())
            return getObjectInstance().getString(1376257ul);
        return boost::none;
    }

    /**
     * Get the value of name if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of name if set, otherwise the value of default passed in
     */
    const std::string& getName(const std::string& defaultValue)
    {
        return getName().get_value_or(defaultValue);
    }

    /**
     * Set name to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& setName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(1376257ul, newValue);
        return *this;
    }

    /**
     * Unset name in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& unsetName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1376257ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether order has been set
     * @return true if order has been set
     */
    bool isOrderSet()
    {
        return getObjectInstance().isSet(1376258ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of order if it has been set.
     * @return the value of order or boost::none if not set
     */
    boost::optional<uint32_t> getOrder()
    {
        if (isOrderSet())
            return (uint32_t)getObjectInstance().getUInt64(1376258ul);
        return boost::none;
    }

    /**
     * Get the value of order if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of order if set, otherwise the value of default passed in
     */
    uint32_t getOrder(uint32_t defaultValue)
    {
        return getOrder().get_value_or(defaultValue);
    }

    /**
     * Set order to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& setOrder(uint32_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1376258ul, newValue);
        return *this;
    }

    /**
     * Unset order in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& unsetOrder()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1376258ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether prot has been set
     * @return true if prot has been set
     */
    bool isProtSet()
    {
        return getObjectInstance().isSet(1376262ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of prot if it has been set.
     * @return the value of prot or boost::none if not set
     */
    boost::optional<const uint8_t> getProt()
    {
        if (isProtSet())
            return (const uint8_t)getObjectInstance().getUInt64(1376262ul);
        return boost::none;
    }

    /**
     * Get the value of prot if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of prot if set, otherwise the value of default passed in
     */
    const uint8_t getProt(const uint8_t defaultValue)
    {
        return getProt().get_value_or(defaultValue);
    }

    /**
     * Set prot to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& setProt(const uint8_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1376262ul, newValue);
        return *this;
    }

    /**
     * Unset prot in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& unsetProt()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1376262ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether sFromPort has been set
     * @return true if sFromPort has been set
     */
    bool isSFromPortSet()
    {
        return getObjectInstance().isSet(1376263ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of sFromPort if it has been set.
     * @return the value of sFromPort or boost::none if not set
     */
    boost::optional<uint16_t> getSFromPort()
    {
        if (isSFromPortSet())
            return (uint16_t)getObjectInstance().getUInt64(1376263ul);
        return boost::none;
    }

    /**
     * Get the value of sFromPort if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of sFromPort if set, otherwise the value of default passed in
     */
    uint16_t getSFromPort(uint16_t defaultValue)
    {
        return getSFromPort().get_value_or(defaultValue);
    }

    /**
     * Set sFromPort to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& setSFromPort(uint16_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1376263ul, newValue);
        return *this;
    }

    /**
     * Unset sFromPort in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& unsetSFromPort()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1376263ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether sToPort has been set
     * @return true if sToPort has been set
     */
    bool isSToPortSet()
    {
        return getObjectInstance().isSet(1376264ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of sToPort if it has been set.
     * @return the value of sToPort or boost::none if not set
     */
    boost::optional<uint16_t> getSToPort()
    {
        if (isSToPortSet())
            return (uint16_t)getObjectInstance().getUInt64(1376264ul);
        return boost::none;
    }

    /**
     * Get the value of sToPort if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of sToPort if set, otherwise the value of default passed in
     */
    uint16_t getSToPort(uint16_t defaultValue)
    {
        return getSToPort().get_value_or(defaultValue);
    }

    /**
     * Set sToPort to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& setSToPort(uint16_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1376264ul, newValue);
        return *this;
    }

    /**
     * Unset sToPort in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& unsetSToPort()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1376264ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether tcpFlags has been set
     * @return true if tcpFlags has been set
     */
    bool isTcpFlagsSet()
    {
        return getObjectInstance().isSet(1376267ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of tcpFlags if it has been set.
     * @return the value of tcpFlags or boost::none if not set
     */
    boost::optional<uint32_t> getTcpFlags()
    {
        if (isTcpFlagsSet())
            return (uint32_t)getObjectInstance().getUInt64(1376267ul);
        return boost::none;
    }

    /**
     * Get the value of tcpFlags if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of tcpFlags if set, otherwise the value of default passed in
     */
    uint32_t getTcpFlags(uint32_t defaultValue)
    {
        return getTcpFlags().get_value_or(defaultValue);
    }

    /**
     * Set tcpFlags to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& setTcpFlags(uint32_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1376267ul, newValue);
        return *this;
    }

    /**
     * Unset tcpFlags in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24Classifier& unsetTcpFlags()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1376267ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of L24Classifier from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::L24Classifier> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::L24Classifier>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of L24Classifier from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::L24Classifier> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::L24Classifier>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of L24Classifier from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpeL24Classifier/[gbpeL24ClassifierName]
     * 
     * @param framework the framework instance to use 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpeL24ClassifierName the value of gbpeL24ClassifierName,
     * a naming property for L24Classifier
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::L24Classifier> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& policySpaceName,
        const std::string& gbpeL24ClassifierName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PolicySpace").addElement(policySpaceName).addElement("GbpeL24Classifier").addElement(gbpeL24ClassifierName).build());
    }

    /**
     * Retrieve an instance of L24Classifier from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpeL24Classifier/[gbpeL24ClassifierName]
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpeL24ClassifierName the value of gbpeL24ClassifierName,
     * a naming property for L24Classifier
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::L24Classifier> > resolve(
        const std::string& policySpaceName,
        const std::string& gbpeL24ClassifierName)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),policySpaceName,gbpeL24ClassifierName);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpRuleFromClassifierRTgtSource the value of gbpRuleFromClassifierRTgtSource,
     * a naming property for RuleFromClassifierRTgt
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::RuleFromClassifierRTgt> > resolveGbpRuleFromClassifierRTgt(
        const std::string& gbpRuleFromClassifierRTgtSource)
    {
        return modelgbp::gbp::RuleFromClassifierRTgt::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpRuleFromClassifierRTgt").addElement(gbpRuleFromClassifierRTgtSource).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpRuleFromClassifierRTgtSource the value of gbpRuleFromClassifierRTgtSource,
     * a naming property for RuleFromClassifierRTgt
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::RuleFromClassifierRTgt> addGbpRuleFromClassifierRTgt(
        const std::string& gbpRuleFromClassifierRTgtSource)
    {
        OF_SHARED_PTR<modelgbp::gbp::RuleFromClassifierRTgt> result = addChild<modelgbp::gbp::RuleFromClassifierRTgt>(
            CLASS_ID, getURI(), 2148860051ul, 147,
            opflex::modb::URIBuilder(getURI()).addElement("GbpRuleFromClassifierRTgt").addElement(gbpRuleFromClassifierRTgtSource).build()
            );
        result->setSource(gbpRuleFromClassifierRTgtSource);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::RuleFromClassifierRTgt
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpRuleFromClassifierRTgt(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::RuleFromClassifierRTgt> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::RuleFromClassifierRTgt>(
            getFramework(), CLASS_ID, getURI(), 2148860051ul, 147, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the L24Classifier object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the L24Classifier object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the L24Classifier object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpeL24Classifier/[gbpeL24ClassifierName]
     * 
     * @param framework the framework instance to use
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpeL24ClassifierName the value of gbpeL24ClassifierName,
     * a naming property for L24Classifier
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& policySpaceName,
        const std::string& gbpeL24ClassifierName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PolicySpace").addElement(policySpaceName).addElement("GbpeL24Classifier").addElement(gbpeL24ClassifierName).build());
    }

    /**
     * Remove the L24Classifier object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]/GbpeL24Classifier/[gbpeL24ClassifierName]
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @param gbpeL24ClassifierName the value of gbpeL24ClassifierName,
     * a naming property for L24Classifier
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& policySpaceName,
        const std::string& gbpeL24ClassifierName)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),policySpaceName,gbpeL24ClassifierName);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of L24Classifier.
     * This should not typically be called from user code.
     */
    L24Classifier(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class L24Classifier

} // namespace gbpe
} // namespace modelgbp
#endif // GI_GBPE_L24CLASSIFIER_HPP
