/**
 * 
 * SOME COPYRIGHT
 * 
 * L24ClassifierCounter.hpp
 * 
 * generated L24ClassifierCounter.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_GBPE_L24CLASSIFIERCOUNTER_HPP
#define GI_GBPE_L24CLASSIFIERCOUNTER_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"

namespace modelgbp {
namespace gbpe {

class L24ClassifierCounter
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for L24ClassifierCounter
     */
    static const opflex::modb::class_id_t CLASS_ID = 48;

    /**
     * Check whether bytes has been set
     * @return true if bytes has been set
     */
    bool isBytesSet()
    {
        return getObjectInstance().isSet(1572871ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of bytes if it has been set.
     * @return the value of bytes or boost::none if not set
     */
    boost::optional<uint64_t> getBytes()
    {
        if (isBytesSet())
            return getObjectInstance().getUInt64(1572871ul);
        return boost::none;
    }

    /**
     * Get the value of bytes if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of bytes if set, otherwise the value of default passed in
     */
    uint64_t getBytes(uint64_t defaultValue)
    {
        return getBytes().get_value_or(defaultValue);
    }

    /**
     * Set bytes to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24ClassifierCounter& setBytes(uint64_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1572871ul, newValue);
        return *this;
    }

    /**
     * Unset bytes in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24ClassifierCounter& unsetBytes()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1572871ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether classifier has been set
     * @return true if classifier has been set
     */
    bool isClassifierSet()
    {
        return getObjectInstance().isSet(1572869ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of classifier if it has been set.
     * @return the value of classifier or boost::none if not set
     */
    boost::optional<const std::string&> getClassifier()
    {
        if (isClassifierSet())
            return getObjectInstance().getString(1572869ul);
        return boost::none;
    }

    /**
     * Get the value of classifier if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of classifier if set, otherwise the value of default passed in
     */
    const std::string& getClassifier(const std::string& defaultValue)
    {
        return getClassifier().get_value_or(defaultValue);
    }

    /**
     * Set classifier to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24ClassifierCounter& setClassifier(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(1572869ul, newValue);
        return *this;
    }

    /**
     * Unset classifier in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24ClassifierCounter& unsetClassifier()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1572869ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether dstEpg has been set
     * @return true if dstEpg has been set
     */
    bool isDstEpgSet()
    {
        return getObjectInstance().isSet(1572868ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of dstEpg if it has been set.
     * @return the value of dstEpg or boost::none if not set
     */
    boost::optional<const std::string&> getDstEpg()
    {
        if (isDstEpgSet())
            return getObjectInstance().getString(1572868ul);
        return boost::none;
    }

    /**
     * Get the value of dstEpg if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of dstEpg if set, otherwise the value of default passed in
     */
    const std::string& getDstEpg(const std::string& defaultValue)
    {
        return getDstEpg().get_value_or(defaultValue);
    }

    /**
     * Set dstEpg to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24ClassifierCounter& setDstEpg(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(1572868ul, newValue);
        return *this;
    }

    /**
     * Unset dstEpg in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24ClassifierCounter& unsetDstEpg()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1572868ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether genId has been set
     * @return true if genId has been set
     */
    bool isGenIdSet()
    {
        return getObjectInstance().isSet(1572866ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of genId if it has been set.
     * @return the value of genId or boost::none if not set
     */
    boost::optional<uint64_t> getGenId()
    {
        if (isGenIdSet())
            return getObjectInstance().getUInt64(1572866ul);
        return boost::none;
    }

    /**
     * Get the value of genId if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of genId if set, otherwise the value of default passed in
     */
    uint64_t getGenId(uint64_t defaultValue)
    {
        return getGenId().get_value_or(defaultValue);
    }

    /**
     * Set genId to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24ClassifierCounter& setGenId(uint64_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1572866ul, newValue);
        return *this;
    }

    /**
     * Unset genId in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24ClassifierCounter& unsetGenId()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1572866ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether packets has been set
     * @return true if packets has been set
     */
    bool isPacketsSet()
    {
        return getObjectInstance().isSet(1572870ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of packets if it has been set.
     * @return the value of packets or boost::none if not set
     */
    boost::optional<uint64_t> getPackets()
    {
        if (isPacketsSet())
            return getObjectInstance().getUInt64(1572870ul);
        return boost::none;
    }

    /**
     * Get the value of packets if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of packets if set, otherwise the value of default passed in
     */
    uint64_t getPackets(uint64_t defaultValue)
    {
        return getPackets().get_value_or(defaultValue);
    }

    /**
     * Set packets to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24ClassifierCounter& setPackets(uint64_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1572870ul, newValue);
        return *this;
    }

    /**
     * Unset packets in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24ClassifierCounter& unsetPackets()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1572870ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether srcEpg has been set
     * @return true if srcEpg has been set
     */
    bool isSrcEpgSet()
    {
        return getObjectInstance().isSet(1572867ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of srcEpg if it has been set.
     * @return the value of srcEpg or boost::none if not set
     */
    boost::optional<const std::string&> getSrcEpg()
    {
        if (isSrcEpgSet())
            return getObjectInstance().getString(1572867ul);
        return boost::none;
    }

    /**
     * Get the value of srcEpg if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of srcEpg if set, otherwise the value of default passed in
     */
    const std::string& getSrcEpg(const std::string& defaultValue)
    {
        return getSrcEpg().get_value_or(defaultValue);
    }

    /**
     * Set srcEpg to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24ClassifierCounter& setSrcEpg(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(1572867ul, newValue);
        return *this;
    }

    /**
     * Unset srcEpg in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24ClassifierCounter& unsetSrcEpg()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1572867ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether uuid has been set
     * @return true if uuid has been set
     */
    bool isUuidSet()
    {
        return getObjectInstance().isSet(1572865ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of uuid if it has been set.
     * @return the value of uuid or boost::none if not set
     */
    boost::optional<const std::string&> getUuid()
    {
        if (isUuidSet())
            return getObjectInstance().getString(1572865ul);
        return boost::none;
    }

    /**
     * Get the value of uuid if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of uuid if set, otherwise the value of default passed in
     */
    const std::string& getUuid(const std::string& defaultValue)
    {
        return getUuid().get_value_or(defaultValue);
    }

    /**
     * Set uuid to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24ClassifierCounter& setUuid(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(1572865ul, newValue);
        return *this;
    }

    /**
     * Unset uuid in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::L24ClassifierCounter& unsetUuid()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1572865ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of L24ClassifierCounter from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::L24ClassifierCounter> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::L24ClassifierCounter>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of L24ClassifierCounter from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::L24ClassifierCounter> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::L24ClassifierCounter>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of L24ClassifierCounter from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverPolicyStatUniverse/GbpeL24ClassifierCounter/[gbpeL24ClassifierCounterUuid]/[gbpeL24ClassifierCounterGenId]/[gbpeL24ClassifierCounterSrcEpg]/[gbpeL24ClassifierCounterDstEpg]/[gbpeL24ClassifierCounterClassifier]
     * 
     * @param framework the framework instance to use 
     * @param gbpeL24ClassifierCounterUuid the value of gbpeL24ClassifierCounterUuid,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterGenId the value of gbpeL24ClassifierCounterGenId,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterSrcEpg the value of gbpeL24ClassifierCounterSrcEpg,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterDstEpg the value of gbpeL24ClassifierCounterDstEpg,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterClassifier the value of gbpeL24ClassifierCounterClassifier,
     * a naming property for L24ClassifierCounter
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::L24ClassifierCounter> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& gbpeL24ClassifierCounterUuid,
        uint64_t gbpeL24ClassifierCounterGenId,
        const std::string& gbpeL24ClassifierCounterSrcEpg,
        const std::string& gbpeL24ClassifierCounterDstEpg,
        const std::string& gbpeL24ClassifierCounterClassifier)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("ObserverPolicyStatUniverse").addElement("GbpeL24ClassifierCounter").addElement(gbpeL24ClassifierCounterUuid).addElement(gbpeL24ClassifierCounterGenId).addElement(gbpeL24ClassifierCounterSrcEpg).addElement(gbpeL24ClassifierCounterDstEpg).addElement(gbpeL24ClassifierCounterClassifier).build());
    }

    /**
     * Retrieve an instance of L24ClassifierCounter from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverPolicyStatUniverse/GbpeL24ClassifierCounter/[gbpeL24ClassifierCounterUuid]/[gbpeL24ClassifierCounterGenId]/[gbpeL24ClassifierCounterSrcEpg]/[gbpeL24ClassifierCounterDstEpg]/[gbpeL24ClassifierCounterClassifier]
     * 
     * @param gbpeL24ClassifierCounterUuid the value of gbpeL24ClassifierCounterUuid,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterGenId the value of gbpeL24ClassifierCounterGenId,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterSrcEpg the value of gbpeL24ClassifierCounterSrcEpg,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterDstEpg the value of gbpeL24ClassifierCounterDstEpg,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterClassifier the value of gbpeL24ClassifierCounterClassifier,
     * a naming property for L24ClassifierCounter
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::L24ClassifierCounter> > resolve(
        const std::string& gbpeL24ClassifierCounterUuid,
        uint64_t gbpeL24ClassifierCounterGenId,
        const std::string& gbpeL24ClassifierCounterSrcEpg,
        const std::string& gbpeL24ClassifierCounterDstEpg,
        const std::string& gbpeL24ClassifierCounterClassifier)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),gbpeL24ClassifierCounterUuid,gbpeL24ClassifierCounterGenId,gbpeL24ClassifierCounterSrcEpg,gbpeL24ClassifierCounterDstEpg,gbpeL24ClassifierCounterClassifier);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the L24ClassifierCounter object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the L24ClassifierCounter object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the L24ClassifierCounter object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverPolicyStatUniverse/GbpeL24ClassifierCounter/[gbpeL24ClassifierCounterUuid]/[gbpeL24ClassifierCounterGenId]/[gbpeL24ClassifierCounterSrcEpg]/[gbpeL24ClassifierCounterDstEpg]/[gbpeL24ClassifierCounterClassifier]
     * 
     * @param framework the framework instance to use
     * @param gbpeL24ClassifierCounterUuid the value of gbpeL24ClassifierCounterUuid,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterGenId the value of gbpeL24ClassifierCounterGenId,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterSrcEpg the value of gbpeL24ClassifierCounterSrcEpg,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterDstEpg the value of gbpeL24ClassifierCounterDstEpg,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterClassifier the value of gbpeL24ClassifierCounterClassifier,
     * a naming property for L24ClassifierCounter
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& gbpeL24ClassifierCounterUuid,
        uint64_t gbpeL24ClassifierCounterGenId,
        const std::string& gbpeL24ClassifierCounterSrcEpg,
        const std::string& gbpeL24ClassifierCounterDstEpg,
        const std::string& gbpeL24ClassifierCounterClassifier)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("ObserverPolicyStatUniverse").addElement("GbpeL24ClassifierCounter").addElement(gbpeL24ClassifierCounterUuid).addElement(gbpeL24ClassifierCounterGenId).addElement(gbpeL24ClassifierCounterSrcEpg).addElement(gbpeL24ClassifierCounterDstEpg).addElement(gbpeL24ClassifierCounterClassifier).build());
    }

    /**
     * Remove the L24ClassifierCounter object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverPolicyStatUniverse/GbpeL24ClassifierCounter/[gbpeL24ClassifierCounterUuid]/[gbpeL24ClassifierCounterGenId]/[gbpeL24ClassifierCounterSrcEpg]/[gbpeL24ClassifierCounterDstEpg]/[gbpeL24ClassifierCounterClassifier]
     * 
     * @param gbpeL24ClassifierCounterUuid the value of gbpeL24ClassifierCounterUuid,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterGenId the value of gbpeL24ClassifierCounterGenId,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterSrcEpg the value of gbpeL24ClassifierCounterSrcEpg,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterDstEpg the value of gbpeL24ClassifierCounterDstEpg,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterClassifier the value of gbpeL24ClassifierCounterClassifier,
     * a naming property for L24ClassifierCounter
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& gbpeL24ClassifierCounterUuid,
        uint64_t gbpeL24ClassifierCounterGenId,
        const std::string& gbpeL24ClassifierCounterSrcEpg,
        const std::string& gbpeL24ClassifierCounterDstEpg,
        const std::string& gbpeL24ClassifierCounterClassifier)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),gbpeL24ClassifierCounterUuid,gbpeL24ClassifierCounterGenId,gbpeL24ClassifierCounterSrcEpg,gbpeL24ClassifierCounterDstEpg,gbpeL24ClassifierCounterClassifier);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of L24ClassifierCounter.
     * This should not typically be called from user code.
     */
    L24ClassifierCounter(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class L24ClassifierCounter

} // namespace gbpe
} // namespace modelgbp
#endif // GI_GBPE_L24CLASSIFIERCOUNTER_HPP
