/**
 * 
 * SOME COPYRIGHT
 * 
 * ReportedEpAttributeSet.hpp
 * 
 * generated ReportedEpAttributeSet.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_GBPE_REPORTEDEPATTRIBUTESET_HPP
#define GI_GBPE_REPORTEDEPATTRIBUTESET_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(gbpe/ReportedEpAttribute)
 */
#include "modelgbp/gbpe/ReportedEpAttribute.hpp"

namespace modelgbp {
namespace gbpe {

class ReportedEpAttributeSet
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for ReportedEpAttributeSet
     */
    static const opflex::modb::class_id_t CLASS_ID = 38;

    /**
     * Retrieve an instance of ReportedEpAttributeSet from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::ReportedEpAttributeSet> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::ReportedEpAttributeSet>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of ReportedEpAttributeSet from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::ReportedEpAttributeSet> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::ReportedEpAttributeSet>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of ReportedEpAttributeSet from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]/GbpeReportedEpAttributeSet
     * 
     * @param framework the framework instance to use 
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::ReportedEpAttributeSet> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("EprL2Universe").addElement("EprL2Ep").addElement(eprL2EpContext).addElement(eprL2EpMac).addElement("GbpeReportedEpAttributeSet").build());
    }

    /**
     * Retrieve an instance of ReportedEpAttributeSet from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]/GbpeReportedEpAttributeSet
     * 
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::ReportedEpAttributeSet> > resolve(
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),eprL2EpContext,eprL2EpMac);
    }

    /**
     * Retrieve an instance of ReportedEpAttributeSet from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EprL3Universe/EprL3Ep/[eprL3EpContext]/[eprL3EpIp]/GbpeReportedEpAttributeSet
     * 
     * @param framework the framework instance to use 
     * @param eprL3EpContext the value of eprL3EpContext,
     * a naming property for L3Ep
     * @param eprL3EpIp the value of eprL3EpIp,
     * a naming property for L3Ep
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::ReportedEpAttributeSet> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& eprL3EpContext,
        const std::string& eprL3EpIp)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("EprL3Universe").addElement("EprL3Ep").addElement(eprL3EpContext).addElement(eprL3EpIp).addElement("GbpeReportedEpAttributeSet").build());
    }

    /**
     * Retrieve an instance of ReportedEpAttributeSet from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /EprL3Universe/EprL3Ep/[eprL3EpContext]/[eprL3EpIp]/GbpeReportedEpAttributeSet
     * 
     * @param eprL3EpContext the value of eprL3EpContext,
     * a naming property for L3Ep
     * @param eprL3EpIp the value of eprL3EpIp,
     * a naming property for L3Ep
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::ReportedEpAttributeSet> > resolve(
        const std::string& eprL3EpContext,
        const std::string& eprL3EpIp)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),eprL3EpContext,eprL3EpIp);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpeReportedEpAttributeName the value of gbpeReportedEpAttributeName,
     * a naming property for ReportedEpAttribute
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::ReportedEpAttribute> > resolveGbpeReportedEpAttribute(
        const std::string& gbpeReportedEpAttributeName)
    {
        return modelgbp::gbpe::ReportedEpAttribute::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeReportedEpAttribute").addElement(gbpeReportedEpAttributeName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpeReportedEpAttributeName the value of gbpeReportedEpAttributeName,
     * a naming property for ReportedEpAttribute
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::ReportedEpAttribute> addGbpeReportedEpAttribute(
        const std::string& gbpeReportedEpAttributeName)
    {
        OF_SHARED_PTR<modelgbp::gbpe::ReportedEpAttribute> result = addChild<modelgbp::gbpe::ReportedEpAttribute>(
            CLASS_ID, getURI(), 2148728871ul, 39,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeReportedEpAttribute").addElement(gbpeReportedEpAttributeName).build()
            );
        result->setName(gbpeReportedEpAttributeName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbpe::ReportedEpAttribute
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpeReportedEpAttribute(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbpe::ReportedEpAttribute> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbpe::ReportedEpAttribute>(
            getFramework(), CLASS_ID, getURI(), 2148728871ul, 39, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the ReportedEpAttributeSet object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the ReportedEpAttributeSet object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the ReportedEpAttributeSet object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]/GbpeReportedEpAttributeSet
     * 
     * @param framework the framework instance to use
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("EprL2Universe").addElement("EprL2Ep").addElement(eprL2EpContext).addElement(eprL2EpMac).addElement("GbpeReportedEpAttributeSet").build());
    }

    /**
     * Remove the ReportedEpAttributeSet object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EprL2Universe/EprL2Ep/[eprL2EpContext]/[eprL2EpMac]/GbpeReportedEpAttributeSet
     * 
     * @param eprL2EpContext the value of eprL2EpContext,
     * a naming property for L2Ep
     * @param eprL2EpMac the value of eprL2EpMac,
     * a naming property for L2Ep
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& eprL2EpContext,
        const opflex::modb::MAC& eprL2EpMac)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),eprL2EpContext,eprL2EpMac);
    }

    /**
     * Remove the ReportedEpAttributeSet object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EprL3Universe/EprL3Ep/[eprL3EpContext]/[eprL3EpIp]/GbpeReportedEpAttributeSet
     * 
     * @param framework the framework instance to use
     * @param eprL3EpContext the value of eprL3EpContext,
     * a naming property for L3Ep
     * @param eprL3EpIp the value of eprL3EpIp,
     * a naming property for L3Ep
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& eprL3EpContext,
        const std::string& eprL3EpIp)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("EprL3Universe").addElement("EprL3Ep").addElement(eprL3EpContext).addElement(eprL3EpIp).addElement("GbpeReportedEpAttributeSet").build());
    }

    /**
     * Remove the ReportedEpAttributeSet object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /EprL3Universe/EprL3Ep/[eprL3EpContext]/[eprL3EpIp]/GbpeReportedEpAttributeSet
     * 
     * @param eprL3EpContext the value of eprL3EpContext,
     * a naming property for L3Ep
     * @param eprL3EpIp the value of eprL3EpIp,
     * a naming property for L3Ep
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& eprL3EpContext,
        const std::string& eprL3EpIp)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),eprL3EpContext,eprL3EpIp);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of ReportedEpAttributeSet.
     * This should not typically be called from user code.
     */
    ReportedEpAttributeSet(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class ReportedEpAttributeSet

} // namespace gbpe
} // namespace modelgbp
#endif // GI_GBPE_REPORTEDEPATTRIBUTESET_HPP
