/**
 * 
 * SOME COPYRIGHT
 * 
 * SecGrpClassifierCounter.hpp
 * 
 * generated SecGrpClassifierCounter.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_GBPE_SECGRPCLASSIFIERCOUNTER_HPP
#define GI_GBPE_SECGRPCLASSIFIERCOUNTER_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"

namespace modelgbp {
namespace gbpe {

class SecGrpClassifierCounter
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for SecGrpClassifierCounter
     */
    static const opflex::modb::class_id_t CLASS_ID = 49;

    /**
     * Check whether classifier has been set
     * @return true if classifier has been set
     */
    bool isClassifierSet()
    {
        return getObjectInstance().isSet(1605635ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of classifier if it has been set.
     * @return the value of classifier or boost::none if not set
     */
    boost::optional<const std::string&> getClassifier()
    {
        if (isClassifierSet())
            return getObjectInstance().getString(1605635ul);
        return boost::none;
    }

    /**
     * Get the value of classifier if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of classifier if set, otherwise the value of default passed in
     */
    const std::string& getClassifier(const std::string& defaultValue)
    {
        return getClassifier().get_value_or(defaultValue);
    }

    /**
     * Set classifier to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::SecGrpClassifierCounter& setClassifier(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(1605635ul, newValue);
        return *this;
    }

    /**
     * Unset classifier in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::SecGrpClassifierCounter& unsetClassifier()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1605635ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether genId has been set
     * @return true if genId has been set
     */
    bool isGenIdSet()
    {
        return getObjectInstance().isSet(1605634ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of genId if it has been set.
     * @return the value of genId or boost::none if not set
     */
    boost::optional<uint64_t> getGenId()
    {
        if (isGenIdSet())
            return getObjectInstance().getUInt64(1605634ul);
        return boost::none;
    }

    /**
     * Get the value of genId if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of genId if set, otherwise the value of default passed in
     */
    uint64_t getGenId(uint64_t defaultValue)
    {
        return getGenId().get_value_or(defaultValue);
    }

    /**
     * Set genId to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::SecGrpClassifierCounter& setGenId(uint64_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1605634ul, newValue);
        return *this;
    }

    /**
     * Unset genId in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::SecGrpClassifierCounter& unsetGenId()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1605634ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether rxbytes has been set
     * @return true if rxbytes has been set
     */
    bool isRxbytesSet()
    {
        return getObjectInstance().isSet(1605637ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of rxbytes if it has been set.
     * @return the value of rxbytes or boost::none if not set
     */
    boost::optional<uint64_t> getRxbytes()
    {
        if (isRxbytesSet())
            return getObjectInstance().getUInt64(1605637ul);
        return boost::none;
    }

    /**
     * Get the value of rxbytes if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of rxbytes if set, otherwise the value of default passed in
     */
    uint64_t getRxbytes(uint64_t defaultValue)
    {
        return getRxbytes().get_value_or(defaultValue);
    }

    /**
     * Set rxbytes to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::SecGrpClassifierCounter& setRxbytes(uint64_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1605637ul, newValue);
        return *this;
    }

    /**
     * Unset rxbytes in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::SecGrpClassifierCounter& unsetRxbytes()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1605637ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether rxpackets has been set
     * @return true if rxpackets has been set
     */
    bool isRxpacketsSet()
    {
        return getObjectInstance().isSet(1605636ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of rxpackets if it has been set.
     * @return the value of rxpackets or boost::none if not set
     */
    boost::optional<uint64_t> getRxpackets()
    {
        if (isRxpacketsSet())
            return getObjectInstance().getUInt64(1605636ul);
        return boost::none;
    }

    /**
     * Get the value of rxpackets if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of rxpackets if set, otherwise the value of default passed in
     */
    uint64_t getRxpackets(uint64_t defaultValue)
    {
        return getRxpackets().get_value_or(defaultValue);
    }

    /**
     * Set rxpackets to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::SecGrpClassifierCounter& setRxpackets(uint64_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1605636ul, newValue);
        return *this;
    }

    /**
     * Unset rxpackets in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::SecGrpClassifierCounter& unsetRxpackets()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1605636ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether txbytes has been set
     * @return true if txbytes has been set
     */
    bool isTxbytesSet()
    {
        return getObjectInstance().isSet(1605639ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of txbytes if it has been set.
     * @return the value of txbytes or boost::none if not set
     */
    boost::optional<uint64_t> getTxbytes()
    {
        if (isTxbytesSet())
            return getObjectInstance().getUInt64(1605639ul);
        return boost::none;
    }

    /**
     * Get the value of txbytes if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of txbytes if set, otherwise the value of default passed in
     */
    uint64_t getTxbytes(uint64_t defaultValue)
    {
        return getTxbytes().get_value_or(defaultValue);
    }

    /**
     * Set txbytes to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::SecGrpClassifierCounter& setTxbytes(uint64_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1605639ul, newValue);
        return *this;
    }

    /**
     * Unset txbytes in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::SecGrpClassifierCounter& unsetTxbytes()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1605639ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether txpackets has been set
     * @return true if txpackets has been set
     */
    bool isTxpacketsSet()
    {
        return getObjectInstance().isSet(1605638ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of txpackets if it has been set.
     * @return the value of txpackets or boost::none if not set
     */
    boost::optional<uint64_t> getTxpackets()
    {
        if (isTxpacketsSet())
            return getObjectInstance().getUInt64(1605638ul);
        return boost::none;
    }

    /**
     * Get the value of txpackets if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of txpackets if set, otherwise the value of default passed in
     */
    uint64_t getTxpackets(uint64_t defaultValue)
    {
        return getTxpackets().get_value_or(defaultValue);
    }

    /**
     * Set txpackets to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::SecGrpClassifierCounter& setTxpackets(uint64_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1605638ul, newValue);
        return *this;
    }

    /**
     * Unset txpackets in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::SecGrpClassifierCounter& unsetTxpackets()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1605638ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether uuid has been set
     * @return true if uuid has been set
     */
    bool isUuidSet()
    {
        return getObjectInstance().isSet(1605633ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of uuid if it has been set.
     * @return the value of uuid or boost::none if not set
     */
    boost::optional<const std::string&> getUuid()
    {
        if (isUuidSet())
            return getObjectInstance().getString(1605633ul);
        return boost::none;
    }

    /**
     * Get the value of uuid if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of uuid if set, otherwise the value of default passed in
     */
    const std::string& getUuid(const std::string& defaultValue)
    {
        return getUuid().get_value_or(defaultValue);
    }

    /**
     * Set uuid to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::SecGrpClassifierCounter& setUuid(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(1605633ul, newValue);
        return *this;
    }

    /**
     * Unset uuid in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::SecGrpClassifierCounter& unsetUuid()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1605633ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of SecGrpClassifierCounter from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::SecGrpClassifierCounter> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::SecGrpClassifierCounter>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of SecGrpClassifierCounter from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::SecGrpClassifierCounter> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::SecGrpClassifierCounter>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of SecGrpClassifierCounter from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverPolicyStatUniverse/GbpeSecGrpClassifierCounter/[gbpeSecGrpClassifierCounterUuid]/[gbpeSecGrpClassifierCounterGenId]/[gbpeSecGrpClassifierCounterClassifier]
     * 
     * @param framework the framework instance to use 
     * @param gbpeSecGrpClassifierCounterUuid the value of gbpeSecGrpClassifierCounterUuid,
     * a naming property for SecGrpClassifierCounter
     * @param gbpeSecGrpClassifierCounterGenId the value of gbpeSecGrpClassifierCounterGenId,
     * a naming property for SecGrpClassifierCounter
     * @param gbpeSecGrpClassifierCounterClassifier the value of gbpeSecGrpClassifierCounterClassifier,
     * a naming property for SecGrpClassifierCounter
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::SecGrpClassifierCounter> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& gbpeSecGrpClassifierCounterUuid,
        uint64_t gbpeSecGrpClassifierCounterGenId,
        const std::string& gbpeSecGrpClassifierCounterClassifier)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("ObserverPolicyStatUniverse").addElement("GbpeSecGrpClassifierCounter").addElement(gbpeSecGrpClassifierCounterUuid).addElement(gbpeSecGrpClassifierCounterGenId).addElement(gbpeSecGrpClassifierCounterClassifier).build());
    }

    /**
     * Retrieve an instance of SecGrpClassifierCounter from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverPolicyStatUniverse/GbpeSecGrpClassifierCounter/[gbpeSecGrpClassifierCounterUuid]/[gbpeSecGrpClassifierCounterGenId]/[gbpeSecGrpClassifierCounterClassifier]
     * 
     * @param gbpeSecGrpClassifierCounterUuid the value of gbpeSecGrpClassifierCounterUuid,
     * a naming property for SecGrpClassifierCounter
     * @param gbpeSecGrpClassifierCounterGenId the value of gbpeSecGrpClassifierCounterGenId,
     * a naming property for SecGrpClassifierCounter
     * @param gbpeSecGrpClassifierCounterClassifier the value of gbpeSecGrpClassifierCounterClassifier,
     * a naming property for SecGrpClassifierCounter
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::SecGrpClassifierCounter> > resolve(
        const std::string& gbpeSecGrpClassifierCounterUuid,
        uint64_t gbpeSecGrpClassifierCounterGenId,
        const std::string& gbpeSecGrpClassifierCounterClassifier)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),gbpeSecGrpClassifierCounterUuid,gbpeSecGrpClassifierCounterGenId,gbpeSecGrpClassifierCounterClassifier);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the SecGrpClassifierCounter object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the SecGrpClassifierCounter object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the SecGrpClassifierCounter object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverPolicyStatUniverse/GbpeSecGrpClassifierCounter/[gbpeSecGrpClassifierCounterUuid]/[gbpeSecGrpClassifierCounterGenId]/[gbpeSecGrpClassifierCounterClassifier]
     * 
     * @param framework the framework instance to use
     * @param gbpeSecGrpClassifierCounterUuid the value of gbpeSecGrpClassifierCounterUuid,
     * a naming property for SecGrpClassifierCounter
     * @param gbpeSecGrpClassifierCounterGenId the value of gbpeSecGrpClassifierCounterGenId,
     * a naming property for SecGrpClassifierCounter
     * @param gbpeSecGrpClassifierCounterClassifier the value of gbpeSecGrpClassifierCounterClassifier,
     * a naming property for SecGrpClassifierCounter
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& gbpeSecGrpClassifierCounterUuid,
        uint64_t gbpeSecGrpClassifierCounterGenId,
        const std::string& gbpeSecGrpClassifierCounterClassifier)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("ObserverPolicyStatUniverse").addElement("GbpeSecGrpClassifierCounter").addElement(gbpeSecGrpClassifierCounterUuid).addElement(gbpeSecGrpClassifierCounterGenId).addElement(gbpeSecGrpClassifierCounterClassifier).build());
    }

    /**
     * Remove the SecGrpClassifierCounter object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverPolicyStatUniverse/GbpeSecGrpClassifierCounter/[gbpeSecGrpClassifierCounterUuid]/[gbpeSecGrpClassifierCounterGenId]/[gbpeSecGrpClassifierCounterClassifier]
     * 
     * @param gbpeSecGrpClassifierCounterUuid the value of gbpeSecGrpClassifierCounterUuid,
     * a naming property for SecGrpClassifierCounter
     * @param gbpeSecGrpClassifierCounterGenId the value of gbpeSecGrpClassifierCounterGenId,
     * a naming property for SecGrpClassifierCounter
     * @param gbpeSecGrpClassifierCounterClassifier the value of gbpeSecGrpClassifierCounterClassifier,
     * a naming property for SecGrpClassifierCounter
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& gbpeSecGrpClassifierCounterUuid,
        uint64_t gbpeSecGrpClassifierCounterGenId,
        const std::string& gbpeSecGrpClassifierCounterClassifier)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),gbpeSecGrpClassifierCounterUuid,gbpeSecGrpClassifierCounterGenId,gbpeSecGrpClassifierCounterClassifier);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of SecGrpClassifierCounter.
     * This should not typically be called from user code.
     */
    SecGrpClassifierCounter(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class SecGrpClassifierCounter

} // namespace gbpe
} // namespace modelgbp
#endif // GI_GBPE_SECGRPCLASSIFIERCOUNTER_HPP
