/**
 * 
 * SOME COPYRIGHT
 * 
 * TunnelEp.hpp
 * 
 * generated TunnelEp.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_GBPE_TUNNELEP_HPP
#define GI_GBPE_TUNNELEP_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(gbpe/Attestation)
 */
#include "modelgbp/gbpe/Attestation.hpp"

namespace modelgbp {
namespace gbpe {

class TunnelEp
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for TunnelEp
     */
    static const opflex::modb::class_id_t CLASS_ID = 45;

    /**
     * Check whether encapId has been set
     * @return true if encapId has been set
     */
    bool isEncapIdSet()
    {
        return getObjectInstance().isSet(1474565ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of encapId if it has been set.
     * @return the value of encapId or boost::none if not set
     */
    boost::optional<uint32_t> getEncapId()
    {
        if (isEncapIdSet())
            return (uint32_t)getObjectInstance().getUInt64(1474565ul);
        return boost::none;
    }

    /**
     * Get the value of encapId if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of encapId if set, otherwise the value of default passed in
     */
    uint32_t getEncapId(uint32_t defaultValue)
    {
        return getEncapId().get_value_or(defaultValue);
    }

    /**
     * Set encapId to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::TunnelEp& setEncapId(uint32_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1474565ul, newValue);
        return *this;
    }

    /**
     * Unset encapId in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::TunnelEp& unsetEncapId()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1474565ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether encapType has been set
     * @return true if encapType has been set
     */
    bool isEncapTypeSet()
    {
        return getObjectInstance().isSet(1474564ul, opflex::modb::PropertyInfo::ENUM8);
    }

    /**
     * Get the value of encapType if it has been set.
     * @return the value of encapType or boost::none if not set
     */
    boost::optional<const uint8_t> getEncapType()
    {
        if (isEncapTypeSet())
            return (const uint8_t)getObjectInstance().getUInt64(1474564ul);
        return boost::none;
    }

    /**
     * Get the value of encapType if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of encapType if set, otherwise the value of default passed in
     */
    const uint8_t getEncapType(const uint8_t defaultValue)
    {
        return getEncapType().get_value_or(defaultValue);
    }

    /**
     * Set encapType to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::TunnelEp& setEncapType(const uint8_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1474564ul, newValue);
        return *this;
    }

    /**
     * Unset encapType in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::TunnelEp& unsetEncapType()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1474564ul, opflex::modb::PropertyInfo::ENUM8, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether mac has been set
     * @return true if mac has been set
     */
    bool isMacSet()
    {
        return getObjectInstance().isSet(1474563ul, opflex::modb::PropertyInfo::MAC);
    }

    /**
     * Get the value of mac if it has been set.
     * @return the value of mac or boost::none if not set
     */
    boost::optional<const opflex::modb::MAC&> getMac()
    {
        if (isMacSet())
            return getObjectInstance().getMAC(1474563ul);
        return boost::none;
    }

    /**
     * Get the value of mac if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of mac if set, otherwise the value of default passed in
     */
    const opflex::modb::MAC& getMac(const opflex::modb::MAC& defaultValue)
    {
        return getMac().get_value_or(defaultValue);
    }

    /**
     * Set mac to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::TunnelEp& setMac(const opflex::modb::MAC& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setMAC(1474563ul, newValue);
        return *this;
    }

    /**
     * Unset mac in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::TunnelEp& unsetMac()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1474563ul, opflex::modb::PropertyInfo::MAC, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether terminatorIp has been set
     * @return true if terminatorIp has been set
     */
    bool isTerminatorIpSet()
    {
        return getObjectInstance().isSet(1474562ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of terminatorIp if it has been set.
     * @return the value of terminatorIp or boost::none if not set
     */
    boost::optional<const std::string&> getTerminatorIp()
    {
        if (isTerminatorIpSet())
            return getObjectInstance().getString(1474562ul);
        return boost::none;
    }

    /**
     * Get the value of terminatorIp if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of terminatorIp if set, otherwise the value of default passed in
     */
    const std::string& getTerminatorIp(const std::string& defaultValue)
    {
        return getTerminatorIp().get_value_or(defaultValue);
    }

    /**
     * Set terminatorIp to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::TunnelEp& setTerminatorIp(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(1474562ul, newValue);
        return *this;
    }

    /**
     * Unset terminatorIp in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::TunnelEp& unsetTerminatorIp()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1474562ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether uuid has been set
     * @return true if uuid has been set
     */
    bool isUuidSet()
    {
        return getObjectInstance().isSet(1474561ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of uuid if it has been set.
     * @return the value of uuid or boost::none if not set
     */
    boost::optional<const std::string&> getUuid()
    {
        if (isUuidSet())
            return getObjectInstance().getString(1474561ul);
        return boost::none;
    }

    /**
     * Get the value of uuid if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of uuid if set, otherwise the value of default passed in
     */
    const std::string& getUuid(const std::string& defaultValue)
    {
        return getUuid().get_value_or(defaultValue);
    }

    /**
     * Set uuid to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::TunnelEp& setUuid(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(1474561ul, newValue);
        return *this;
    }

    /**
     * Unset uuid in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::TunnelEp& unsetUuid()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1474561ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of TunnelEp from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::TunnelEp> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::TunnelEp>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of TunnelEp from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::TunnelEp> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::TunnelEp>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of TunnelEp from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeTunnelEpUniverse/GbpeTunnelEp/[gbpeTunnelEpUuid]
     * 
     * @param framework the framework instance to use 
     * @param gbpeTunnelEpUuid the value of gbpeTunnelEpUuid,
     * a naming property for TunnelEp
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::TunnelEp> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& gbpeTunnelEpUuid)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("GbpeTunnelEpUniverse").addElement("GbpeTunnelEp").addElement(gbpeTunnelEpUuid).build());
    }

    /**
     * Retrieve an instance of TunnelEp from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeTunnelEpUniverse/GbpeTunnelEp/[gbpeTunnelEpUuid]
     * 
     * @param gbpeTunnelEpUuid the value of gbpeTunnelEpUuid,
     * a naming property for TunnelEp
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::TunnelEp> > resolve(
        const std::string& gbpeTunnelEpUuid)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),gbpeTunnelEpUuid);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::Attestation> > resolveGbpeAttestation(
        const std::string& gbpeAttestationName)
    {
        return modelgbp::gbpe::Attestation::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeAttestation").addElement(gbpeAttestationName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpeAttestationName the value of gbpeAttestationName,
     * a naming property for Attestation
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::Attestation> addGbpeAttestation(
        const std::string& gbpeAttestationName)
    {
        OF_SHARED_PTR<modelgbp::gbpe::Attestation> result = addChild<modelgbp::gbpe::Attestation>(
            CLASS_ID, getURI(), 2148958255ul, 47,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeAttestation").addElement(gbpeAttestationName).build()
            );
        result->setName(gbpeAttestationName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbpe::Attestation
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpeAttestation(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbpe::Attestation> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbpe::Attestation>(
            getFramework(), CLASS_ID, getURI(), 2148958255ul, 47, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the TunnelEp object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the TunnelEp object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the TunnelEp object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeTunnelEpUniverse/GbpeTunnelEp/[gbpeTunnelEpUuid]
     * 
     * @param framework the framework instance to use
     * @param gbpeTunnelEpUuid the value of gbpeTunnelEpUuid,
     * a naming property for TunnelEp
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& gbpeTunnelEpUuid)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("GbpeTunnelEpUniverse").addElement("GbpeTunnelEp").addElement(gbpeTunnelEpUuid).build());
    }

    /**
     * Remove the TunnelEp object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /GbpeTunnelEpUniverse/GbpeTunnelEp/[gbpeTunnelEpUuid]
     * 
     * @param gbpeTunnelEpUuid the value of gbpeTunnelEpUuid,
     * a naming property for TunnelEp
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& gbpeTunnelEpUuid)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),gbpeTunnelEpUuid);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of TunnelEp.
     * This should not typically be called from user code.
     */
    TunnelEp(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class TunnelEp

} // namespace gbpe
} // namespace modelgbp
#endif // GI_GBPE_TUNNELEP_HPP
