/**
 * 
 * SOME COPYRIGHT
 * 
 * DHCPv4Config.hpp
 * 
 * generated DHCPv4Config.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_INV_DHCPV4CONFIG_HPP
#define GI_INV_DHCPV4CONFIG_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(inv/DNSServer)
 */
#include "modelgbp/inv/DNSServer.hpp"
/*
 * contains: item:mclass(inv/Router)
 */
#include "modelgbp/inv/Router.hpp"
/*
 * contains: item:mclass(inv/StaticRoute)
 */
#include "modelgbp/inv/StaticRoute.hpp"

namespace modelgbp {
namespace inv {

class DHCPv4Config
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for DHCPv4Config
     */
    static const opflex::modb::class_id_t CLASS_ID = 130;

    /**
     * Check whether domain has been set
     * @return true if domain has been set
     */
    bool isDomainSet()
    {
        return getObjectInstance().isSet(4259844ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of domain if it has been set.
     * @return the value of domain or boost::none if not set
     */
    boost::optional<const std::string&> getDomain()
    {
        if (isDomainSet())
            return getObjectInstance().getString(4259844ul);
        return boost::none;
    }

    /**
     * Get the value of domain if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of domain if set, otherwise the value of default passed in
     */
    const std::string& getDomain(const std::string& defaultValue)
    {
        return getDomain().get_value_or(defaultValue);
    }

    /**
     * Set domain to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv4Config& setDomain(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(4259844ul, newValue);
        return *this;
    }

    /**
     * Unset domain in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv4Config& unsetDomain()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4259844ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether interfaceMTU has been set
     * @return true if interfaceMTU has been set
     */
    bool isInterfaceMTUSet()
    {
        return getObjectInstance().isSet(4259845ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of interfaceMTU if it has been set.
     * @return the value of interfaceMTU or boost::none if not set
     */
    boost::optional<uint16_t> getInterfaceMTU()
    {
        if (isInterfaceMTUSet())
            return (uint16_t)getObjectInstance().getUInt64(4259845ul);
        return boost::none;
    }

    /**
     * Get the value of interfaceMTU if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of interfaceMTU if set, otherwise the value of default passed in
     */
    uint16_t getInterfaceMTU(uint16_t defaultValue)
    {
        return getInterfaceMTU().get_value_or(defaultValue);
    }

    /**
     * Set interfaceMTU to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv4Config& setInterfaceMTU(uint16_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(4259845ul, newValue);
        return *this;
    }

    /**
     * Unset interfaceMTU in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv4Config& unsetInterfaceMTU()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4259845ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether ip has been set
     * @return true if ip has been set
     */
    bool isIpSet()
    {
        return getObjectInstance().isSet(4259841ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of ip if it has been set.
     * @return the value of ip or boost::none if not set
     */
    boost::optional<const std::string&> getIp()
    {
        if (isIpSet())
            return getObjectInstance().getString(4259841ul);
        return boost::none;
    }

    /**
     * Get the value of ip if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of ip if set, otherwise the value of default passed in
     */
    const std::string& getIp(const std::string& defaultValue)
    {
        return getIp().get_value_or(defaultValue);
    }

    /**
     * Set ip to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv4Config& setIp(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(4259841ul, newValue);
        return *this;
    }

    /**
     * Unset ip in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv4Config& unsetIp()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4259841ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether leaseTime has been set
     * @return true if leaseTime has been set
     */
    bool isLeaseTimeSet()
    {
        return getObjectInstance().isSet(4259846ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of leaseTime if it has been set.
     * @return the value of leaseTime or boost::none if not set
     */
    boost::optional<uint32_t> getLeaseTime()
    {
        if (isLeaseTimeSet())
            return (uint32_t)getObjectInstance().getUInt64(4259846ul);
        return boost::none;
    }

    /**
     * Get the value of leaseTime if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of leaseTime if set, otherwise the value of default passed in
     */
    uint32_t getLeaseTime(uint32_t defaultValue)
    {
        return getLeaseTime().get_value_or(defaultValue);
    }

    /**
     * Set leaseTime to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv4Config& setLeaseTime(uint32_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(4259846ul, newValue);
        return *this;
    }

    /**
     * Unset leaseTime in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv4Config& unsetLeaseTime()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4259846ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether prefixLen has been set
     * @return true if prefixLen has been set
     */
    bool isPrefixLenSet()
    {
        return getObjectInstance().isSet(4259842ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of prefixLen if it has been set.
     * @return the value of prefixLen or boost::none if not set
     */
    boost::optional<const uint8_t> getPrefixLen()
    {
        if (isPrefixLenSet())
            return (const uint8_t)getObjectInstance().getUInt64(4259842ul);
        return boost::none;
    }

    /**
     * Get the value of prefixLen if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of prefixLen if set, otherwise the value of default passed in
     */
    const uint8_t getPrefixLen(const uint8_t defaultValue)
    {
        return getPrefixLen().get_value_or(defaultValue);
    }

    /**
     * Set prefixLen to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv4Config& setPrefixLen(const uint8_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(4259842ul, newValue);
        return *this;
    }

    /**
     * Unset prefixLen in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv4Config& unsetPrefixLen()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4259842ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether serverIp has been set
     * @return true if serverIp has been set
     */
    bool isServerIpSet()
    {
        return getObjectInstance().isSet(4259843ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of serverIp if it has been set.
     * @return the value of serverIp or boost::none if not set
     */
    boost::optional<const std::string&> getServerIp()
    {
        if (isServerIpSet())
            return getObjectInstance().getString(4259843ul);
        return boost::none;
    }

    /**
     * Get the value of serverIp if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of serverIp if set, otherwise the value of default passed in
     */
    const std::string& getServerIp(const std::string& defaultValue)
    {
        return getServerIp().get_value_or(defaultValue);
    }

    /**
     * Set serverIp to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv4Config& setServerIp(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(4259843ul, newValue);
        return *this;
    }

    /**
     * Unset serverIp in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv4Config& unsetServerIp()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4259843ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of DHCPv4Config from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::DHCPv4Config> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::inv::DHCPv4Config>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of DHCPv4Config from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::DHCPv4Config> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::inv::DHCPv4Config>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of DHCPv4Config from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvDHCPv4Config
     * 
     * @param framework the framework instance to use 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::DHCPv4Config> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("InvUniverse").addElement("InvLocalEndpointInventory").addElement(invLocalEndpointInventoryName).addElement("InvLocalInventoryEp").addElement(invLocalInventoryEpUuid).addElement("InvDHCPv4Config").build());
    }

    /**
     * Retrieve an instance of DHCPv4Config from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvDHCPv4Config
     * 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::DHCPv4Config> > resolve(
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),invLocalEndpointInventoryName,invLocalInventoryEpUuid);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param invDNSServerName the value of invDNSServerName,
     * a naming property for DNSServer
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::inv::DNSServer> > resolveInvDNSServer(
        const std::string& invDNSServerName)
    {
        return modelgbp::inv::DNSServer::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("InvDNSServer").addElement(invDNSServerName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param invDNSServerName the value of invDNSServerName,
     * a naming property for DNSServer
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::inv::DNSServer> addInvDNSServer(
        const std::string& invDNSServerName)
    {
        OF_SHARED_PTR<modelgbp::inv::DNSServer> result = addChild<modelgbp::inv::DNSServer>(
            CLASS_ID, getURI(), 2151743619ul, 131,
            opflex::modb::URIBuilder(getURI()).addElement("InvDNSServer").addElement(invDNSServerName).build()
            );
        result->setName(invDNSServerName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::inv::DNSServer
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveInvDNSServer(/* out */ std::vector<OF_SHARED_PTR<modelgbp::inv::DNSServer> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::inv::DNSServer>(
            getFramework(), CLASS_ID, getURI(), 2151743619ul, 131, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param invRouterName the value of invRouterName,
     * a naming property for Router
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::inv::Router> > resolveInvRouter(
        const std::string& invRouterName)
    {
        return modelgbp::inv::Router::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("InvRouter").addElement(invRouterName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param invRouterName the value of invRouterName,
     * a naming property for Router
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::inv::Router> addInvRouter(
        const std::string& invRouterName)
    {
        OF_SHARED_PTR<modelgbp::inv::Router> result = addChild<modelgbp::inv::Router>(
            CLASS_ID, getURI(), 2151743620ul, 132,
            opflex::modb::URIBuilder(getURI()).addElement("InvRouter").addElement(invRouterName).build()
            );
        result->setName(invRouterName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::inv::Router
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveInvRouter(/* out */ std::vector<OF_SHARED_PTR<modelgbp::inv::Router> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::inv::Router>(
            getFramework(), CLASS_ID, getURI(), 2151743620ul, 132, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param invStaticRouteDest the value of invStaticRouteDest,
     * a naming property for StaticRoute
     * @param invStaticRoutePrefixLen the value of invStaticRoutePrefixLen,
     * a naming property for StaticRoute
     * @param invStaticRouteNextHop the value of invStaticRouteNextHop,
     * a naming property for StaticRoute
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::inv::StaticRoute> > resolveInvStaticRoute(
        const std::string& invStaticRouteDest,
        const uint8_t invStaticRoutePrefixLen,
        const std::string& invStaticRouteNextHop)
    {
        return modelgbp::inv::StaticRoute::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("InvStaticRoute").addElement(invStaticRouteDest).addElement(invStaticRoutePrefixLen).addElement(invStaticRouteNextHop).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param invStaticRouteDest the value of invStaticRouteDest,
     * a naming property for StaticRoute
     * @param invStaticRoutePrefixLen the value of invStaticRoutePrefixLen,
     * a naming property for StaticRoute
     * @param invStaticRouteNextHop the value of invStaticRouteNextHop,
     * a naming property for StaticRoute
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::inv::StaticRoute> addInvStaticRoute(
        const std::string& invStaticRouteDest,
        const uint8_t invStaticRoutePrefixLen,
        const std::string& invStaticRouteNextHop)
    {
        OF_SHARED_PTR<modelgbp::inv::StaticRoute> result = addChild<modelgbp::inv::StaticRoute>(
            CLASS_ID, getURI(), 2151743621ul, 133,
            opflex::modb::URIBuilder(getURI()).addElement("InvStaticRoute").addElement(invStaticRouteDest).addElement(invStaticRoutePrefixLen).addElement(invStaticRouteNextHop).build()
            );
        result->setDest(invStaticRouteDest);
        result->setPrefixLen(invStaticRoutePrefixLen);
        result->setNextHop(invStaticRouteNextHop);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::inv::StaticRoute
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveInvStaticRoute(/* out */ std::vector<OF_SHARED_PTR<modelgbp::inv::StaticRoute> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::inv::StaticRoute>(
            getFramework(), CLASS_ID, getURI(), 2151743621ul, 133, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the DHCPv4Config object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the DHCPv4Config object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the DHCPv4Config object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvDHCPv4Config
     * 
     * @param framework the framework instance to use
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("InvUniverse").addElement("InvLocalEndpointInventory").addElement(invLocalEndpointInventoryName).addElement("InvLocalInventoryEp").addElement(invLocalInventoryEpUuid).addElement("InvDHCPv4Config").build());
    }

    /**
     * Remove the DHCPv4Config object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvDHCPv4Config
     * 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),invLocalEndpointInventoryName,invLocalInventoryEpUuid);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of DHCPv4Config.
     * This should not typically be called from user code.
     */
    DHCPv4Config(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class DHCPv4Config

} // namespace inv
} // namespace modelgbp
#endif // GI_INV_DHCPV4CONFIG_HPP
