/**
 * 
 * SOME COPYRIGHT
 * 
 * DHCPv6Config.hpp
 * 
 * generated DHCPv6Config.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_INV_DHCPV6CONFIG_HPP
#define GI_INV_DHCPV6CONFIG_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(inv/DNSServer)
 */
#include "modelgbp/inv/DNSServer.hpp"
/*
 * contains: item:mclass(inv/SearchListEntry)
 */
#include "modelgbp/inv/SearchListEntry.hpp"

namespace modelgbp {
namespace inv {

class DHCPv6Config
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for DHCPv6Config
     */
    static const opflex::modb::class_id_t CLASS_ID = 134;

    /**
     * Check whether preferredLifetime has been set
     * @return true if preferredLifetime has been set
     */
    bool isPreferredLifetimeSet()
    {
        return getObjectInstance().isSet(4390916ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of preferredLifetime if it has been set.
     * @return the value of preferredLifetime or boost::none if not set
     */
    boost::optional<uint32_t> getPreferredLifetime()
    {
        if (isPreferredLifetimeSet())
            return (uint32_t)getObjectInstance().getUInt64(4390916ul);
        return boost::none;
    }

    /**
     * Get the value of preferredLifetime if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of preferredLifetime if set, otherwise the value of default passed in
     */
    uint32_t getPreferredLifetime(uint32_t defaultValue)
    {
        return getPreferredLifetime().get_value_or(defaultValue);
    }

    /**
     * Set preferredLifetime to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv6Config& setPreferredLifetime(uint32_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(4390916ul, newValue);
        return *this;
    }

    /**
     * Unset preferredLifetime in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv6Config& unsetPreferredLifetime()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4390916ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether t1 has been set
     * @return true if t1 has been set
     */
    bool isT1Set()
    {
        return getObjectInstance().isSet(4390913ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of t1 if it has been set.
     * @return the value of t1 or boost::none if not set
     */
    boost::optional<uint32_t> getT1()
    {
        if (isT1Set())
            return (uint32_t)getObjectInstance().getUInt64(4390913ul);
        return boost::none;
    }

    /**
     * Get the value of t1 if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of t1 if set, otherwise the value of default passed in
     */
    uint32_t getT1(uint32_t defaultValue)
    {
        return getT1().get_value_or(defaultValue);
    }

    /**
     * Set t1 to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv6Config& setT1(uint32_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(4390913ul, newValue);
        return *this;
    }

    /**
     * Unset t1 in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv6Config& unsetT1()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4390913ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether t2 has been set
     * @return true if t2 has been set
     */
    bool isT2Set()
    {
        return getObjectInstance().isSet(4390914ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of t2 if it has been set.
     * @return the value of t2 or boost::none if not set
     */
    boost::optional<uint32_t> getT2()
    {
        if (isT2Set())
            return (uint32_t)getObjectInstance().getUInt64(4390914ul);
        return boost::none;
    }

    /**
     * Get the value of t2 if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of t2 if set, otherwise the value of default passed in
     */
    uint32_t getT2(uint32_t defaultValue)
    {
        return getT2().get_value_or(defaultValue);
    }

    /**
     * Set t2 to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv6Config& setT2(uint32_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(4390914ul, newValue);
        return *this;
    }

    /**
     * Unset t2 in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv6Config& unsetT2()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4390914ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether validLifetime has been set
     * @return true if validLifetime has been set
     */
    bool isValidLifetimeSet()
    {
        return getObjectInstance().isSet(4390915ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of validLifetime if it has been set.
     * @return the value of validLifetime or boost::none if not set
     */
    boost::optional<uint32_t> getValidLifetime()
    {
        if (isValidLifetimeSet())
            return (uint32_t)getObjectInstance().getUInt64(4390915ul);
        return boost::none;
    }

    /**
     * Get the value of validLifetime if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of validLifetime if set, otherwise the value of default passed in
     */
    uint32_t getValidLifetime(uint32_t defaultValue)
    {
        return getValidLifetime().get_value_or(defaultValue);
    }

    /**
     * Set validLifetime to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv6Config& setValidLifetime(uint32_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(4390915ul, newValue);
        return *this;
    }

    /**
     * Unset validLifetime in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::DHCPv6Config& unsetValidLifetime()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4390915ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of DHCPv6Config from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::DHCPv6Config> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::inv::DHCPv6Config>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of DHCPv6Config from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::DHCPv6Config> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::inv::DHCPv6Config>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of DHCPv6Config from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvDHCPv6Config
     * 
     * @param framework the framework instance to use 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::DHCPv6Config> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("InvUniverse").addElement("InvLocalEndpointInventory").addElement(invLocalEndpointInventoryName).addElement("InvLocalInventoryEp").addElement(invLocalInventoryEpUuid).addElement("InvDHCPv6Config").build());
    }

    /**
     * Retrieve an instance of DHCPv6Config from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvDHCPv6Config
     * 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::DHCPv6Config> > resolve(
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),invLocalEndpointInventoryName,invLocalInventoryEpUuid);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param invDNSServerName the value of invDNSServerName,
     * a naming property for DNSServer
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::inv::DNSServer> > resolveInvDNSServer(
        const std::string& invDNSServerName)
    {
        return modelgbp::inv::DNSServer::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("InvDNSServer").addElement(invDNSServerName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param invDNSServerName the value of invDNSServerName,
     * a naming property for DNSServer
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::inv::DNSServer> addInvDNSServer(
        const std::string& invDNSServerName)
    {
        OF_SHARED_PTR<modelgbp::inv::DNSServer> result = addChild<modelgbp::inv::DNSServer>(
            CLASS_ID, getURI(), 2151874691ul, 131,
            opflex::modb::URIBuilder(getURI()).addElement("InvDNSServer").addElement(invDNSServerName).build()
            );
        result->setName(invDNSServerName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::inv::DNSServer
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveInvDNSServer(/* out */ std::vector<OF_SHARED_PTR<modelgbp::inv::DNSServer> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::inv::DNSServer>(
            getFramework(), CLASS_ID, getURI(), 2151874691ul, 131, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param invSearchListEntryName the value of invSearchListEntryName,
     * a naming property for SearchListEntry
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::inv::SearchListEntry> > resolveInvSearchListEntry(
        const std::string& invSearchListEntryName)
    {
        return modelgbp::inv::SearchListEntry::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("InvSearchListEntry").addElement(invSearchListEntryName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param invSearchListEntryName the value of invSearchListEntryName,
     * a naming property for SearchListEntry
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::inv::SearchListEntry> addInvSearchListEntry(
        const std::string& invSearchListEntryName)
    {
        OF_SHARED_PTR<modelgbp::inv::SearchListEntry> result = addChild<modelgbp::inv::SearchListEntry>(
            CLASS_ID, getURI(), 2151874695ul, 135,
            opflex::modb::URIBuilder(getURI()).addElement("InvSearchListEntry").addElement(invSearchListEntryName).build()
            );
        result->setName(invSearchListEntryName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::inv::SearchListEntry
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveInvSearchListEntry(/* out */ std::vector<OF_SHARED_PTR<modelgbp::inv::SearchListEntry> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::inv::SearchListEntry>(
            getFramework(), CLASS_ID, getURI(), 2151874695ul, 135, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the DHCPv6Config object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the DHCPv6Config object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the DHCPv6Config object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvDHCPv6Config
     * 
     * @param framework the framework instance to use
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("InvUniverse").addElement("InvLocalEndpointInventory").addElement(invLocalEndpointInventoryName).addElement("InvLocalInventoryEp").addElement(invLocalInventoryEpUuid).addElement("InvDHCPv6Config").build());
    }

    /**
     * Remove the DHCPv6Config object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvDHCPv6Config
     * 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),invLocalEndpointInventoryName,invLocalInventoryEpUuid);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of DHCPv6Config.
     * This should not typically be called from user code.
     */
    DHCPv6Config(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class DHCPv6Config

} // namespace inv
} // namespace modelgbp
#endif // GI_INV_DHCPV6CONFIG_HPP
