/**
 * 
 * SOME COPYRIGHT
 * 
 * Ip.hpp
 * 
 * generated Ip.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_INV_IP_HPP
#define GI_INV_IP_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"

namespace modelgbp {
namespace inv {

class Ip
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for Ip
     */
    static const opflex::modb::class_id_t CLASS_ID = 123;

    /**
     * Check whether ip has been set
     * @return true if ip has been set
     */
    bool isIpSet()
    {
        return getObjectInstance().isSet(4030465ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of ip if it has been set.
     * @return the value of ip or boost::none if not set
     */
    boost::optional<const std::string&> getIp()
    {
        if (isIpSet())
            return getObjectInstance().getString(4030465ul);
        return boost::none;
    }

    /**
     * Get the value of ip if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of ip if set, otherwise the value of default passed in
     */
    const std::string& getIp(const std::string& defaultValue)
    {
        return getIp().get_value_or(defaultValue);
    }

    /**
     * Set ip to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::Ip& setIp(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(4030465ul, newValue);
        return *this;
    }

    /**
     * Unset ip in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::Ip& unsetIp()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4030465ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether mac has been set
     * @return true if mac has been set
     */
    bool isMacSet()
    {
        return getObjectInstance().isSet(4030467ul, opflex::modb::PropertyInfo::MAC);
    }

    /**
     * Get the value of mac if it has been set.
     * @return the value of mac or boost::none if not set
     */
    boost::optional<const opflex::modb::MAC&> getMac()
    {
        if (isMacSet())
            return getObjectInstance().getMAC(4030467ul);
        return boost::none;
    }

    /**
     * Get the value of mac if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of mac if set, otherwise the value of default passed in
     */
    const opflex::modb::MAC& getMac(const opflex::modb::MAC& defaultValue)
    {
        return getMac().get_value_or(defaultValue);
    }

    /**
     * Set mac to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::Ip& setMac(const opflex::modb::MAC& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setMAC(4030467ul, newValue);
        return *this;
    }

    /**
     * Unset mac in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::Ip& unsetMac()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4030467ul, opflex::modb::PropertyInfo::MAC, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether type has been set
     * @return true if type has been set
     */
    bool isTypeSet()
    {
        return getObjectInstance().isSet(4030466ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of type if it has been set.
     * @return the value of type or boost::none if not set
     */
    boost::optional<const std::string&> getType()
    {
        if (isTypeSet())
            return getObjectInstance().getString(4030466ul);
        return boost::none;
    }

    /**
     * Get the value of type if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of type if set, otherwise the value of default passed in
     */
    const std::string& getType(const std::string& defaultValue)
    {
        return getType().get_value_or(defaultValue);
    }

    /**
     * Set type to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::Ip& setType(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(4030466ul, newValue);
        return *this;
    }

    /**
     * Unset type in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::Ip& unsetType()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4030466ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of Ip from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::Ip> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::inv::Ip>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of Ip from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::Ip> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::inv::Ip>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of Ip from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvIp/[invIpIp]/[invIpType]
     * 
     * @param framework the framework instance to use 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @param invIpIp the value of invIpIp,
     * a naming property for Ip
     * @param invIpType the value of invIpType,
     * a naming property for Ip
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::Ip> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid,
        const std::string& invIpIp,
        const std::string& invIpType)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("InvUniverse").addElement("InvLocalEndpointInventory").addElement(invLocalEndpointInventoryName).addElement("InvLocalInventoryEp").addElement(invLocalInventoryEpUuid).addElement("InvIp").addElement(invIpIp).addElement(invIpType).build());
    }

    /**
     * Retrieve an instance of Ip from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvIp/[invIpIp]/[invIpType]
     * 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @param invIpIp the value of invIpIp,
     * a naming property for Ip
     * @param invIpType the value of invIpType,
     * a naming property for Ip
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::Ip> > resolve(
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid,
        const std::string& invIpIp,
        const std::string& invIpType)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),invLocalEndpointInventoryName,invLocalInventoryEpUuid,invIpIp,invIpType);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the Ip object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the Ip object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the Ip object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvIp/[invIpIp]/[invIpType]
     * 
     * @param framework the framework instance to use
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @param invIpIp the value of invIpIp,
     * a naming property for Ip
     * @param invIpType the value of invIpType,
     * a naming property for Ip
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid,
        const std::string& invIpIp,
        const std::string& invIpType)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("InvUniverse").addElement("InvLocalEndpointInventory").addElement(invLocalEndpointInventoryName).addElement("InvLocalInventoryEp").addElement(invLocalInventoryEpUuid).addElement("InvIp").addElement(invIpIp).addElement(invIpType).build());
    }

    /**
     * Remove the Ip object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvIp/[invIpIp]/[invIpType]
     * 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @param invIpIp the value of invIpIp,
     * a naming property for Ip
     * @param invIpType the value of invIpType,
     * a naming property for Ip
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid,
        const std::string& invIpIp,
        const std::string& invIpType)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),invLocalEndpointInventoryName,invLocalInventoryEpUuid,invIpIp,invIpType);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of Ip.
     * This should not typically be called from user code.
     */
    Ip(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class Ip

} // namespace inv
} // namespace modelgbp
#endif // GI_INV_IP_HPP
