/**
 * 
 * SOME COPYRIGHT
 * 
 * IpMapping.hpp
 * 
 * generated IpMapping.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_INV_IPMAPPING_HPP
#define GI_INV_IPMAPPING_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(inv/IpMappingToGroupRSrc)
 */
#include "modelgbp/inv/IpMappingToGroupRSrc.hpp"

namespace modelgbp {
namespace inv {

class IpMapping
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for IpMapping
     */
    static const opflex::modb::class_id_t CLASS_ID = 124;

    /**
     * Check whether floatingIp has been set
     * @return true if floatingIp has been set
     */
    bool isFloatingIpSet()
    {
        return getObjectInstance().isSet(4063235ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of floatingIp if it has been set.
     * @return the value of floatingIp or boost::none if not set
     */
    boost::optional<const std::string&> getFloatingIp()
    {
        if (isFloatingIpSet())
            return getObjectInstance().getString(4063235ul);
        return boost::none;
    }

    /**
     * Get the value of floatingIp if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of floatingIp if set, otherwise the value of default passed in
     */
    const std::string& getFloatingIp(const std::string& defaultValue)
    {
        return getFloatingIp().get_value_or(defaultValue);
    }

    /**
     * Set floatingIp to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::IpMapping& setFloatingIp(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(4063235ul, newValue);
        return *this;
    }

    /**
     * Unset floatingIp in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::IpMapping& unsetFloatingIp()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4063235ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether mappedIp has been set
     * @return true if mappedIp has been set
     */
    bool isMappedIpSet()
    {
        return getObjectInstance().isSet(4063234ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of mappedIp if it has been set.
     * @return the value of mappedIp or boost::none if not set
     */
    boost::optional<const std::string&> getMappedIp()
    {
        if (isMappedIpSet())
            return getObjectInstance().getString(4063234ul);
        return boost::none;
    }

    /**
     * Get the value of mappedIp if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of mappedIp if set, otherwise the value of default passed in
     */
    const std::string& getMappedIp(const std::string& defaultValue)
    {
        return getMappedIp().get_value_or(defaultValue);
    }

    /**
     * Set mappedIp to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::IpMapping& setMappedIp(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(4063234ul, newValue);
        return *this;
    }

    /**
     * Unset mappedIp in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::IpMapping& unsetMappedIp()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4063234ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether name has been set
     * @return true if name has been set
     */
    bool isNameSet()
    {
        return getObjectInstance().isSet(4063233ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of name if it has been set.
     * @return the value of name or boost::none if not set
     */
    boost::optional<const std::string&> getName()
    {
        if (isNameSet())
            return getObjectInstance().getString(4063233ul);
        return boost::none;
    }

    /**
     * Get the value of name if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of name if set, otherwise the value of default passed in
     */
    const std::string& getName(const std::string& defaultValue)
    {
        return getName().get_value_or(defaultValue);
    }

    /**
     * Set name to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::IpMapping& setName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(4063233ul, newValue);
        return *this;
    }

    /**
     * Unset name in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::IpMapping& unsetName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4063233ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether nextHopIf has been set
     * @return true if nextHopIf has been set
     */
    bool isNextHopIfSet()
    {
        return getObjectInstance().isSet(4063236ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of nextHopIf if it has been set.
     * @return the value of nextHopIf or boost::none if not set
     */
    boost::optional<const std::string&> getNextHopIf()
    {
        if (isNextHopIfSet())
            return getObjectInstance().getString(4063236ul);
        return boost::none;
    }

    /**
     * Get the value of nextHopIf if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of nextHopIf if set, otherwise the value of default passed in
     */
    const std::string& getNextHopIf(const std::string& defaultValue)
    {
        return getNextHopIf().get_value_or(defaultValue);
    }

    /**
     * Set nextHopIf to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::IpMapping& setNextHopIf(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(4063236ul, newValue);
        return *this;
    }

    /**
     * Unset nextHopIf in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::IpMapping& unsetNextHopIf()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4063236ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether nextHopMac has been set
     * @return true if nextHopMac has been set
     */
    bool isNextHopMacSet()
    {
        return getObjectInstance().isSet(4063237ul, opflex::modb::PropertyInfo::MAC);
    }

    /**
     * Get the value of nextHopMac if it has been set.
     * @return the value of nextHopMac or boost::none if not set
     */
    boost::optional<const opflex::modb::MAC&> getNextHopMac()
    {
        if (isNextHopMacSet())
            return getObjectInstance().getMAC(4063237ul);
        return boost::none;
    }

    /**
     * Get the value of nextHopMac if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of nextHopMac if set, otherwise the value of default passed in
     */
    const opflex::modb::MAC& getNextHopMac(const opflex::modb::MAC& defaultValue)
    {
        return getNextHopMac().get_value_or(defaultValue);
    }

    /**
     * Set nextHopMac to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::IpMapping& setNextHopMac(const opflex::modb::MAC& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setMAC(4063237ul, newValue);
        return *this;
    }

    /**
     * Unset nextHopMac in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::IpMapping& unsetNextHopMac()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4063237ul, opflex::modb::PropertyInfo::MAC, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of IpMapping from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::IpMapping> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::inv::IpMapping>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of IpMapping from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::IpMapping> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::inv::IpMapping>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of IpMapping from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvIpMapping/[invIpMappingName]
     * 
     * @param framework the framework instance to use 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @param invIpMappingName the value of invIpMappingName,
     * a naming property for IpMapping
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::IpMapping> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid,
        const std::string& invIpMappingName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("InvUniverse").addElement("InvLocalEndpointInventory").addElement(invLocalEndpointInventoryName).addElement("InvLocalInventoryEp").addElement(invLocalInventoryEpUuid).addElement("InvIpMapping").addElement(invIpMappingName).build());
    }

    /**
     * Retrieve an instance of IpMapping from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvIpMapping/[invIpMappingName]
     * 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @param invIpMappingName the value of invIpMappingName,
     * a naming property for IpMapping
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::IpMapping> > resolve(
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid,
        const std::string& invIpMappingName)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),invLocalEndpointInventoryName,invLocalInventoryEpUuid,invIpMappingName);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::inv::IpMappingToGroupRSrc> > resolveInvIpMappingToGroupRSrc(
        )
    {
        return modelgbp::inv::IpMappingToGroupRSrc::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("InvIpMappingToGroupRSrc").build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::inv::IpMappingToGroupRSrc> addInvIpMappingToGroupRSrc(
        )
    {
        OF_SHARED_PTR<modelgbp::inv::IpMappingToGroupRSrc> result = addChild<modelgbp::inv::IpMappingToGroupRSrc>(
            CLASS_ID, getURI(), 2151547005ul, 125,
            opflex::modb::URIBuilder(getURI()).addElement("InvIpMappingToGroupRSrc").build()
            );
        return result;
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the IpMapping object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the IpMapping object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the IpMapping object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvIpMapping/[invIpMappingName]
     * 
     * @param framework the framework instance to use
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @param invIpMappingName the value of invIpMappingName,
     * a naming property for IpMapping
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid,
        const std::string& invIpMappingName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("InvUniverse").addElement("InvLocalEndpointInventory").addElement(invLocalEndpointInventoryName).addElement("InvLocalInventoryEp").addElement(invLocalInventoryEpUuid).addElement("InvIpMapping").addElement(invIpMappingName).build());
    }

    /**
     * Remove the IpMapping object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvIpMapping/[invIpMappingName]
     * 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @param invIpMappingName the value of invIpMappingName,
     * a naming property for IpMapping
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid,
        const std::string& invIpMappingName)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),invLocalEndpointInventoryName,invLocalInventoryEpUuid,invIpMappingName);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of IpMapping.
     * This should not typically be called from user code.
     */
    IpMapping(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class IpMapping

} // namespace inv
} // namespace modelgbp
#endif // GI_INV_IPMAPPING_HPP
