/**
 * 
 * SOME COPYRIGHT
 * 
 * LocalEndpointInventory.hpp
 * 
 * generated LocalEndpointInventory.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_INV_LOCALENDPOINTINVENTORY_HPP
#define GI_INV_LOCALENDPOINTINVENTORY_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(domain/ConfigFromEndpointInventoryRTgt)
 */
#include "modelgbp/domain/ConfigFromEndpointInventoryRTgt.hpp"
/*
 * contains: item:mclass(inv/LocalInventoryEp)
 */
#include "modelgbp/inv/LocalInventoryEp.hpp"

namespace modelgbp {
namespace inv {

class LocalEndpointInventory
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for LocalEndpointInventory
     */
    static const opflex::modb::class_id_t CLASS_ID = 114;

    /**
     * Check whether name has been set
     * @return true if name has been set
     */
    bool isNameSet()
    {
        return getObjectInstance().isSet(3735553ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of name if it has been set.
     * @return the value of name or boost::none if not set
     */
    boost::optional<const std::string&> getName()
    {
        if (isNameSet())
            return getObjectInstance().getString(3735553ul);
        return boost::none;
    }

    /**
     * Get the value of name if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of name if set, otherwise the value of default passed in
     */
    const std::string& getName(const std::string& defaultValue)
    {
        return getName().get_value_or(defaultValue);
    }

    /**
     * Set name to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::LocalEndpointInventory& setName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(3735553ul, newValue);
        return *this;
    }

    /**
     * Unset name in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::LocalEndpointInventory& unsetName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3735553ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of LocalEndpointInventory from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::LocalEndpointInventory> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::inv::LocalEndpointInventory>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of LocalEndpointInventory from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::LocalEndpointInventory> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::inv::LocalEndpointInventory>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of LocalEndpointInventory from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]
     * 
     * @param framework the framework instance to use 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::LocalEndpointInventory> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& invLocalEndpointInventoryName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("InvUniverse").addElement("InvLocalEndpointInventory").addElement(invLocalEndpointInventoryName).build());
    }

    /**
     * Retrieve an instance of LocalEndpointInventory from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]
     * 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::LocalEndpointInventory> > resolve(
        const std::string& invLocalEndpointInventoryName)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),invLocalEndpointInventoryName);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param domainConfigFromEndpointInventoryRTgtSource the value of domainConfigFromEndpointInventoryRTgtSource,
     * a naming property for ConfigFromEndpointInventoryRTgt
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::domain::ConfigFromEndpointInventoryRTgt> > resolveDomainConfigFromEndpointInventoryRTgt(
        const std::string& domainConfigFromEndpointInventoryRTgtSource)
    {
        return modelgbp::domain::ConfigFromEndpointInventoryRTgt::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("DomainConfigFromEndpointInventoryRTgt").addElement(domainConfigFromEndpointInventoryRTgtSource).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param domainConfigFromEndpointInventoryRTgtSource the value of domainConfigFromEndpointInventoryRTgtSource,
     * a naming property for ConfigFromEndpointInventoryRTgt
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::domain::ConfigFromEndpointInventoryRTgt> addDomainConfigFromEndpointInventoryRTgt(
        const std::string& domainConfigFromEndpointInventoryRTgtSource)
    {
        OF_SHARED_PTR<modelgbp::domain::ConfigFromEndpointInventoryRTgt> result = addChild<modelgbp::domain::ConfigFromEndpointInventoryRTgt>(
            CLASS_ID, getURI(), 2151219261ul, 61,
            opflex::modb::URIBuilder(getURI()).addElement("DomainConfigFromEndpointInventoryRTgt").addElement(domainConfigFromEndpointInventoryRTgtSource).build()
            );
        result->setSource(domainConfigFromEndpointInventoryRTgtSource);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::domain::ConfigFromEndpointInventoryRTgt
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveDomainConfigFromEndpointInventoryRTgt(/* out */ std::vector<OF_SHARED_PTR<modelgbp::domain::ConfigFromEndpointInventoryRTgt> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::domain::ConfigFromEndpointInventoryRTgt>(
            getFramework(), CLASS_ID, getURI(), 2151219261ul, 61, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::inv::LocalInventoryEp> > resolveInvLocalInventoryEp(
        const std::string& invLocalInventoryEpUuid)
    {
        return modelgbp::inv::LocalInventoryEp::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("InvLocalInventoryEp").addElement(invLocalInventoryEpUuid).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::inv::LocalInventoryEp> addInvLocalInventoryEp(
        const std::string& invLocalInventoryEpUuid)
    {
        OF_SHARED_PTR<modelgbp::inv::LocalInventoryEp> result = addChild<modelgbp::inv::LocalInventoryEp>(
            CLASS_ID, getURI(), 2151219316ul, 116,
            opflex::modb::URIBuilder(getURI()).addElement("InvLocalInventoryEp").addElement(invLocalInventoryEpUuid).build()
            );
        result->setUuid(invLocalInventoryEpUuid);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::inv::LocalInventoryEp
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveInvLocalInventoryEp(/* out */ std::vector<OF_SHARED_PTR<modelgbp::inv::LocalInventoryEp> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::inv::LocalInventoryEp>(
            getFramework(), CLASS_ID, getURI(), 2151219316ul, 116, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the LocalEndpointInventory object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the LocalEndpointInventory object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the LocalEndpointInventory object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]
     * 
     * @param framework the framework instance to use
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& invLocalEndpointInventoryName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("InvUniverse").addElement("InvLocalEndpointInventory").addElement(invLocalEndpointInventoryName).build());
    }

    /**
     * Remove the LocalEndpointInventory object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]
     * 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& invLocalEndpointInventoryName)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),invLocalEndpointInventoryName);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of LocalEndpointInventory.
     * This should not typically be called from user code.
     */
    LocalEndpointInventory(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class LocalEndpointInventory

} // namespace inv
} // namespace modelgbp
#endif // GI_INV_LOCALENDPOINTINVENTORY_HPP
