/**
 * 
 * SOME COPYRIGHT
 * 
 * LocalInventoryEp.hpp
 * 
 * generated LocalInventoryEp.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_INV_LOCALINVENTORYEP_HPP
#define GI_INV_LOCALINVENTORYEP_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(inv/LocalInventoryEpToGroupRSrc)
 */
#include "modelgbp/inv/LocalInventoryEpToGroupRSrc.hpp"
/*
 * contains: item:mclass(inv/LocalInventoryEpToSecGroupRSrc)
 */
#include "modelgbp/inv/LocalInventoryEpToSecGroupRSrc.hpp"
/*
 * contains: item:mclass(inv/Ip)
 */
#include "modelgbp/inv/Ip.hpp"
/*
 * contains: item:mclass(inv/IpMapping)
 */
#include "modelgbp/inv/IpMapping.hpp"
/*
 * contains: item:mclass(inv/Interface)
 */
#include "modelgbp/inv/Interface.hpp"
/*
 * contains: item:mclass(inv/DHCPv4Config)
 */
#include "modelgbp/inv/DHCPv4Config.hpp"
/*
 * contains: item:mclass(inv/DHCPv6Config)
 */
#include "modelgbp/inv/DHCPv6Config.hpp"
/*
 * contains: item:mclass(inv/Attribute)
 */
#include "modelgbp/inv/Attribute.hpp"

namespace modelgbp {
namespace inv {

class LocalInventoryEp
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for LocalInventoryEp
     */
    static const opflex::modb::class_id_t CLASS_ID = 116;

    /**
     * Check whether accessVlan has been set
     * @return true if accessVlan has been set
     */
    bool isAccessVlanSet()
    {
        return getObjectInstance().isSet(3801092ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of accessVlan if it has been set.
     * @return the value of accessVlan or boost::none if not set
     */
    boost::optional<uint16_t> getAccessVlan()
    {
        if (isAccessVlanSet())
            return (uint16_t)getObjectInstance().getUInt64(3801092ul);
        return boost::none;
    }

    /**
     * Get the value of accessVlan if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of accessVlan if set, otherwise the value of default passed in
     */
    uint16_t getAccessVlan(uint16_t defaultValue)
    {
        return getAccessVlan().get_value_or(defaultValue);
    }

    /**
     * Set accessVlan to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::LocalInventoryEp& setAccessVlan(uint16_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(3801092ul, newValue);
        return *this;
    }

    /**
     * Unset accessVlan in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::LocalInventoryEp& unsetAccessVlan()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3801092ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether discoveryMode has been set
     * @return true if discoveryMode has been set
     */
    bool isDiscoveryModeSet()
    {
        return getObjectInstance().isSet(3801094ul, opflex::modb::PropertyInfo::ENUM8);
    }

    /**
     * Get the value of discoveryMode if it has been set.
     * @return the value of discoveryMode or boost::none if not set
     */
    boost::optional<const uint8_t> getDiscoveryMode()
    {
        if (isDiscoveryModeSet())
            return (const uint8_t)getObjectInstance().getUInt64(3801094ul);
        return boost::none;
    }

    /**
     * Get the value of discoveryMode if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of discoveryMode if set, otherwise the value of default passed in
     */
    const uint8_t getDiscoveryMode(const uint8_t defaultValue)
    {
        return getDiscoveryMode().get_value_or(defaultValue);
    }

    /**
     * Set discoveryMode to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::LocalInventoryEp& setDiscoveryMode(const uint8_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(3801094ul, newValue);
        return *this;
    }

    /**
     * Unset discoveryMode in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::LocalInventoryEp& unsetDiscoveryMode()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3801094ul, opflex::modb::PropertyInfo::ENUM8, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether egMappingAlias has been set
     * @return true if egMappingAlias has been set
     */
    bool isEgMappingAliasSet()
    {
        return getObjectInstance().isSet(3801091ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of egMappingAlias if it has been set.
     * @return the value of egMappingAlias or boost::none if not set
     */
    boost::optional<const std::string&> getEgMappingAlias()
    {
        if (isEgMappingAliasSet())
            return getObjectInstance().getString(3801091ul);
        return boost::none;
    }

    /**
     * Get the value of egMappingAlias if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of egMappingAlias if set, otherwise the value of default passed in
     */
    const std::string& getEgMappingAlias(const std::string& defaultValue)
    {
        return getEgMappingAlias().get_value_or(defaultValue);
    }

    /**
     * Set egMappingAlias to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::LocalInventoryEp& setEgMappingAlias(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(3801091ul, newValue);
        return *this;
    }

    /**
     * Unset egMappingAlias in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::LocalInventoryEp& unsetEgMappingAlias()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3801091ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether ifaceSecurity has been set
     * @return true if ifaceSecurity has been set
     */
    bool isIfaceSecuritySet()
    {
        return getObjectInstance().isSet(3801093ul, opflex::modb::PropertyInfo::ENUM8);
    }

    /**
     * Get the value of ifaceSecurity if it has been set.
     * @return the value of ifaceSecurity or boost::none if not set
     */
    boost::optional<const uint8_t> getIfaceSecurity()
    {
        if (isIfaceSecuritySet())
            return (const uint8_t)getObjectInstance().getUInt64(3801093ul);
        return boost::none;
    }

    /**
     * Get the value of ifaceSecurity if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of ifaceSecurity if set, otherwise the value of default passed in
     */
    const uint8_t getIfaceSecurity(const uint8_t defaultValue)
    {
        return getIfaceSecurity().get_value_or(defaultValue);
    }

    /**
     * Set ifaceSecurity to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::LocalInventoryEp& setIfaceSecurity(const uint8_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(3801093ul, newValue);
        return *this;
    }

    /**
     * Unset ifaceSecurity in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::LocalInventoryEp& unsetIfaceSecurity()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3801093ul, opflex::modb::PropertyInfo::ENUM8, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether mac has been set
     * @return true if mac has been set
     */
    bool isMacSet()
    {
        return getObjectInstance().isSet(3801090ul, opflex::modb::PropertyInfo::MAC);
    }

    /**
     * Get the value of mac if it has been set.
     * @return the value of mac or boost::none if not set
     */
    boost::optional<const opflex::modb::MAC&> getMac()
    {
        if (isMacSet())
            return getObjectInstance().getMAC(3801090ul);
        return boost::none;
    }

    /**
     * Get the value of mac if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of mac if set, otherwise the value of default passed in
     */
    const opflex::modb::MAC& getMac(const opflex::modb::MAC& defaultValue)
    {
        return getMac().get_value_or(defaultValue);
    }

    /**
     * Set mac to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::LocalInventoryEp& setMac(const opflex::modb::MAC& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setMAC(3801090ul, newValue);
        return *this;
    }

    /**
     * Unset mac in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::LocalInventoryEp& unsetMac()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3801090ul, opflex::modb::PropertyInfo::MAC, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether uuid has been set
     * @return true if uuid has been set
     */
    bool isUuidSet()
    {
        return getObjectInstance().isSet(3801089ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of uuid if it has been set.
     * @return the value of uuid or boost::none if not set
     */
    boost::optional<const std::string&> getUuid()
    {
        if (isUuidSet())
            return getObjectInstance().getString(3801089ul);
        return boost::none;
    }

    /**
     * Get the value of uuid if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of uuid if set, otherwise the value of default passed in
     */
    const std::string& getUuid(const std::string& defaultValue)
    {
        return getUuid().get_value_or(defaultValue);
    }

    /**
     * Set uuid to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::LocalInventoryEp& setUuid(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(3801089ul, newValue);
        return *this;
    }

    /**
     * Unset uuid in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::LocalInventoryEp& unsetUuid()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(3801089ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of LocalInventoryEp from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::LocalInventoryEp> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::inv::LocalInventoryEp>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of LocalInventoryEp from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::LocalInventoryEp> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::inv::LocalInventoryEp>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of LocalInventoryEp from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]
     * 
     * @param framework the framework instance to use 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::LocalInventoryEp> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("InvUniverse").addElement("InvLocalEndpointInventory").addElement(invLocalEndpointInventoryName).addElement("InvLocalInventoryEp").addElement(invLocalInventoryEpUuid).build());
    }

    /**
     * Retrieve an instance of LocalInventoryEp from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]
     * 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::LocalInventoryEp> > resolve(
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),invLocalEndpointInventoryName,invLocalInventoryEpUuid);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::inv::LocalInventoryEpToGroupRSrc> > resolveInvLocalInventoryEpToGroupRSrc(
        )
    {
        return modelgbp::inv::LocalInventoryEpToGroupRSrc::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("InvLocalInventoryEpToGroupRSrc").build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::inv::LocalInventoryEpToGroupRSrc> addInvLocalInventoryEpToGroupRSrc(
        )
    {
        OF_SHARED_PTR<modelgbp::inv::LocalInventoryEpToGroupRSrc> result = addChild<modelgbp::inv::LocalInventoryEpToGroupRSrc>(
            CLASS_ID, getURI(), 2151284853ul, 117,
            opflex::modb::URIBuilder(getURI()).addElement("InvLocalInventoryEpToGroupRSrc").build()
            );
        return result;
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param invLocalInventoryEpToSecGroupRSrcTargetClass the value of invLocalInventoryEpToSecGroupRSrcTargetClass,
     * a naming property for LocalInventoryEpToSecGroupRSrc
     * @param invLocalInventoryEpToSecGroupRSrcTargetName the value of invLocalInventoryEpToSecGroupRSrcTargetName,
     * a naming property for LocalInventoryEpToSecGroupRSrc
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::inv::LocalInventoryEpToSecGroupRSrc> > resolveInvLocalInventoryEpToSecGroupRSrc(
        const std::string& invLocalInventoryEpToSecGroupRSrcTargetName)
    {
        opflex::modb::class_id_t invLocalInventoryEpToSecGroupRSrcTargetClass = 203;
        return modelgbp::inv::LocalInventoryEpToSecGroupRSrc::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("InvLocalInventoryEpToSecGroupRSrc").addElement(invLocalInventoryEpToSecGroupRSrcTargetClass).addElement(invLocalInventoryEpToSecGroupRSrcTargetName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param invLocalInventoryEpToSecGroupRSrcTargetClass the value of invLocalInventoryEpToSecGroupRSrcTargetClass,
     * a naming property for LocalInventoryEpToSecGroupRSrc
     * @param invLocalInventoryEpToSecGroupRSrcTargetName the value of invLocalInventoryEpToSecGroupRSrcTargetName,
     * a naming property for LocalInventoryEpToSecGroupRSrc
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::inv::LocalInventoryEpToSecGroupRSrc> addInvLocalInventoryEpToSecGroupRSrc(
        const std::string& invLocalInventoryEpToSecGroupRSrcTargetName)
    {
        opflex::modb::class_id_t invLocalInventoryEpToSecGroupRSrcTargetClass = 203;
        OF_SHARED_PTR<modelgbp::inv::LocalInventoryEpToSecGroupRSrc> result = addChild<modelgbp::inv::LocalInventoryEpToSecGroupRSrc>(
            CLASS_ID, getURI(), 2151284856ul, 120,
            opflex::modb::URIBuilder(getURI()).addElement("InvLocalInventoryEpToSecGroupRSrc").addElement(invLocalInventoryEpToSecGroupRSrcTargetClass).addElement(invLocalInventoryEpToSecGroupRSrcTargetName).build()
            );
        result->setTargetSecGroup(opflex::modb::URI(invLocalInventoryEpToSecGroupRSrcTargetName));
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::inv::LocalInventoryEpToSecGroupRSrc
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveInvLocalInventoryEpToSecGroupRSrc(/* out */ std::vector<OF_SHARED_PTR<modelgbp::inv::LocalInventoryEpToSecGroupRSrc> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::inv::LocalInventoryEpToSecGroupRSrc>(
            getFramework(), CLASS_ID, getURI(), 2151284856ul, 120, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param invIpIp the value of invIpIp,
     * a naming property for Ip
     * @param invIpType the value of invIpType,
     * a naming property for Ip
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::inv::Ip> > resolveInvIp(
        const std::string& invIpIp,
        const std::string& invIpType)
    {
        return modelgbp::inv::Ip::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("InvIp").addElement(invIpIp).addElement(invIpType).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param invIpIp the value of invIpIp,
     * a naming property for Ip
     * @param invIpType the value of invIpType,
     * a naming property for Ip
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::inv::Ip> addInvIp(
        const std::string& invIpIp,
        const std::string& invIpType)
    {
        OF_SHARED_PTR<modelgbp::inv::Ip> result = addChild<modelgbp::inv::Ip>(
            CLASS_ID, getURI(), 2151284859ul, 123,
            opflex::modb::URIBuilder(getURI()).addElement("InvIp").addElement(invIpIp).addElement(invIpType).build()
            );
        result->setIp(invIpIp);
        result->setType(invIpType);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::inv::Ip
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveInvIp(/* out */ std::vector<OF_SHARED_PTR<modelgbp::inv::Ip> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::inv::Ip>(
            getFramework(), CLASS_ID, getURI(), 2151284859ul, 123, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param invIpMappingName the value of invIpMappingName,
     * a naming property for IpMapping
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::inv::IpMapping> > resolveInvIpMapping(
        const std::string& invIpMappingName)
    {
        return modelgbp::inv::IpMapping::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("InvIpMapping").addElement(invIpMappingName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param invIpMappingName the value of invIpMappingName,
     * a naming property for IpMapping
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::inv::IpMapping> addInvIpMapping(
        const std::string& invIpMappingName)
    {
        OF_SHARED_PTR<modelgbp::inv::IpMapping> result = addChild<modelgbp::inv::IpMapping>(
            CLASS_ID, getURI(), 2151284860ul, 124,
            opflex::modb::URIBuilder(getURI()).addElement("InvIpMapping").addElement(invIpMappingName).build()
            );
        result->setName(invIpMappingName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::inv::IpMapping
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveInvIpMapping(/* out */ std::vector<OF_SHARED_PTR<modelgbp::inv::IpMapping> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::inv::IpMapping>(
            getFramework(), CLASS_ID, getURI(), 2151284860ul, 124, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param invInterfaceName the value of invInterfaceName,
     * a naming property for Interface
     * @param invInterfaceType the value of invInterfaceType,
     * a naming property for Interface
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::inv::Interface> > resolveInvInterface(
        const std::string& invInterfaceName,
        const std::string& invInterfaceType)
    {
        return modelgbp::inv::Interface::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("InvInterface").addElement(invInterfaceName).addElement(invInterfaceType).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param invInterfaceName the value of invInterfaceName,
     * a naming property for Interface
     * @param invInterfaceType the value of invInterfaceType,
     * a naming property for Interface
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::inv::Interface> addInvInterface(
        const std::string& invInterfaceName,
        const std::string& invInterfaceType)
    {
        OF_SHARED_PTR<modelgbp::inv::Interface> result = addChild<modelgbp::inv::Interface>(
            CLASS_ID, getURI(), 2151284864ul, 128,
            opflex::modb::URIBuilder(getURI()).addElement("InvInterface").addElement(invInterfaceName).addElement(invInterfaceType).build()
            );
        result->setName(invInterfaceName);
        result->setType(invInterfaceType);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::inv::Interface
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveInvInterface(/* out */ std::vector<OF_SHARED_PTR<modelgbp::inv::Interface> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::inv::Interface>(
            getFramework(), CLASS_ID, getURI(), 2151284864ul, 128, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::inv::DHCPv4Config> > resolveInvDHCPv4Config(
        )
    {
        return modelgbp::inv::DHCPv4Config::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("InvDHCPv4Config").build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::inv::DHCPv4Config> addInvDHCPv4Config(
        )
    {
        OF_SHARED_PTR<modelgbp::inv::DHCPv4Config> result = addChild<modelgbp::inv::DHCPv4Config>(
            CLASS_ID, getURI(), 2151284866ul, 130,
            opflex::modb::URIBuilder(getURI()).addElement("InvDHCPv4Config").build()
            );
        return result;
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::inv::DHCPv6Config> > resolveInvDHCPv6Config(
        )
    {
        return modelgbp::inv::DHCPv6Config::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("InvDHCPv6Config").build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::inv::DHCPv6Config> addInvDHCPv6Config(
        )
    {
        OF_SHARED_PTR<modelgbp::inv::DHCPv6Config> result = addChild<modelgbp::inv::DHCPv6Config>(
            CLASS_ID, getURI(), 2151284870ul, 134,
            opflex::modb::URIBuilder(getURI()).addElement("InvDHCPv6Config").build()
            );
        return result;
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param invAttributeName the value of invAttributeName,
     * a naming property for Attribute
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::inv::Attribute> > resolveInvAttribute(
        const std::string& invAttributeName)
    {
        return modelgbp::inv::Attribute::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("InvAttribute").addElement(invAttributeName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param invAttributeName the value of invAttributeName,
     * a naming property for Attribute
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::inv::Attribute> addInvAttribute(
        const std::string& invAttributeName)
    {
        OF_SHARED_PTR<modelgbp::inv::Attribute> result = addChild<modelgbp::inv::Attribute>(
            CLASS_ID, getURI(), 2151284872ul, 136,
            opflex::modb::URIBuilder(getURI()).addElement("InvAttribute").addElement(invAttributeName).build()
            );
        result->setName(invAttributeName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::inv::Attribute
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveInvAttribute(/* out */ std::vector<OF_SHARED_PTR<modelgbp::inv::Attribute> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::inv::Attribute>(
            getFramework(), CLASS_ID, getURI(), 2151284872ul, 136, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the LocalInventoryEp object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the LocalInventoryEp object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the LocalInventoryEp object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]
     * 
     * @param framework the framework instance to use
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("InvUniverse").addElement("InvLocalEndpointInventory").addElement(invLocalEndpointInventoryName).addElement("InvLocalInventoryEp").addElement(invLocalInventoryEpUuid).build());
    }

    /**
     * Remove the LocalInventoryEp object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]
     * 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),invLocalEndpointInventoryName,invLocalInventoryEpUuid);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of LocalInventoryEp.
     * This should not typically be called from user code.
     */
    LocalInventoryEp(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class LocalInventoryEp

} // namespace inv
} // namespace modelgbp
#endif // GI_INV_LOCALINVENTORYEP_HPP
