/**
 * 
 * SOME COPYRIGHT
 * 
 * Router.hpp
 * 
 * generated Router.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_INV_ROUTER_HPP
#define GI_INV_ROUTER_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"

namespace modelgbp {
namespace inv {

class Router
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for Router
     */
    static const opflex::modb::class_id_t CLASS_ID = 132;

    /**
     * Check whether name has been set
     * @return true if name has been set
     */
    bool isNameSet()
    {
        return getObjectInstance().isSet(4325377ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of name if it has been set.
     * @return the value of name or boost::none if not set
     */
    boost::optional<const std::string&> getName()
    {
        if (isNameSet())
            return getObjectInstance().getString(4325377ul);
        return boost::none;
    }

    /**
     * Get the value of name if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of name if set, otherwise the value of default passed in
     */
    const std::string& getName(const std::string& defaultValue)
    {
        return getName().get_value_or(defaultValue);
    }

    /**
     * Set name to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::Router& setName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(4325377ul, newValue);
        return *this;
    }

    /**
     * Unset name in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::inv::Router& unsetName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(4325377ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of Router from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::Router> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::inv::Router>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of Router from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::Router> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::inv::Router>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of Router from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvDHCPv4Config/InvRouter/[invRouterName]
     * 
     * @param framework the framework instance to use 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @param invRouterName the value of invRouterName,
     * a naming property for Router
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::Router> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid,
        const std::string& invRouterName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("InvUniverse").addElement("InvLocalEndpointInventory").addElement(invLocalEndpointInventoryName).addElement("InvLocalInventoryEp").addElement(invLocalInventoryEpUuid).addElement("InvDHCPv4Config").addElement("InvRouter").addElement(invRouterName).build());
    }

    /**
     * Retrieve an instance of Router from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvDHCPv4Config/InvRouter/[invRouterName]
     * 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @param invRouterName the value of invRouterName,
     * a naming property for Router
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::inv::Router> > resolve(
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid,
        const std::string& invRouterName)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),invLocalEndpointInventoryName,invLocalInventoryEpUuid,invRouterName);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the Router object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the Router object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the Router object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvDHCPv4Config/InvRouter/[invRouterName]
     * 
     * @param framework the framework instance to use
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @param invRouterName the value of invRouterName,
     * a naming property for Router
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid,
        const std::string& invRouterName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("InvUniverse").addElement("InvLocalEndpointInventory").addElement(invLocalEndpointInventoryName).addElement("InvLocalInventoryEp").addElement(invLocalInventoryEpUuid).addElement("InvDHCPv4Config").addElement("InvRouter").addElement(invRouterName).build());
    }

    /**
     * Remove the Router object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /InvUniverse/InvLocalEndpointInventory/[invLocalEndpointInventoryName]/InvLocalInventoryEp/[invLocalInventoryEpUuid]/InvDHCPv4Config/InvRouter/[invRouterName]
     * 
     * @param invLocalEndpointInventoryName the value of invLocalEndpointInventoryName,
     * a naming property for LocalEndpointInventory
     * @param invLocalInventoryEpUuid the value of invLocalInventoryEpUuid,
     * a naming property for LocalInventoryEp
     * @param invRouterName the value of invRouterName,
     * a naming property for Router
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& invLocalEndpointInventoryName,
        const std::string& invLocalInventoryEpUuid,
        const std::string& invRouterName)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),invLocalEndpointInventoryName,invLocalInventoryEpUuid,invRouterName);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of Router.
     * This should not typically be called from user code.
     */
    Router(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class Router

} // namespace inv
} // namespace modelgbp
#endif // GI_INV_ROUTER_HPP
