/**
 * 
 * SOME COPYRIGHT
 * 
 * EpStatUniverse.hpp
 * 
 * generated EpStatUniverse.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_OBSERVER_EPSTATUNIVERSE_HPP
#define GI_OBSERVER_EPSTATUNIVERSE_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(gbpe/EpCounter)
 */
#include "modelgbp/gbpe/EpCounter.hpp"
/*
 * contains: item:mclass(dfw/EpCounter)
 */
#include "modelgbp/dfw/EpCounter.hpp"

namespace modelgbp {
namespace observer {

class EpStatUniverse
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for EpStatUniverse
     */
    static const opflex::modb::class_id_t CLASS_ID = 212;

    /**
     * Retrieve an instance of EpStatUniverse from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::observer::EpStatUniverse> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::observer::EpStatUniverse>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of EpStatUniverse from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::observer::EpStatUniverse> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::observer::EpStatUniverse>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of EpStatUniverse from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverEpStatUniverse
     * 
     * @param framework the framework instance to use 
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::observer::EpStatUniverse> > resolve(
        opflex::ofcore::OFFramework& framework)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("ObserverEpStatUniverse").build());
    }

    /**
     * Retrieve an instance of EpStatUniverse from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverEpStatUniverse
     * 
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::observer::EpStatUniverse> > resolve(
        )
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance());
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpeEpCounterUuid the value of gbpeEpCounterUuid,
     * a naming property for EpCounter
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpCounter> > resolveGbpeEpCounter(
        const std::string& gbpeEpCounterUuid)
    {
        return modelgbp::gbpe::EpCounter::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeEpCounter").addElement(gbpeEpCounterUuid).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpeEpCounterUuid the value of gbpeEpCounterUuid,
     * a naming property for EpCounter
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::EpCounter> addGbpeEpCounter(
        const std::string& gbpeEpCounterUuid)
    {
        OF_SHARED_PTR<modelgbp::gbpe::EpCounter> result = addChild<modelgbp::gbpe::EpCounter>(
            CLASS_ID, getURI(), 2154430507ul, 43,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeEpCounter").addElement(gbpeEpCounterUuid).build()
            );
        result->setUuid(gbpeEpCounterUuid);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbpe::EpCounter
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpeEpCounter(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbpe::EpCounter> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbpe::EpCounter>(
            getFramework(), CLASS_ID, getURI(), 2154430507ul, 43, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param dfwEpCounterUuid the value of dfwEpCounterUuid,
     * a naming property for EpCounter
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::dfw::EpCounter> > resolveDfwEpCounter(
        const std::string& dfwEpCounterUuid)
    {
        return modelgbp::dfw::EpCounter::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("DfwEpCounter").addElement(dfwEpCounterUuid).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param dfwEpCounterUuid the value of dfwEpCounterUuid,
     * a naming property for EpCounter
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::dfw::EpCounter> addDfwEpCounter(
        const std::string& dfwEpCounterUuid)
    {
        OF_SHARED_PTR<modelgbp::dfw::EpCounter> result = addChild<modelgbp::dfw::EpCounter>(
            CLASS_ID, getURI(), 2154430519ul, 55,
            opflex::modb::URIBuilder(getURI()).addElement("DfwEpCounter").addElement(dfwEpCounterUuid).build()
            );
        result->setUuid(dfwEpCounterUuid);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::dfw::EpCounter
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveDfwEpCounter(/* out */ std::vector<OF_SHARED_PTR<modelgbp::dfw::EpCounter> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::dfw::EpCounter>(
            getFramework(), CLASS_ID, getURI(), 2154430519ul, 55, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the EpStatUniverse object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the EpStatUniverse object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of EpStatUniverse.
     * This should not typically be called from user code.
     */
    EpStatUniverse(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class EpStatUniverse

} // namespace observer
} // namespace modelgbp
#endif // GI_OBSERVER_EPSTATUNIVERSE_HPP
