/**
 * 
 * SOME COPYRIGHT
 * 
 * PolicyStatUniverse.hpp
 * 
 * generated PolicyStatUniverse.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_OBSERVER_POLICYSTATUNIVERSE_HPP
#define GI_OBSERVER_POLICYSTATUNIVERSE_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(gbpe/L24ClassifierCounter)
 */
#include "modelgbp/gbpe/L24ClassifierCounter.hpp"
/*
 * contains: item:mclass(gbpe/SecGrpClassifierCounter)
 */
#include "modelgbp/gbpe/SecGrpClassifierCounter.hpp"
/*
 * contains: item:mclass(gbpe/RoutingDomainDropCounter)
 */
#include "modelgbp/gbpe/RoutingDomainDropCounter.hpp"

namespace modelgbp {
namespace observer {

class PolicyStatUniverse
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for PolicyStatUniverse
     */
    static const opflex::modb::class_id_t CLASS_ID = 213;

    /**
     * Retrieve an instance of PolicyStatUniverse from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::observer::PolicyStatUniverse> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::observer::PolicyStatUniverse>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of PolicyStatUniverse from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::observer::PolicyStatUniverse> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::observer::PolicyStatUniverse>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of PolicyStatUniverse from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverPolicyStatUniverse
     * 
     * @param framework the framework instance to use 
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::observer::PolicyStatUniverse> > resolve(
        opflex::ofcore::OFFramework& framework)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("ObserverPolicyStatUniverse").build());
    }

    /**
     * Retrieve an instance of PolicyStatUniverse from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverPolicyStatUniverse
     * 
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::observer::PolicyStatUniverse> > resolve(
        )
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance());
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpeL24ClassifierCounterUuid the value of gbpeL24ClassifierCounterUuid,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterGenId the value of gbpeL24ClassifierCounterGenId,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterSrcEpg the value of gbpeL24ClassifierCounterSrcEpg,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterDstEpg the value of gbpeL24ClassifierCounterDstEpg,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterClassifier the value of gbpeL24ClassifierCounterClassifier,
     * a naming property for L24ClassifierCounter
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::L24ClassifierCounter> > resolveGbpeL24ClassifierCounter(
        const std::string& gbpeL24ClassifierCounterUuid,
        uint64_t gbpeL24ClassifierCounterGenId,
        const std::string& gbpeL24ClassifierCounterSrcEpg,
        const std::string& gbpeL24ClassifierCounterDstEpg,
        const std::string& gbpeL24ClassifierCounterClassifier)
    {
        return modelgbp::gbpe::L24ClassifierCounter::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeL24ClassifierCounter").addElement(gbpeL24ClassifierCounterUuid).addElement(gbpeL24ClassifierCounterGenId).addElement(gbpeL24ClassifierCounterSrcEpg).addElement(gbpeL24ClassifierCounterDstEpg).addElement(gbpeL24ClassifierCounterClassifier).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpeL24ClassifierCounterUuid the value of gbpeL24ClassifierCounterUuid,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterGenId the value of gbpeL24ClassifierCounterGenId,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterSrcEpg the value of gbpeL24ClassifierCounterSrcEpg,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterDstEpg the value of gbpeL24ClassifierCounterDstEpg,
     * a naming property for L24ClassifierCounter
     * @param gbpeL24ClassifierCounterClassifier the value of gbpeL24ClassifierCounterClassifier,
     * a naming property for L24ClassifierCounter
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::L24ClassifierCounter> addGbpeL24ClassifierCounter(
        const std::string& gbpeL24ClassifierCounterUuid,
        uint64_t gbpeL24ClassifierCounterGenId,
        const std::string& gbpeL24ClassifierCounterSrcEpg,
        const std::string& gbpeL24ClassifierCounterDstEpg,
        const std::string& gbpeL24ClassifierCounterClassifier)
    {
        OF_SHARED_PTR<modelgbp::gbpe::L24ClassifierCounter> result = addChild<modelgbp::gbpe::L24ClassifierCounter>(
            CLASS_ID, getURI(), 2154463280ul, 48,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeL24ClassifierCounter").addElement(gbpeL24ClassifierCounterUuid).addElement(gbpeL24ClassifierCounterGenId).addElement(gbpeL24ClassifierCounterSrcEpg).addElement(gbpeL24ClassifierCounterDstEpg).addElement(gbpeL24ClassifierCounterClassifier).build()
            );
        result->setUuid(gbpeL24ClassifierCounterUuid);
        result->setGenId(gbpeL24ClassifierCounterGenId);
        result->setSrcEpg(gbpeL24ClassifierCounterSrcEpg);
        result->setDstEpg(gbpeL24ClassifierCounterDstEpg);
        result->setClassifier(gbpeL24ClassifierCounterClassifier);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbpe::L24ClassifierCounter
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpeL24ClassifierCounter(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbpe::L24ClassifierCounter> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbpe::L24ClassifierCounter>(
            getFramework(), CLASS_ID, getURI(), 2154463280ul, 48, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpeSecGrpClassifierCounterUuid the value of gbpeSecGrpClassifierCounterUuid,
     * a naming property for SecGrpClassifierCounter
     * @param gbpeSecGrpClassifierCounterGenId the value of gbpeSecGrpClassifierCounterGenId,
     * a naming property for SecGrpClassifierCounter
     * @param gbpeSecGrpClassifierCounterClassifier the value of gbpeSecGrpClassifierCounterClassifier,
     * a naming property for SecGrpClassifierCounter
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::SecGrpClassifierCounter> > resolveGbpeSecGrpClassifierCounter(
        const std::string& gbpeSecGrpClassifierCounterUuid,
        uint64_t gbpeSecGrpClassifierCounterGenId,
        const std::string& gbpeSecGrpClassifierCounterClassifier)
    {
        return modelgbp::gbpe::SecGrpClassifierCounter::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeSecGrpClassifierCounter").addElement(gbpeSecGrpClassifierCounterUuid).addElement(gbpeSecGrpClassifierCounterGenId).addElement(gbpeSecGrpClassifierCounterClassifier).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpeSecGrpClassifierCounterUuid the value of gbpeSecGrpClassifierCounterUuid,
     * a naming property for SecGrpClassifierCounter
     * @param gbpeSecGrpClassifierCounterGenId the value of gbpeSecGrpClassifierCounterGenId,
     * a naming property for SecGrpClassifierCounter
     * @param gbpeSecGrpClassifierCounterClassifier the value of gbpeSecGrpClassifierCounterClassifier,
     * a naming property for SecGrpClassifierCounter
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::SecGrpClassifierCounter> addGbpeSecGrpClassifierCounter(
        const std::string& gbpeSecGrpClassifierCounterUuid,
        uint64_t gbpeSecGrpClassifierCounterGenId,
        const std::string& gbpeSecGrpClassifierCounterClassifier)
    {
        OF_SHARED_PTR<modelgbp::gbpe::SecGrpClassifierCounter> result = addChild<modelgbp::gbpe::SecGrpClassifierCounter>(
            CLASS_ID, getURI(), 2154463281ul, 49,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeSecGrpClassifierCounter").addElement(gbpeSecGrpClassifierCounterUuid).addElement(gbpeSecGrpClassifierCounterGenId).addElement(gbpeSecGrpClassifierCounterClassifier).build()
            );
        result->setUuid(gbpeSecGrpClassifierCounterUuid);
        result->setGenId(gbpeSecGrpClassifierCounterGenId);
        result->setClassifier(gbpeSecGrpClassifierCounterClassifier);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbpe::SecGrpClassifierCounter
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpeSecGrpClassifierCounter(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbpe::SecGrpClassifierCounter> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbpe::SecGrpClassifierCounter>(
            getFramework(), CLASS_ID, getURI(), 2154463281ul, 49, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpeRoutingDomainDropCounterUuid the value of gbpeRoutingDomainDropCounterUuid,
     * a naming property for RoutingDomainDropCounter
     * @param gbpeRoutingDomainDropCounterGenId the value of gbpeRoutingDomainDropCounterGenId,
     * a naming property for RoutingDomainDropCounter
     * @param gbpeRoutingDomainDropCounterRoutingDomain the value of gbpeRoutingDomainDropCounterRoutingDomain,
     * a naming property for RoutingDomainDropCounter
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::RoutingDomainDropCounter> > resolveGbpeRoutingDomainDropCounter(
        const std::string& gbpeRoutingDomainDropCounterUuid,
        uint64_t gbpeRoutingDomainDropCounterGenId,
        const std::string& gbpeRoutingDomainDropCounterRoutingDomain)
    {
        return modelgbp::gbpe::RoutingDomainDropCounter::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeRoutingDomainDropCounter").addElement(gbpeRoutingDomainDropCounterUuid).addElement(gbpeRoutingDomainDropCounterGenId).addElement(gbpeRoutingDomainDropCounterRoutingDomain).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpeRoutingDomainDropCounterUuid the value of gbpeRoutingDomainDropCounterUuid,
     * a naming property for RoutingDomainDropCounter
     * @param gbpeRoutingDomainDropCounterGenId the value of gbpeRoutingDomainDropCounterGenId,
     * a naming property for RoutingDomainDropCounter
     * @param gbpeRoutingDomainDropCounterRoutingDomain the value of gbpeRoutingDomainDropCounterRoutingDomain,
     * a naming property for RoutingDomainDropCounter
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::RoutingDomainDropCounter> addGbpeRoutingDomainDropCounter(
        const std::string& gbpeRoutingDomainDropCounterUuid,
        uint64_t gbpeRoutingDomainDropCounterGenId,
        const std::string& gbpeRoutingDomainDropCounterRoutingDomain)
    {
        OF_SHARED_PTR<modelgbp::gbpe::RoutingDomainDropCounter> result = addChild<modelgbp::gbpe::RoutingDomainDropCounter>(
            CLASS_ID, getURI(), 2154463282ul, 50,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeRoutingDomainDropCounter").addElement(gbpeRoutingDomainDropCounterUuid).addElement(gbpeRoutingDomainDropCounterGenId).addElement(gbpeRoutingDomainDropCounterRoutingDomain).build()
            );
        result->setUuid(gbpeRoutingDomainDropCounterUuid);
        result->setGenId(gbpeRoutingDomainDropCounterGenId);
        result->setRoutingDomain(gbpeRoutingDomainDropCounterRoutingDomain);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbpe::RoutingDomainDropCounter
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpeRoutingDomainDropCounter(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbpe::RoutingDomainDropCounter> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbpe::RoutingDomainDropCounter>(
            getFramework(), CLASS_ID, getURI(), 2154463282ul, 50, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the PolicyStatUniverse object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the PolicyStatUniverse object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of PolicyStatUniverse.
     * This should not typically be called from user code.
     */
    PolicyStatUniverse(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class PolicyStatUniverse

} // namespace observer
} // namespace modelgbp
#endif // GI_OBSERVER_POLICYSTATUNIVERSE_HPP
