/**
 * 
 * SOME COPYRIGHT
 * 
 * Space.hpp
 * 
 * generated Space.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_POLICY_SPACE_HPP
#define GI_POLICY_SPACE_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(gbpe/L24Classifier)
 */
#include "modelgbp/gbpe/L24Classifier.hpp"
/*
 * contains: item:mclass(gbp/AllowDenyAction)
 */
#include "modelgbp/gbp/AllowDenyAction.hpp"
/*
 * contains: item:mclass(gbp/Contract)
 */
#include "modelgbp/gbp/Contract.hpp"
/*
 * contains: item:mclass(gbp/EpGroup)
 */
#include "modelgbp/gbp/EpGroup.hpp"
/*
 * contains: item:mclass(gbp/BridgeDomain)
 */
#include "modelgbp/gbp/BridgeDomain.hpp"
/*
 * contains: item:mclass(gbp/FloodDomain)
 */
#include "modelgbp/gbp/FloodDomain.hpp"
/*
 * contains: item:mclass(gbp/RoutingDomain)
 */
#include "modelgbp/gbp/RoutingDomain.hpp"
/*
 * contains: item:mclass(gbp/Subnets)
 */
#include "modelgbp/gbp/Subnets.hpp"
/*
 * contains: item:mclass(gbp/SecGroup)
 */
#include "modelgbp/gbp/SecGroup.hpp"

namespace modelgbp {
namespace policy {

class Space
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for Space
     */
    static const opflex::modb::class_id_t CLASS_ID = 224;

    /**
     * Check whether name has been set
     * @return true if name has been set
     */
    bool isNameSet()
    {
        return getObjectInstance().isSet(7340033ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of name if it has been set.
     * @return the value of name or boost::none if not set
     */
    boost::optional<const std::string&> getName()
    {
        if (isNameSet())
            return getObjectInstance().getString(7340033ul);
        return boost::none;
    }

    /**
     * Get the value of name if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of name if set, otherwise the value of default passed in
     */
    const std::string& getName(const std::string& defaultValue)
    {
        return getName().get_value_or(defaultValue);
    }

    /**
     * Set name to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::policy::Space& setName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(7340033ul, newValue);
        return *this;
    }

    /**
     * Unset name in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::policy::Space& unsetName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(7340033ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of Space from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::policy::Space> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::policy::Space>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of Space from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::policy::Space> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::policy::Space>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of Space from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]
     * 
     * @param framework the framework instance to use 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::policy::Space> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& policySpaceName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PolicySpace").addElement(policySpaceName).build());
    }

    /**
     * Retrieve an instance of Space from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::policy::Space> > resolve(
        const std::string& policySpaceName)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),policySpaceName);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpeL24ClassifierName the value of gbpeL24ClassifierName,
     * a naming property for L24Classifier
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::L24Classifier> > resolveGbpeL24Classifier(
        const std::string& gbpeL24ClassifierName)
    {
        return modelgbp::gbpe::L24Classifier::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeL24Classifier").addElement(gbpeL24ClassifierName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpeL24ClassifierName the value of gbpeL24ClassifierName,
     * a naming property for L24Classifier
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::L24Classifier> addGbpeL24Classifier(
        const std::string& gbpeL24ClassifierName)
    {
        OF_SHARED_PTR<modelgbp::gbpe::L24Classifier> result = addChild<modelgbp::gbpe::L24Classifier>(
            CLASS_ID, getURI(), 2154823722ul, 42,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeL24Classifier").addElement(gbpeL24ClassifierName).build()
            );
        result->setName(gbpeL24ClassifierName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbpe::L24Classifier
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpeL24Classifier(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbpe::L24Classifier> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbpe::L24Classifier>(
            getFramework(), CLASS_ID, getURI(), 2154823722ul, 42, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpAllowDenyActionName the value of gbpAllowDenyActionName,
     * a naming property for AllowDenyAction
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::AllowDenyAction> > resolveGbpAllowDenyAction(
        const std::string& gbpAllowDenyActionName)
    {
        return modelgbp::gbp::AllowDenyAction::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpAllowDenyAction").addElement(gbpAllowDenyActionName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpAllowDenyActionName the value of gbpAllowDenyActionName,
     * a naming property for AllowDenyAction
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::AllowDenyAction> addGbpAllowDenyAction(
        const std::string& gbpAllowDenyActionName)
    {
        OF_SHARED_PTR<modelgbp::gbp::AllowDenyAction> result = addChild<modelgbp::gbp::AllowDenyAction>(
            CLASS_ID, getURI(), 2154823821ul, 141,
            opflex::modb::URIBuilder(getURI()).addElement("GbpAllowDenyAction").addElement(gbpAllowDenyActionName).build()
            );
        result->setName(gbpAllowDenyActionName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::AllowDenyAction
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpAllowDenyAction(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::AllowDenyAction> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::AllowDenyAction>(
            getFramework(), CLASS_ID, getURI(), 2154823821ul, 141, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpContractName the value of gbpContractName,
     * a naming property for Contract
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::Contract> > resolveGbpContract(
        const std::string& gbpContractName)
    {
        return modelgbp::gbp::Contract::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpContract").addElement(gbpContractName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpContractName the value of gbpContractName,
     * a naming property for Contract
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::Contract> addGbpContract(
        const std::string& gbpContractName)
    {
        OF_SHARED_PTR<modelgbp::gbp::Contract> result = addChild<modelgbp::gbp::Contract>(
            CLASS_ID, getURI(), 2154823823ul, 143,
            opflex::modb::URIBuilder(getURI()).addElement("GbpContract").addElement(gbpContractName).build()
            );
        result->setName(gbpContractName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::Contract
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpContract(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::Contract> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::Contract>(
            getFramework(), CLASS_ID, getURI(), 2154823823ul, 143, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpEpGroupName the value of gbpEpGroupName,
     * a naming property for EpGroup
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::EpGroup> > resolveGbpEpGroup(
        const std::string& gbpEpGroupName)
    {
        return modelgbp::gbp::EpGroup::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpEpGroup").addElement(gbpEpGroupName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpEpGroupName the value of gbpEpGroupName,
     * a naming property for EpGroup
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::EpGroup> addGbpEpGroup(
        const std::string& gbpEpGroupName)
    {
        OF_SHARED_PTR<modelgbp::gbp::EpGroup> result = addChild<modelgbp::gbp::EpGroup>(
            CLASS_ID, getURI(), 2154823832ul, 152,
            opflex::modb::URIBuilder(getURI()).addElement("GbpEpGroup").addElement(gbpEpGroupName).build()
            );
        result->setName(gbpEpGroupName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::EpGroup
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpEpGroup(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::EpGroup> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::EpGroup>(
            getFramework(), CLASS_ID, getURI(), 2154823832ul, 152, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpBridgeDomainName the value of gbpBridgeDomainName,
     * a naming property for BridgeDomain
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::BridgeDomain> > resolveGbpBridgeDomain(
        const std::string& gbpBridgeDomainName)
    {
        return modelgbp::gbp::BridgeDomain::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpBridgeDomain").addElement(gbpBridgeDomainName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpBridgeDomainName the value of gbpBridgeDomainName,
     * a naming property for BridgeDomain
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::BridgeDomain> addGbpBridgeDomain(
        const std::string& gbpBridgeDomainName)
    {
        OF_SHARED_PTR<modelgbp::gbp::BridgeDomain> result = addChild<modelgbp::gbp::BridgeDomain>(
            CLASS_ID, getURI(), 2154823861ul, 181,
            opflex::modb::URIBuilder(getURI()).addElement("GbpBridgeDomain").addElement(gbpBridgeDomainName).build()
            );
        result->setName(gbpBridgeDomainName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::BridgeDomain
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpBridgeDomain(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::BridgeDomain> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::BridgeDomain>(
            getFramework(), CLASS_ID, getURI(), 2154823861ul, 181, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpFloodDomainName the value of gbpFloodDomainName,
     * a naming property for FloodDomain
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::FloodDomain> > resolveGbpFloodDomain(
        const std::string& gbpFloodDomainName)
    {
        return modelgbp::gbp::FloodDomain::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpFloodDomain").addElement(gbpFloodDomainName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpFloodDomainName the value of gbpFloodDomainName,
     * a naming property for FloodDomain
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::FloodDomain> addGbpFloodDomain(
        const std::string& gbpFloodDomainName)
    {
        OF_SHARED_PTR<modelgbp::gbp::FloodDomain> result = addChild<modelgbp::gbp::FloodDomain>(
            CLASS_ID, getURI(), 2154823865ul, 185,
            opflex::modb::URIBuilder(getURI()).addElement("GbpFloodDomain").addElement(gbpFloodDomainName).build()
            );
        result->setName(gbpFloodDomainName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::FloodDomain
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpFloodDomain(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::FloodDomain> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::FloodDomain>(
            getFramework(), CLASS_ID, getURI(), 2154823865ul, 185, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpRoutingDomainName the value of gbpRoutingDomainName,
     * a naming property for RoutingDomain
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::RoutingDomain> > resolveGbpRoutingDomain(
        const std::string& gbpRoutingDomainName)
    {
        return modelgbp::gbp::RoutingDomain::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpRoutingDomain").addElement(gbpRoutingDomainName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpRoutingDomainName the value of gbpRoutingDomainName,
     * a naming property for RoutingDomain
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::RoutingDomain> addGbpRoutingDomain(
        const std::string& gbpRoutingDomainName)
    {
        OF_SHARED_PTR<modelgbp::gbp::RoutingDomain> result = addChild<modelgbp::gbp::RoutingDomain>(
            CLASS_ID, getURI(), 2154823870ul, 190,
            opflex::modb::URIBuilder(getURI()).addElement("GbpRoutingDomain").addElement(gbpRoutingDomainName).build()
            );
        result->setName(gbpRoutingDomainName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::RoutingDomain
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpRoutingDomain(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::RoutingDomain> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::RoutingDomain>(
            getFramework(), CLASS_ID, getURI(), 2154823870ul, 190, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpSubnetsName the value of gbpSubnetsName,
     * a naming property for Subnets
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::Subnets> > resolveGbpSubnets(
        const std::string& gbpSubnetsName)
    {
        return modelgbp::gbp::Subnets::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpSubnets").addElement(gbpSubnetsName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpSubnetsName the value of gbpSubnetsName,
     * a naming property for Subnets
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::Subnets> addGbpSubnets(
        const std::string& gbpSubnetsName)
    {
        OF_SHARED_PTR<modelgbp::gbp::Subnets> result = addChild<modelgbp::gbp::Subnets>(
            CLASS_ID, getURI(), 2154823876ul, 196,
            opflex::modb::URIBuilder(getURI()).addElement("GbpSubnets").addElement(gbpSubnetsName).build()
            );
        result->setName(gbpSubnetsName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::Subnets
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpSubnets(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::Subnets> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::Subnets>(
            getFramework(), CLASS_ID, getURI(), 2154823876ul, 196, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpSecGroupName the value of gbpSecGroupName,
     * a naming property for SecGroup
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbp::SecGroup> > resolveGbpSecGroup(
        const std::string& gbpSecGroupName)
    {
        return modelgbp::gbp::SecGroup::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpSecGroup").addElement(gbpSecGroupName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpSecGroupName the value of gbpSecGroupName,
     * a naming property for SecGroup
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbp::SecGroup> addGbpSecGroup(
        const std::string& gbpSecGroupName)
    {
        OF_SHARED_PTR<modelgbp::gbp::SecGroup> result = addChild<modelgbp::gbp::SecGroup>(
            CLASS_ID, getURI(), 2154823883ul, 203,
            opflex::modb::URIBuilder(getURI()).addElement("GbpSecGroup").addElement(gbpSecGroupName).build()
            );
        result->setName(gbpSecGroupName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbp::SecGroup
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpSecGroup(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbp::SecGroup> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbp::SecGroup>(
            getFramework(), CLASS_ID, getURI(), 2154823883ul, 203, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the Space object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the Space object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the Space object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]
     * 
     * @param framework the framework instance to use
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& policySpaceName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PolicySpace").addElement(policySpaceName).build());
    }

    /**
     * Remove the Space object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PolicySpace/[policySpaceName]
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& policySpaceName)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),policySpaceName);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of Space.
     * This should not typically be called from user code.
     */
    Space(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class Space

} // namespace policy
} // namespace modelgbp
#endif // GI_POLICY_SPACE_HPP
