/**
 * 
 * SOME COPYRIGHT
 * 
 * Universe.hpp
 * 
 * generated Universe.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_POLICY_UNIVERSE_HPP
#define GI_POLICY_UNIVERSE_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(gbpe/EpgMapping)
 */
#include "modelgbp/gbpe/EpgMapping.hpp"
/*
 * contains: item:mclass(gbpe/IndirectEpgMapping)
 */
#include "modelgbp/gbpe/IndirectEpgMapping.hpp"
/*
 * contains: item:mclass(gbpe/MappingRuleSet)
 */
#include "modelgbp/gbpe/MappingRuleSet.hpp"
/*
 * contains: item:mclass(platform/Config)
 */
#include "modelgbp/platform/Config.hpp"
/*
 * contains: item:mclass(policy/Space)
 */
#include "modelgbp/policy/Space.hpp"

namespace modelgbp {
namespace policy {

class Universe
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for Universe
     */
    static const opflex::modb::class_id_t CLASS_ID = 223;

    /**
     * Retrieve an instance of Universe from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::policy::Universe> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::policy::Universe>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of Universe from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::policy::Universe> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::policy::Universe>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of Universe from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse
     * 
     * @param framework the framework instance to use 
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::policy::Universe> > resolve(
        opflex::ofcore::OFFramework& framework)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("PolicyUniverse").build());
    }

    /**
     * Retrieve an instance of Universe from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse
     * 
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::policy::Universe> > resolve(
        )
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance());
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpeEpgMappingName the value of gbpeEpgMappingName,
     * a naming property for EpgMapping
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::EpgMapping> > resolveGbpeEpgMapping(
        const std::string& gbpeEpgMappingName)
    {
        return modelgbp::gbpe::EpgMapping::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeEpgMapping").addElement(gbpeEpgMappingName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpeEpgMappingName the value of gbpeEpgMappingName,
     * a naming property for EpgMapping
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::EpgMapping> addGbpeEpgMapping(
        const std::string& gbpeEpgMappingName)
    {
        OF_SHARED_PTR<modelgbp::gbpe::EpgMapping> result = addChild<modelgbp::gbpe::EpgMapping>(
            CLASS_ID, getURI(), 2154790922ul, 10,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeEpgMapping").addElement(gbpeEpgMappingName).build()
            );
        result->setName(gbpeEpgMappingName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbpe::EpgMapping
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpeEpgMapping(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbpe::EpgMapping> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbpe::EpgMapping>(
            getFramework(), CLASS_ID, getURI(), 2154790922ul, 10, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpeIndirectEpgMappingName the value of gbpeIndirectEpgMappingName,
     * a naming property for IndirectEpgMapping
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::IndirectEpgMapping> > resolveGbpeIndirectEpgMapping(
        const std::string& gbpeIndirectEpgMappingName)
    {
        return modelgbp::gbpe::IndirectEpgMapping::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeIndirectEpgMapping").addElement(gbpeIndirectEpgMappingName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpeIndirectEpgMappingName the value of gbpeIndirectEpgMappingName,
     * a naming property for IndirectEpgMapping
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::IndirectEpgMapping> addGbpeIndirectEpgMapping(
        const std::string& gbpeIndirectEpgMappingName)
    {
        OF_SHARED_PTR<modelgbp::gbpe::IndirectEpgMapping> result = addChild<modelgbp::gbpe::IndirectEpgMapping>(
            CLASS_ID, getURI(), 2154790926ul, 14,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeIndirectEpgMapping").addElement(gbpeIndirectEpgMappingName).build()
            );
        result->setName(gbpeIndirectEpgMappingName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbpe::IndirectEpgMapping
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpeIndirectEpgMapping(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbpe::IndirectEpgMapping> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbpe::IndirectEpgMapping>(
            getFramework(), CLASS_ID, getURI(), 2154790926ul, 14, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param gbpeMappingRuleSetName the value of gbpeMappingRuleSetName,
     * a naming property for MappingRuleSet
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::gbpe::MappingRuleSet> > resolveGbpeMappingRuleSet(
        const std::string& gbpeMappingRuleSetName)
    {
        return modelgbp::gbpe::MappingRuleSet::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("GbpeMappingRuleSet").addElement(gbpeMappingRuleSetName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param gbpeMappingRuleSetName the value of gbpeMappingRuleSetName,
     * a naming property for MappingRuleSet
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::gbpe::MappingRuleSet> addGbpeMappingRuleSet(
        const std::string& gbpeMappingRuleSetName)
    {
        OF_SHARED_PTR<modelgbp::gbpe::MappingRuleSet> result = addChild<modelgbp::gbpe::MappingRuleSet>(
            CLASS_ID, getURI(), 2154790940ul, 28,
            opflex::modb::URIBuilder(getURI()).addElement("GbpeMappingRuleSet").addElement(gbpeMappingRuleSetName).build()
            );
        result->setName(gbpeMappingRuleSetName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::gbpe::MappingRuleSet
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolveGbpeMappingRuleSet(/* out */ std::vector<OF_SHARED_PTR<modelgbp::gbpe::MappingRuleSet> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::gbpe::MappingRuleSet>(
            getFramework(), CLASS_ID, getURI(), 2154790940ul, 28, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param platformConfigName the value of platformConfigName,
     * a naming property for Config
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::platform::Config> > resolvePlatformConfig(
        const std::string& platformConfigName)
    {
        return modelgbp::platform::Config::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("PlatformConfig").addElement(platformConfigName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param platformConfigName the value of platformConfigName,
     * a naming property for Config
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::platform::Config> addPlatformConfig(
        const std::string& platformConfigName)
    {
        OF_SHARED_PTR<modelgbp::platform::Config> result = addChild<modelgbp::platform::Config>(
            CLASS_ID, getURI(), 2154790963ul, 51,
            opflex::modb::URIBuilder(getURI()).addElement("PlatformConfig").addElement(platformConfigName).build()
            );
        result->setName(platformConfigName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::platform::Config
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolvePlatformConfig(/* out */ std::vector<OF_SHARED_PTR<modelgbp::platform::Config> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::platform::Config>(
            getFramework(), CLASS_ID, getURI(), 2154790963ul, 51, out);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::policy::Space> > resolvePolicySpace(
        const std::string& policySpaceName)
    {
        return modelgbp::policy::Space::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("PolicySpace").addElement(policySpaceName).build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @param policySpaceName the value of policySpaceName,
     * a naming property for Space
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::policy::Space> addPolicySpace(
        const std::string& policySpaceName)
    {
        OF_SHARED_PTR<modelgbp::policy::Space> result = addChild<modelgbp::policy::Space>(
            CLASS_ID, getURI(), 2154791136ul, 224,
            opflex::modb::URIBuilder(getURI()).addElement("PolicySpace").addElement(policySpaceName).build()
            );
        result->setName(policySpaceName);
        return result;
    }

    /**
     * Resolve and retrieve all of the immediate children of type
     * modelgbp::policy::Space
     * 
     * Note that this retrieves only those children that exist in the
     * local store.  It is possible that there are other children that
     * exist remotely.
     * 
     * The resulting managed objects will be added to the result
     * vector provided.
     * 
     * @param out a reference to a vector that will receive the child
     * objects.
     */
    void resolvePolicySpace(/* out */ std::vector<OF_SHARED_PTR<modelgbp::policy::Space> >& out)
    {
        opflex::modb::mointernal::MO::resolveChildren<modelgbp::policy::Space>(
            getFramework(), CLASS_ID, getURI(), 2154791136ul, 224, out);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the Universe object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the Universe object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of Universe.
     * This should not typically be called from user code.
     */
    Universe(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class Universe

} // namespace policy
} // namespace modelgbp
#endif // GI_POLICY_UNIVERSE_HPP
