/**
 * 
 * SOME COPYRIGHT
 * 
 * SrcMember.hpp
 * 
 * generated SrcMember.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_SPAN_SRCMEMBER_HPP
#define GI_SPAN_SRCMEMBER_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"
/*
 * contains: item:mclass(span/MemberToRefRSrc)
 */
#include "modelgbp/span/MemberToRefRSrc.hpp"

namespace modelgbp {
namespace span {

class SrcMember
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for SrcMember
     */
    static const opflex::modb::class_id_t CLASS_ID = 77;

    /**
     * Check whether dir has been set
     * @return true if dir has been set
     */
    bool isDirSet()
    {
        return getObjectInstance().isSet(2523138ul, opflex::modb::PropertyInfo::ENUM8);
    }

    /**
     * Get the value of dir if it has been set.
     * @return the value of dir or boost::none if not set
     */
    boost::optional<const uint8_t> getDir()
    {
        if (isDirSet())
            return (const uint8_t)getObjectInstance().getUInt64(2523138ul);
        return boost::none;
    }

    /**
     * Get the value of dir if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of dir if set, otherwise the value of default passed in
     */
    const uint8_t getDir(const uint8_t defaultValue)
    {
        return getDir().get_value_or(defaultValue);
    }

    /**
     * Set dir to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::span::SrcMember& setDir(const uint8_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(2523138ul, newValue);
        return *this;
    }

    /**
     * Unset dir in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::span::SrcMember& unsetDir()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(2523138ul, opflex::modb::PropertyInfo::ENUM8, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether name has been set
     * @return true if name has been set
     */
    bool isNameSet()
    {
        return getObjectInstance().isSet(2523137ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of name if it has been set.
     * @return the value of name or boost::none if not set
     */
    boost::optional<const std::string&> getName()
    {
        if (isNameSet())
            return getObjectInstance().getString(2523137ul);
        return boost::none;
    }

    /**
     * Get the value of name if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of name if set, otherwise the value of default passed in
     */
    const std::string& getName(const std::string& defaultValue)
    {
        return getName().get_value_or(defaultValue);
    }

    /**
     * Set name to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::span::SrcMember& setName(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(2523137ul, newValue);
        return *this;
    }

    /**
     * Unset name in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::span::SrcMember& unsetName()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(2523137ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of SrcMember from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::span::SrcMember> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::span::SrcMember>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of SrcMember from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::span::SrcMember> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::span::SrcMember>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of SrcMember from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PlatformConfig/[platformConfigName]/SpanSrcGrp/[spanSrcGrpName]/SpanSrcMember/[spanSrcMemberName]
     * 
     * @param framework the framework instance to use 
     * @param platformConfigName the value of platformConfigName,
     * a naming property for Config
     * @param spanSrcGrpName the value of spanSrcGrpName,
     * a naming property for SrcGrp
     * @param spanSrcMemberName the value of spanSrcMemberName,
     * a naming property for SrcMember
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::span::SrcMember> > resolveUnderPolicyUniversePlatformConfigSpanSrcGrp(
        opflex::ofcore::OFFramework& framework,
        const std::string& platformConfigName,
        const std::string& spanSrcGrpName,
        const std::string& spanSrcMemberName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PlatformConfig").addElement(platformConfigName).addElement("SpanSrcGrp").addElement(spanSrcGrpName).addElement("SpanSrcMember").addElement(spanSrcMemberName).build());
    }

    /**
     * Retrieve an instance of SrcMember from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PlatformConfig/[platformConfigName]/SpanSrcGrp/[spanSrcGrpName]/SpanSrcMember/[spanSrcMemberName]
     * 
     * @param platformConfigName the value of platformConfigName,
     * a naming property for Config
     * @param spanSrcGrpName the value of spanSrcGrpName,
     * a naming property for SrcGrp
     * @param spanSrcMemberName the value of spanSrcMemberName,
     * a naming property for SrcMember
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::span::SrcMember> > resolveUnderPolicyUniversePlatformConfigSpanSrcGrp(
        const std::string& platformConfigName,
        const std::string& spanSrcGrpName,
        const std::string& spanSrcMemberName)
    {
        return resolveUnderPolicyUniversePlatformConfigSpanSrcGrp(opflex::ofcore::OFFramework::defaultInstance(),platformConfigName,spanSrcGrpName,spanSrcMemberName);
    }

    /**
     * Retrieve an instance of SrcMember from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PlatformConfig/[platformConfigName]/SpanDstGrp/[spanDstGrpName]/SpanSrcMember/[spanSrcMemberName]
     * 
     * @param framework the framework instance to use 
     * @param platformConfigName the value of platformConfigName,
     * a naming property for Config
     * @param spanDstGrpName the value of spanDstGrpName,
     * a naming property for DstGrp
     * @param spanSrcMemberName the value of spanSrcMemberName,
     * a naming property for SrcMember
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::span::SrcMember> > resolveUnderPolicyUniversePlatformConfigSpanDstGrp(
        opflex::ofcore::OFFramework& framework,
        const std::string& platformConfigName,
        const std::string& spanDstGrpName,
        const std::string& spanSrcMemberName)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PlatformConfig").addElement(platformConfigName).addElement("SpanDstGrp").addElement(spanDstGrpName).addElement("SpanSrcMember").addElement(spanSrcMemberName).build());
    }

    /**
     * Retrieve an instance of SrcMember from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PlatformConfig/[platformConfigName]/SpanDstGrp/[spanDstGrpName]/SpanSrcMember/[spanSrcMemberName]
     * 
     * @param platformConfigName the value of platformConfigName,
     * a naming property for Config
     * @param spanDstGrpName the value of spanDstGrpName,
     * a naming property for DstGrp
     * @param spanSrcMemberName the value of spanSrcMemberName,
     * a naming property for SrcMember
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::span::SrcMember> > resolveUnderPolicyUniversePlatformConfigSpanDstGrp(
        const std::string& platformConfigName,
        const std::string& spanDstGrpName,
        const std::string& spanSrcMemberName)
    {
        return resolveUnderPolicyUniversePlatformConfigSpanDstGrp(opflex::ofcore::OFFramework::defaultInstance(),platformConfigName,spanDstGrpName,spanSrcMemberName);
    }

    /**
     * Retrieve the child object with the specified naming
     * properties. If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    boost::optional<OF_SHARED_PTR<modelgbp::span::MemberToRefRSrc> > resolveSpanMemberToRefRSrc(
        )
    {
        return modelgbp::span::MemberToRefRSrc::resolve(getFramework(), opflex::modb::URIBuilder(getURI()).addElement("SpanMemberToRefRSrc").build());
    }

    /**
     * Create a new child object with the specified naming properties
     * and make it a child of this object in the currently-active
     * mutator.  If the object already exists in the store, get a
     * mutable copy of that object.  If the object already exists in
     * the mutator, get a reference to the object.
     * 
     * @throws std::logic_error if no mutator is active
     * @return a shared pointer to the (possibly new) object
     */
    OF_SHARED_PTR<modelgbp::span::MemberToRefRSrc> addSpanMemberToRefRSrc(
        )
    {
        OF_SHARED_PTR<modelgbp::span::MemberToRefRSrc> result = addChild<modelgbp::span::MemberToRefRSrc>(
            CLASS_ID, getURI(), 2150006858ul, 74,
            opflex::modb::URIBuilder(getURI()).addElement("SpanMemberToRefRSrc").build()
            );
        return result;
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the SrcMember object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the SrcMember object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the SrcMember object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PlatformConfig/[platformConfigName]/SpanSrcGrp/[spanSrcGrpName]/SpanSrcMember/[spanSrcMemberName]
     * 
     * @param framework the framework instance to use
     * @param platformConfigName the value of platformConfigName,
     * a naming property for Config
     * @param spanSrcGrpName the value of spanSrcGrpName,
     * a naming property for SrcGrp
     * @param spanSrcMemberName the value of spanSrcMemberName,
     * a naming property for SrcMember
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderPolicyUniversePlatformConfigSpanSrcGrp(
        opflex::ofcore::OFFramework& framework,
        const std::string& platformConfigName,
        const std::string& spanSrcGrpName,
        const std::string& spanSrcMemberName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PlatformConfig").addElement(platformConfigName).addElement("SpanSrcGrp").addElement(spanSrcGrpName).addElement("SpanSrcMember").addElement(spanSrcMemberName).build());
    }

    /**
     * Remove the SrcMember object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PlatformConfig/[platformConfigName]/SpanSrcGrp/[spanSrcGrpName]/SpanSrcMember/[spanSrcMemberName]
     * 
     * @param platformConfigName the value of platformConfigName,
     * a naming property for Config
     * @param spanSrcGrpName the value of spanSrcGrpName,
     * a naming property for SrcGrp
     * @param spanSrcMemberName the value of spanSrcMemberName,
     * a naming property for SrcMember
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderPolicyUniversePlatformConfigSpanSrcGrp(
        const std::string& platformConfigName,
        const std::string& spanSrcGrpName,
        const std::string& spanSrcMemberName)
    {
        removeUnderPolicyUniversePlatformConfigSpanSrcGrp(opflex::ofcore::OFFramework::defaultInstance(),platformConfigName,spanSrcGrpName,spanSrcMemberName);
    }

    /**
     * Remove the SrcMember object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PlatformConfig/[platformConfigName]/SpanDstGrp/[spanDstGrpName]/SpanSrcMember/[spanSrcMemberName]
     * 
     * @param framework the framework instance to use
     * @param platformConfigName the value of platformConfigName,
     * a naming property for Config
     * @param spanDstGrpName the value of spanDstGrpName,
     * a naming property for DstGrp
     * @param spanSrcMemberName the value of spanSrcMemberName,
     * a naming property for SrcMember
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderPolicyUniversePlatformConfigSpanDstGrp(
        opflex::ofcore::OFFramework& framework,
        const std::string& platformConfigName,
        const std::string& spanDstGrpName,
        const std::string& spanSrcMemberName)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("PolicyUniverse").addElement("PlatformConfig").addElement(platformConfigName).addElement("SpanDstGrp").addElement(spanDstGrpName).addElement("SpanSrcMember").addElement(spanSrcMemberName).build());
    }

    /**
     * Remove the SrcMember object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /PolicyUniverse/PlatformConfig/[platformConfigName]/SpanDstGrp/[spanDstGrpName]/SpanSrcMember/[spanSrcMemberName]
     * 
     * @param platformConfigName the value of platformConfigName,
     * a naming property for Config
     * @param spanDstGrpName the value of spanDstGrpName,
     * a naming property for DstGrp
     * @param spanSrcMemberName the value of spanSrcMemberName,
     * a naming property for SrcMember
     * @throws std::logic_error if no mutator is active
     */
    static void removeUnderPolicyUniversePlatformConfigSpanDstGrp(
        const std::string& platformConfigName,
        const std::string& spanDstGrpName,
        const std::string& spanSrcMemberName)
    {
        removeUnderPolicyUniversePlatformConfigSpanDstGrp(opflex::ofcore::OFFramework::defaultInstance(),platformConfigName,spanDstGrpName,spanSrcMemberName);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of SrcMember.
     * This should not typically be called from user code.
     */
    SrcMember(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class SrcMember

} // namespace span
} // namespace modelgbp
#endif // GI_SPAN_SRCMEMBER_HPP
